=== modified file 'drizzled/definitions.h'
--- drizzled/definitions.h	2009-11-26 02:37:40 +0000
+++ drizzled/definitions.h	2009-11-28 22:02:19 +0000
@@ -512,10 +512,6 @@
 #define MY_I_S_UNSIGNED   2
 
 
-#define SKIP_OPEN_TABLE 0                // do not open table
-#define OPEN_FRM_ONLY   1                // open FRM file only
-#define OPEN_FULL_TABLE 2                // open FRM,MYD, MYI files
-
 /*
    "Declared Type Collation"
    A combination of collation and its derivation.

=== modified file 'drizzled/enum.h'
--- drizzled/enum.h	2009-11-26 02:37:40 +0000
+++ drizzled/enum.h	2009-11-28 22:02:19 +0000
@@ -211,14 +211,6 @@
   IGNORE_EXCEPT_NON_UNIQUE
 };
 
-enum enum_schema_table_state
-{
-  NOT_PROCESSED= 0,
-  PROCESSED_BY_CREATE_SORT_INDEX,
-  PROCESSED_BY_JOIN_EXEC
-};
-
-
 enum tmp_table_type
 {
   NO_TMP_TABLE, 

=== modified file 'drizzled/field_iterator.cc'
--- drizzled/field_iterator.cc	2009-04-28 21:46:57 +0000
+++ drizzled/field_iterator.cc	2009-11-26 04:33:51 +0000
@@ -138,13 +138,9 @@
 
   /*
     Test that TableList::db is the same as TableShare::db to
-    ensure consistency. An exception are I_S schema tables, which
-    are inconsistent in this respect.
+    ensure consistency. 
   */
-  assert(!strcmp(table_ref->db, table_ref->table->s->db.str) ||
-              (table_ref->schema_table &&
-               table_ref->table->s->db.str[0] == 0));
-
+  assert(!strcmp(table_ref->db, table_ref->table->s->db.str));
   return table_ref->db;
 }
 

=== modified file 'drizzled/join.cc'
--- drizzled/join.cc	2009-11-19 18:58:35 +0000
+++ drizzled/join.cc	2009-11-26 04:33:51 +0000
@@ -1245,9 +1245,6 @@
     return;
   }
 
-  if ((this->select_lex->options & OPTION_SCHEMA_TABLE) && get_schema_tables_result(this, PROCESSED_BY_JOIN_EXEC))
-    return;
-
   if (select_options & SELECT_DESCRIBE)
   {
     /*
@@ -5584,8 +5581,6 @@
 
     s->dependent= tables->dep_tables;
     s->key_dependent= 0;
-    if (tables->schema_table)
-      table->cursor->stats.records= 2;
     table->quick_condition_rows= table->cursor->stats.records;
 
     s->on_expr_ref= &tables->on_expr;

=== modified file 'drizzled/natural_join_column.cc'
--- drizzled/natural_join_column.cc	2009-08-27 15:40:07 +0000
+++ drizzled/natural_join_column.cc	2009-11-26 04:33:51 +0000
@@ -61,12 +61,9 @@
 {
   /*
     Test that TableList::db is the same as TableShare::db to
-    ensure consistency. An exception are I_S schema tables, which
-    are inconsistent in this respect.
+    ensure consistency. 
   */
   assert(!strcmp(table_ref->db,
-                      table_ref->table->s->db.str) ||
-              (table_ref->schema_table &&
-               table_ref->table->s->db.str[0] == 0));
+                      table_ref->table->s->db.str));
   return table_ref->db;
 }

=== modified file 'drizzled/opt_sum.cc'
--- drizzled/opt_sum.cc	2009-11-16 17:06:48 +0000
+++ drizzled/opt_sum.cc	2009-11-26 04:33:51 +0000
@@ -162,10 +162,9 @@
       Schema tables are filled after this function is invoked, so we can't
       get row count
     */
-    if (!(tl->table->cursor->ha_table_flags() & HA_STATS_RECORDS_IS_EXACT) ||
-        tl->schema_table)
+    if (!(tl->table->cursor->ha_table_flags() & HA_STATS_RECORDS_IS_EXACT))
     {
-      maybe_exact_count&= test(!tl->schema_table &&
+      maybe_exact_count&= test(
                                (tl->table->cursor->ha_table_flags() &
                                 HA_HAS_RECORDS));
       is_exact_count= false;

=== modified file 'drizzled/plugin/info_schema_table.h'
--- drizzled/plugin/info_schema_table.h	2009-11-04 16:33:52 +0000
+++ drizzled/plugin/info_schema_table.h	2009-11-30 17:23:08 +0000
@@ -21,6 +21,8 @@
 #ifndef DRIZZLED_PLUGIN_INFO_SCHEMA_TABLE_H
 #define DRIZZLED_PLUGIN_INFO_SCHEMA_TABLE_H
 
+#include "drizzled/hash/crc32.h"
+
 #include <string>
 #include <set>
 #include <algorithm>
@@ -53,16 +55,14 @@
              enum enum_field_types in_type,
              int32_t in_value,
              uint32_t in_flags,
-             const std::string& in_old_name,
-             uint32_t in_open_method)
+             const std::string& in_old_name)
     :
       name(in_name),
       length(in_length),
       type(in_type),
       value(in_value),
       flags(in_flags),
-      old_name(in_old_name),
-      open_method(in_open_method)
+      old_name(in_old_name)
   {}
 
   ColumnInfo()
@@ -71,8 +71,7 @@
       length(0),
       type(DRIZZLE_TYPE_VARCHAR),
       flags(0),
-      old_name(),
-      open_method(SKIP_OPEN_TABLE)
+      old_name()
   {}
 
   /**
@@ -99,14 +98,6 @@
   }
 
   /**
-   * @return the open method for this column.
-   */
-  uint32_t getOpenMethod() const
-  {
-    return open_method;
-  }
-
-  /**
    * @return the flags for this column.
    */
   uint32_t getFlags() const
@@ -176,12 +167,6 @@
    */
   const std::string old_name;
 
-  /**
-   * This should be one of @c SKIP_OPEN_TABLE,
-   * @c OPEN_FRM_ONLY or @c OPEN_FULL_TABLE.
-   */
-  uint32_t open_method;
-
 };
 
 /**
@@ -194,13 +179,13 @@
 public:
   virtual ~InfoSchemaMethods() {}
 
-  virtual Table *createSchemaTable(Session *session,
-                                   TableList *table_list) const;
   virtual int fillTable(Session *session, 
-                        TableList *tables);
-  virtual int processTable(Session *session, TableList *tables,
+                        Table *table,
+                        InfoSchemaTable *schema_table);
+  virtual int processTable(InfoSchemaTable *store_table, 
+                           Session *session, TableList *tables,
                            Table *table, bool res, LEX_STRING *db_name,
-                           LEX_STRING *table_name) const;
+                           LEX_STRING *table_name);
   virtual int oldFormat(Session *session, 
                         InfoSchemaTable *schema_table) const;
 };
@@ -215,15 +200,21 @@
   InfoSchemaRecord()
     :
       record(NULL),
-      rec_len(0)
+      rec_len(0),
+      checksum(0)
   {}
 
   InfoSchemaRecord(unsigned char *buf,
                    size_t in_len)
     :
-      record(buf),
-      rec_len(in_len)
-  {}
+      record(NULL),
+      rec_len(in_len),
+      checksum(0)
+  {
+    record= new unsigned char[rec_len];
+    memcpy(record, buf, rec_len);
+    checksum= drizzled::hash::crc32((const char *) record, rec_len);
+  }
 
   InfoSchemaRecord(const InfoSchemaRecord &rhs)
     :
@@ -232,6 +223,7 @@
   {
     record= new(std::nothrow) unsigned char[rec_len];
     memcpy(record, rhs.record, rec_len);
+    checksum= drizzled::hash::crc32((const char *) record, rec_len);
   }
 
   ~InfoSchemaRecord()
@@ -242,17 +234,49 @@
     }
   }
 
+  /**
+   * Copy this record into the memory passed to this function.
+   *
+   * @param[out] buf copy the record into this memory
+   */
   void copyRecordInto(unsigned char *buf)
   {
     memcpy(buf, record, rec_len);
   }
 
+  /**
+   * @return the length of this record
+   */
+  size_t getRecordLength() const
+  {
+    return rec_len;
+  }
+
+  /**
+   * @return the checksum of the data in this record
+   */
+  uint32_t getChecksum() const
+  {
+    return checksum;
+  }
+
+  /**
+   * @param[in] crc a checksum to compare
+   * @return true if the input checksum matches the checksum for this record; false otherwise
+   */
+  bool checksumMatches(uint32_t crc) const
+  {
+    return (checksum == crc);
+  }
+
 private:
 
   unsigned char *record;
 
   size_t rec_len;
 
+  uint32_t checksum;
+
 };
 
 class DeleteRows
@@ -265,6 +289,21 @@
   }
 };
 
+class FindRowByChecksum
+{
+  uint32_t cs;
+public:
+  FindRowByChecksum(uint32_t in_cs)
+    :
+      cs(in_cs)
+  {}
+
+  inline bool operator()(const InfoSchemaRecord *rec) const
+  {
+    return (cs == rec->getChecksum());
+  }
+};
+
 /**
  * @class InfoSchemaTable
  * @brief 
@@ -331,30 +370,14 @@
   }
 
   /**
-   * Create the temporary I_S tables using schema_table data.
-   *
-   * @param[in] session a session handler
-   * @param[in] table_list Used to pass I_S table information (fields,
-   *                       tables, parameters, etc.) and table name
-   * @retval \# pointer to created table
-   * @retval NULL Can't create table
-   */
-  Table *createSchemaTable(Session *session, TableList *table_list) const
-  {
-    Table *retval= i_s_methods->createSchemaTable(session, table_list);
-    return retval;
-  }
-
-  /**
    * Fill I_S table.
    *
    * @param[in] session a session handler
-   * @param[in] tables I_S table
    * @return 0 on success; 1 on error
    */
-  int fillTable(Session *session, TableList *tables)
+  int fillTable(Session *session, Table *table)
   {
-    int retval= i_s_methods->fillTable(session, tables);
+    int retval= i_s_methods->fillTable(session, table, this);
     return retval;
   }
 
@@ -371,9 +394,9 @@
    * @return 0 on success; 1 on error
    */
   int processTable(Session *session, TableList *tables, Table *table,
-                   bool res, LEX_STRING *db_name, LEX_STRING *tab_name) const
+                   bool res, LEX_STRING *db_name, LEX_STRING *tab_name)
   {
-    int retval= i_s_methods->processTable(session, tables, table,
+    int retval= i_s_methods->processTable(this, session, tables, table,
                                           res, db_name, tab_name);
     return retval;
   }
@@ -483,11 +506,17 @@
     return column_info;
   }
 
+  /**
+   * @return the rows for this I_S table.
+   */
   Rows &getRows()
   {
     return rows;
   }
 
+  /**
+   * Clear the rows for this table and de-allocate all memory for this rows.
+   */
   void clearRows()
   {
     std::for_each(rows.begin(),
@@ -496,10 +525,26 @@
     rows.clear();
   }
 
+  /**
+   * Add a row to the std::vector of rows for this I_S table. For the moment, we check to make sure
+   * that we do not add any duplicate rows. This is done in a niave manner for the moment by
+   * checking the crc of the raw data for each row. We will not add this row to the std::vector of
+   * rows for this I_S table is a duplicate row already exists in the std::vector.
+   *
+   * @param[in] buf raw data for the record to add
+   * @param[in] len size of the raw data for the record to add
+   */
   void addRow(unsigned char *buf, size_t len)
   {
-    InfoSchemaRecord *record= new InfoSchemaRecord(buf, len);
-    rows.push_back(record);
+    uint32_t cs= drizzled::hash::crc32((const char *) buf, len);
+    Rows::iterator it= std::find_if(rows.begin(),
+                                    rows.end(),
+                                    FindRowByChecksum(cs));
+    if (it == rows.end())
+    {
+      InfoSchemaRecord *record= new InfoSchemaRecord(buf, len);
+      rows.push_back(record);
+    }
   }
 
   /**
@@ -511,15 +556,6 @@
     return column_info[index]->getName();
   }
 
-  /**
-   * @param[in] index the index of this column
-   * @return the open method for the column at the given index
-   */
-  uint32_t getColumnOpenMethod(int index) const
-  {
-    return column_info[index]->getOpenMethod();
-  }
-
 private:
 
   /**
@@ -556,6 +592,9 @@
    */
   Columns column_info;
 
+  /**
+   * The rows for this I_S table.
+   */
   Rows rows;
 
   /**

=== modified file 'drizzled/show.cc'
--- drizzled/show.cc	2009-11-19 03:54:45 +0000
+++ drizzled/show.cc	2009-11-26 04:33:51 +0000
@@ -226,10 +226,7 @@
   if (session->client->sendFields(&field_list))
     return true;
   {
-    if (table_list->schema_table)
-      session->client->store(table_list->schema_table->getTableName().c_str());
-    else
-      session->client->store(table_list->table->alias);
+    session->client->store(table_list->table->alias);
   }
 
   session->client->store(buffer.ptr(), buffer.length());
@@ -453,10 +450,7 @@
     packet->append(STRING_WITH_LEN("CREATE TABLE "));
   if (is_if_not_exists)
     packet->append(STRING_WITH_LEN("IF NOT EXISTS "));
-  if (table_list->schema_table)
-    alias= table_list->schema_table->getTableName().c_str();
-  else
-    alias= share->table_name.str;
+  alias= share->table_name.str;
 
   packet->append_identifier(alias, strlen(alias));
   packet->append(STRING_WITH_LEN(" (\n"));
@@ -1009,34 +1003,6 @@
   return;
 }
 
-/*
-  Store record to I_S table, convert HEAP table
-  to MyISAM if necessary
-
-  SYNOPSIS
-    schema_table_store_record()
-    session                   thread Cursor
-    table                 Information schema table to be updated
-
-  RETURN
-    0	                  success
-    1	                  error
-*/
-
-bool schema_table_store_record(Session *session, Table *table)
-{
-  int error;
-  if ((error= table->cursor->ha_write_row(table->record[0])))
-  {
-    Tmp_Table_Param *param= table->pos_in_table_list->schema_table_param;
-
-    if (create_myisam_from_heap(session, table, param->start_recinfo,
-                                &param->recinfo, error, 0))
-      return true;
-  }
-  return false;
-}
-
 
 static int make_table_list(Session *session, Select_Lex *sel,
                            LEX_STRING *db_name, LEX_STRING *table_name)
@@ -1070,9 +1036,9 @@
 
 static bool get_lookup_value(Session *session, Item_func *item_func,
                              TableList *table,
-                             LOOKUP_FIELD_VALUES *lookup_field_vals)
+                             LOOKUP_FIELD_VALUES *lookup_field_vals,
+                             plugin::InfoSchemaTable *schema_table)
 {
-  plugin::InfoSchemaTable *schema_table= table->schema_table;
   const char *field_name1= schema_table->getFirstColumnIndex() >= 0 ?
     schema_table->getColumnName(schema_table->getFirstColumnIndex()).c_str() : "";
   const char *field_name2= schema_table->getSecondColumnIndex() >= 0 ?
@@ -1151,7 +1117,8 @@
 */
 
 bool calc_lookup_values_from_cond(Session *session, COND *cond, TableList *table,
-                                  LOOKUP_FIELD_VALUES *lookup_field_vals)
+                                  LOOKUP_FIELD_VALUES *lookup_field_vals,
+                                  plugin::InfoSchemaTable *schema_table)
 {
   if (!cond)
     return 0;
@@ -1166,12 +1133,12 @@
       {
         if (item->type() == Item::FUNC_ITEM)
         {
-          if (get_lookup_value(session, (Item_func*)item, table, lookup_field_vals))
+          if (get_lookup_value(session, (Item_func*)item, table, lookup_field_vals, schema_table))
             return 1;
         }
         else
         {
-          if (calc_lookup_values_from_cond(session, item, table, lookup_field_vals))
+          if (calc_lookup_values_from_cond(session, item, table, lookup_field_vals, schema_table))
             return 1;
         }
       }
@@ -1179,20 +1146,20 @@
     return 0;
   }
   else if (cond->type() == Item::FUNC_ITEM &&
-           get_lookup_value(session, (Item_func*) cond, table, lookup_field_vals))
+           get_lookup_value(session, (Item_func*) cond, table, lookup_field_vals, schema_table))
     return 1;
   return 0;
 }
 
 
-static bool uses_only_table_name_fields(Item *item, TableList *table)
+static bool uses_only_table_name_fields(Item *item, Table *table, plugin::InfoSchemaTable *schema_table)
 {
   if (item->type() == Item::FUNC_ITEM)
   {
     Item_func *item_func= (Item_func*)item;
     for (uint32_t i=0; i<item_func->argument_count(); i++)
     {
-      if (!uses_only_table_name_fields(item_func->arguments()[i], table))
+      if (! uses_only_table_name_fields(item_func->arguments()[i], table, schema_table))
         return 0;
     }
   }
@@ -1200,12 +1167,11 @@
   {
     Item_field *item_field= (Item_field*)item;
     const CHARSET_INFO * const cs= system_charset_info;
-    plugin::InfoSchemaTable *schema_table= table->schema_table;
     const char *field_name1= schema_table->getFirstColumnIndex() >= 0 ?
       schema_table->getColumnName(schema_table->getFirstColumnIndex()).c_str() : "";
     const char *field_name2= schema_table->getSecondColumnIndex() >= 0 ?
       schema_table->getColumnName(schema_table->getSecondColumnIndex()).c_str() : "";
-    if (table->table != item_field->field->table ||
+    if (table != item_field->field->table ||
         (cs->coll->strnncollsp(cs, (unsigned char *) field_name1, strlen(field_name1),
                                (unsigned char *) item_field->field_name,
                                strlen(item_field->field_name), 0) &&
@@ -1215,7 +1181,7 @@
       return 0;
   }
   else if (item->type() == Item::REF_ITEM)
-    return uses_only_table_name_fields(item->real_item(), table);
+    return uses_only_table_name_fields(item->real_item(), table, schema_table);
 
   if (item->type() == Item::SUBSELECT_ITEM && !item->const_item())
     return 0;
@@ -1224,7 +1190,7 @@
 }
 
 
-static COND * make_cond_for_info_schema(COND *cond, TableList *table)
+static COND * make_cond_for_info_schema(COND *cond, Table *table, plugin::InfoSchemaTable *schema_table)
 {
   if (!cond)
     return (COND*) 0;
@@ -1235,38 +1201,38 @@
       /* Create new top level AND item */
       Item_cond_and *new_cond=new Item_cond_and;
       if (!new_cond)
-	return (COND*) 0;
+        return (COND*) 0;
       List_iterator<Item> li(*((Item_cond*) cond)->argument_list());
       Item *item;
       while ((item=li++))
       {
-	Item *fix= make_cond_for_info_schema(item, table);
-	if (fix)
-	  new_cond->argument_list()->push_back(fix);
+        Item *fix= make_cond_for_info_schema(item, table, schema_table);
+        if (fix)
+          new_cond->argument_list()->push_back(fix);
       }
       switch (new_cond->argument_list()->elements) {
-      case 0:
-	return (COND*) 0;
-      case 1:
-	return new_cond->argument_list()->head();
-      default:
-	new_cond->quick_fix_field();
-	return new_cond;
+        case 0:
+          return (COND*) 0;
+        case 1:
+          return new_cond->argument_list()->head();
+        default:
+          new_cond->quick_fix_field();
+          return new_cond;
       }
     }
     else
     {						// Or list
       Item_cond_or *new_cond=new Item_cond_or;
       if (!new_cond)
-	return (COND*) 0;
+        return (COND*) 0;
       List_iterator<Item> li(*((Item_cond*) cond)->argument_list());
       Item *item;
       while ((item=li++))
       {
-	Item *fix=make_cond_for_info_schema(item, table);
-	if (!fix)
-	  return (COND*) 0;
-	new_cond->argument_list()->push_back(fix);
+        Item *fix=make_cond_for_info_schema(item, table, schema_table);
+        if (!fix)
+          return (COND*) 0;
+        new_cond->argument_list()->push_back(fix);
       }
       new_cond->quick_fix_field();
       new_cond->top_level_item();
@@ -1274,7 +1240,7 @@
     }
   }
 
-  if (!uses_only_table_name_fields(cond, table))
+  if (! uses_only_table_name_fields(cond, table, schema_table))
     return (COND*) 0;
   return cond;
 }
@@ -1299,7 +1265,8 @@
 */
 
 bool get_lookup_field_values(Session *session, COND *cond, TableList *tables,
-                             LOOKUP_FIELD_VALUES *lookup_field_values)
+                             LOOKUP_FIELD_VALUES *lookup_field_values,
+                             plugin::InfoSchemaTable *schema_table)
 {
   LEX *lex= session->lex;
   const char *wild= lex->wild ? lex->wild->ptr() : NULL;
@@ -1329,7 +1296,7 @@
       The "default" is for queries over I_S.
       All previous cases handle SHOW commands.
     */
-    return calc_lookup_values_from_cond(session, cond, tables, lookup_field_values);
+    return calc_lookup_values_from_cond(session, cond, tables, lookup_field_values, schema_table);
   }
 }
 
@@ -1599,7 +1566,8 @@
 
 static int fill_schema_table_names(Session *session, Table *table,
                                    LEX_STRING *db_name, LEX_STRING *table_name,
-                                   bool with_i_schema)
+                                   bool with_i_schema,
+                                   plugin::InfoSchemaTable *schema_table)
 {
   if (with_i_schema)
   {
@@ -1621,114 +1589,12 @@
       return 0;
     }
   }
-  if (schema_table_store_record(session, table))
-    return 1;
+  schema_table->addRow(table->record[0], table->s->reclength);
   return 0;
 }
 
 
 /**
-  @brief          Get open table method
-
-  @details        The function calculates the method which will be used
-                  for table opening:
-                  SKIP_OPEN_TABLE - do not open table
-                  OPEN_FRM_ONLY   - open FRM cursor only
-                  OPEN_FULL_TABLE - open FRM, data, index files
-  @param[in]      tables               I_S table table_list
-  @param[in]      schema_table         I_S table struct
-
-  @return         return a set of flags
-    @retval       SKIP_OPEN_TABLE | OPEN_FRM_ONLY | OPEN_FULL_TABLE
-*/
-
-static uint32_t get_table_open_method(TableList *tables,
-                                      plugin::InfoSchemaTable *schema_table)
-{
-  /*
-    determine which method will be used for table opening
-  */
-  if (schema_table->getRequestedObject() & OPTIMIZE_I_S_TABLE)
-  {
-    Field **ptr, *field;
-    int table_open_method= 0, field_indx= 0;
-    for (ptr= tables->table->field; (field= *ptr) ; ptr++)
-    {
-      if (field->isReadSet())
-        table_open_method|= schema_table->getColumnOpenMethod(field_indx);
-      field_indx++;
-    }
-    return table_open_method;
-  }
-  /* I_S tables which use get_all_tables but can not be optimized */
-  return (uint32_t) OPEN_FULL_TABLE;
-}
-
-
-/**
-  @brief          Fill I_S table with data from FRM cursor only
-
-  @param[in]      session                      thread Cursor
-  @param[in]      table                    Table struct for I_S table
-  @param[in]      schema_table             I_S table struct
-  @param[in]      db_name                  database name
-  @param[in]      table_name               table name
-
-  @return         Operation status
-    @retval       0           Table is processed and we can continue
-                              with new table
-    @retval       1           It's view and we have to use
-                              open_tables function for this table
-*/
-
-static int fill_schema_table_from_frm(Session *session,TableList *tables,
-                                      plugin::InfoSchemaTable *schema_table,
-                                      LEX_STRING *db_name,
-                                      LEX_STRING *table_name)
-{
-  Table *table= tables->table;
-  TableShare *share;
-  Table tbl;
-  TableList table_list;
-  uint32_t res= 0;
-  int error;
-  char key[MAX_DBKEY_LENGTH];
-  uint32_t key_length;
-
-  memset(&tbl, 0, sizeof(Table));
-
-  table_list.table_name= table_name->str;
-  table_list.db= db_name->str;
-
-  key_length= table_list.create_table_def_key(key);
-  pthread_mutex_lock(&LOCK_open); /* Locking to get table share when filling schema table from FRM */
-  share= TableShare::getShare(session, &table_list, key, key_length, 0, &error);
-  if (!share)
-  {
-    res= 0;
-    goto err;
-  }
-
-  {
-    tbl.s= share;
-    table_list.table= &tbl;
-    res= schema_table->processTable(session, &table_list, table,
-                                    res, db_name, table_name);
-  }
-  /* For the moment we just set everything to read */
-  table->setReadSet();
-
-  TableShare::release(share);
-
-err:
-  pthread_mutex_unlock(&LOCK_open);
-  session->clear_error();
-  return res;
-}
-
-
-
-/**
   @brief          Fill I_S tables whose data are retrieved
                   from frm files and storage engine
 
@@ -1745,14 +1611,14 @@
     @retval       0                        success
     @retval       1                        error
 */
-int plugin::InfoSchemaMethods::fillTable(Session *session, TableList *tables)
+int plugin::InfoSchemaMethods::fillTable(Session *session, 
+                                         Table *table,
+                                         plugin::InfoSchemaTable *schema_table)
 {
   LEX *lex= session->lex;
-  Table *table= tables->table;
   Select_Lex *old_all_select_lex= lex->all_selects_list;
   enum_sql_command save_sql_command= lex->sql_command;
-  Select_Lex *lsel= tables->schema_select_lex;
-  plugin::InfoSchemaTable *schema_table= tables->schema_table;
+  Select_Lex *lsel= table->pos_in_table_list->schema_select_lex;
   Select_Lex sel;
   LOOKUP_FIELD_VALUES lookup_field_vals;
   bool with_i_schema;
@@ -1764,7 +1630,6 @@
   int error= 1;
   Open_tables_state open_tables_state_backup;
   Query_tables_list query_tables_list_backup;
-  uint32_t table_open_method;
   bool old_value= session->no_warnings_for_error;
 
   /*
@@ -1774,8 +1639,6 @@
   */
   session->reset_n_backup_open_tables_state(&open_tables_state_backup);
 
-  tables->table_open_method= table_open_method=
-    get_table_open_method(tables, schema_table);
   /*
     this branch processes SHOW FIELDS, SHOW INDEXES commands.
     see sql_parse.cc, prepare_schema_table() function where
@@ -1783,12 +1646,16 @@
   */
   if (lsel && lsel->table_list.first)
   {
-    error= fill_schema_show_cols_or_idxs(session, tables, schema_table,
+    error= fill_schema_show_cols_or_idxs(session, table->pos_in_table_list, schema_table,
                                          &open_tables_state_backup);
     goto err;
   }
 
-  if (get_lookup_field_values(session, cond, tables, &lookup_field_vals))
+  if (get_lookup_field_values(session, 
+                              cond, 
+                              table->pos_in_table_list, 
+                              &lookup_field_vals,
+                              schema_table))
   {
     error= 0;
     goto err;
@@ -1810,16 +1677,17 @@
 
   if (lookup_field_vals.db_value.length &&
       !lookup_field_vals.wild_db_value)
-    tables->has_db_lookup_value= true;
+    table->pos_in_table_list->has_db_lookup_value= true;
 
   if (lookup_field_vals.table_value.length &&
       !lookup_field_vals.wild_table_value)
-    tables->has_table_lookup_value= true;
+    table->pos_in_table_list->has_table_lookup_value= true;
 
-  if (tables->has_db_lookup_value && tables->has_table_lookup_value)
+  if (table->pos_in_table_list->has_db_lookup_value && 
+      table->pos_in_table_list->has_table_lookup_value)
     partial_cond= 0;
   else
-    partial_cond= make_cond_for_info_schema(cond, tables);
+    partial_cond= make_cond_for_info_schema(cond, table, schema_table);
 
   if (lex->describe)
   {
@@ -1857,39 +1725,19 @@
 
       if (!partial_cond || partial_cond->val_int())
       {
-        /*
-          If table is I_S.tables and open_table_method is 0 (eg SKIP_OPEN)
-          we can skip table opening and we don't have lookup value for
-          table name or lookup value is wild string(table name list is
-          already created by make_table_name_list() function).
-        */
-        if (! table_open_method &&
-            schema_table->getTableName().compare("TABLES") == 0 &&
-            (! lookup_field_vals.table_value.length ||
-             lookup_field_vals.wild_table_value))
-        {
-          if (schema_table_store_record(session, table))
-            goto err;      /* Out of space in temporary table */
-          continue;
-        }
-
         /* SHOW Table NAMES command */
         if (schema_table->getTableName().compare("TABLE_NAMES") == 0)
         {
-          if (fill_schema_table_names(session, tables->table, *db_name,
-                                      *table_name, with_i_schema))
+          if (fill_schema_table_names(session, 
+                                      table, 
+                                      *db_name,
+                                      *table_name, 
+                                      with_i_schema,
+                                      schema_table))
             continue;
         }
         else
         {
-          if (!(table_open_method & ~OPEN_FRM_ONLY) &&
-              !with_i_schema)
-          {
-            if (!fill_schema_table_from_frm(session, tables, schema_table, *db_name,
-                                            *table_name))
-              continue;
-          }
-
           LEX_STRING tmp_lex_string, orig_db_name;
           /*
             Set the parent lex of 'sel' because it is needed by
@@ -1898,9 +1746,13 @@
           session->no_warnings_for_error= 1;
           sel.parent_lex= lex;
           /* db_name can be changed in make_table_list() func */
-          if (!session->make_lex_string(&orig_db_name, (*db_name)->str,
-                                        (*db_name)->length, false))
+          if (! session->make_lex_string(&orig_db_name, 
+                                         (*db_name)->str,
+                                         (*db_name)->length, 
+                                         false))
+          {
             goto err;
+          }
 
           if (make_table_list(session, &sel, *db_name, *table_name))
             goto err;
@@ -2073,10 +1925,13 @@
 }
 
 
-int plugin::InfoSchemaMethods::processTable(Session *session, TableList *tables,
+int plugin::InfoSchemaMethods::processTable(
+            plugin::InfoSchemaTable *store_table,
+            Session *session, 
+            TableList *tables,
 				    Table *table, bool res,
 				    LEX_STRING *db_name,
-				    LEX_STRING *table_name) const
+				    LEX_STRING *table_name)
 {
   LEX *lex= session->lex;
   const char *wild= lex->wild ? lex->wild->ptr() : NULL;
@@ -2107,16 +1962,8 @@
   show_table_share= show_table->s;
   count= 0;
 
-  if (tables->schema_table)
-  {
-    ptr= show_table->field;
-    timestamp_field= show_table->timestamp_field;
-  }
-  else
-  {
-    ptr= show_table_share->field;
-    timestamp_field= show_table_share->timestamp_field;
-  }
+  ptr= show_table_share->field;
+  timestamp_field= show_table_share->timestamp_field;
 
   /* For the moment we just set everything to read */
   if (!show_table->read_set)
@@ -2187,112 +2034,12 @@
       table->field[20]->store((const char*) pos,
                               strlen((const char*) pos), cs);
     }
-    if (schema_table_store_record(session, table))
-      return(1);
+    store_table->addRow(table->record[0], table->s->reclength);
   }
   return(0);
 }
 
 
-Table *plugin::InfoSchemaMethods::createSchemaTable(Session *session, TableList *table_list)
-  const
-{
-  int field_count= 0;
-  Item *item;
-  Table *table;
-  List<Item> field_list;
-  const CHARSET_INFO * const cs= system_charset_info;
-  const plugin::InfoSchemaTable::Columns &columns= table_list->schema_table->getColumns();
-  plugin::InfoSchemaTable::Columns::const_iterator iter= columns.begin();
-
-  while (iter != columns.end())
-  {
-    const plugin::ColumnInfo *column= *iter;
-    switch (column->getType()) {
-    case DRIZZLE_TYPE_LONG:
-    case DRIZZLE_TYPE_LONGLONG:
-      if (!(item= new Item_return_int(column->getName().c_str(),
-                                      column->getLength(),
-                                      column->getType(),
-                                      column->getValue())))
-      {
-        return(0);
-      }
-      item->unsigned_flag= (column->getFlags() & MY_I_S_UNSIGNED);
-      break;
-    case DRIZZLE_TYPE_DATE:
-    case DRIZZLE_TYPE_TIMESTAMP:
-    case DRIZZLE_TYPE_DATETIME:
-      if (!(item=new Item_return_date_time(column->getName().c_str(),
-                                           column->getType())))
-      {
-        return(0);
-      }
-      break;
-    case DRIZZLE_TYPE_DOUBLE:
-      if ((item= new Item_float(column->getName().c_str(), 0.0, NOT_FIXED_DEC,
-                           column->getLength())) == NULL)
-        return NULL;
-      break;
-    case DRIZZLE_TYPE_DECIMAL:
-      if (!(item= new Item_decimal((int64_t) column->getValue(), false)))
-      {
-        return(0);
-      }
-      item->unsigned_flag= (column->getFlags() & MY_I_S_UNSIGNED);
-      item->decimals= column->getLength() % 10;
-      item->max_length= (column->getLength()/100)%100;
-      if (item->unsigned_flag == 0)
-        item->max_length+= 1;
-      if (item->decimals > 0)
-        item->max_length+= 1;
-      item->set_name(column->getName().c_str(),
-                     column->getName().length(), cs);
-      break;
-    case DRIZZLE_TYPE_BLOB:
-      if (!(item= new Item_blob(column->getName().c_str(),
-                                column->getLength())))
-      {
-        return(0);
-      }
-      break;
-    default:
-      if (!(item= new Item_empty_string("", column->getLength(), cs)))
-      {
-        return(0);
-      }
-      item->set_name(column->getName().c_str(),
-                     column->getName().length(), cs);
-      break;
-    }
-    field_list.push_back(item);
-    item->maybe_null= (column->getFlags() & MY_I_S_MAYBE_NULL);
-    field_count++;
-    ++iter;
-  }
-  Tmp_Table_Param *tmp_table_param =
-    (Tmp_Table_Param*) (session->alloc(sizeof(Tmp_Table_Param)));
-  tmp_table_param->init();
-  tmp_table_param->table_charset= cs;
-  tmp_table_param->field_count= field_count;
-  tmp_table_param->schema_table= 1;
-  Select_Lex *select_lex= session->lex->current_select;
-  if (!(table= create_tmp_table(session, tmp_table_param,
-                                field_list, (order_st*) 0, 0, 0,
-                                (select_lex->options | session->options |
-                                 TMP_TABLE_ALL_COLUMNS),
-                                HA_POS_ERROR, table_list->alias)))
-    return(0);
-  my_bitmap_map* bitmaps=
-    (my_bitmap_map*) session->alloc(bitmap_buffer_size(field_count));
-  table->def_read_set.init((my_bitmap_map*) bitmaps, field_count);
-  table->read_set= &table->def_read_set;
-  table->read_set->clearAll();
-  table_list->schema_table_param= tmp_table_param;
-  return(table);
-}
-
-
 /*
   For old SHOW compatibility. It is used when
   old SHOW doesn't have generated column names
@@ -2339,47 +2086,6 @@
 
 
 /*
-  Create information_schema table
-
-  SYNOPSIS
-  mysql_schema_table()
-    session                thread Cursor
-    lex                pointer to LEX
-    table_list         pointer to table_list
-
-  RETURN
-    true on error
-*/
-
-bool mysql_schema_table(Session *session, LEX *, TableList *table_list)
-{
-  Table *table;
-  if (!(table= table_list->schema_table->createSchemaTable(session, table_list)))
-    return true;
-  table->s->tmp_table= SYSTEM_TMP_TABLE;
-  /*
-    This test is necessary to make
-    case insensitive cursor systems +
-    upper case table names(information schema tables) +
-    views
-    working correctly
-  */
-  if (table_list->schema_table_name)
-    table->alias_name_used= my_strcasecmp(table_alias_charset,
-                                          table_list->schema_table_name,
-                                          table_list->alias);
-  table_list->table_name= table->s->table_name.str;
-  table_list->table_name_length= table->s->table_name.length;
-  table_list->table= table;
-  table->next= session->derived_tables;
-  session->derived_tables= table;
-  table_list->select_lex->options |= OPTION_SCHEMA_TABLE;
-
-  return false;
-}
-
-
-/*
   Generate select from information_schema table
 
   SYNOPSIS
@@ -2413,90 +2119,3 @@
   return false;
 }
 
-
-/*
-  Fill temporary schema tables before SELECT
-
-  SYNOPSIS
-    get_schema_tables_result()
-    join  join which use schema tables
-    executed_place place where I_S table processed
-
-  RETURN
-    false success
-    true  error
-*/
-
-bool get_schema_tables_result(JOIN *join,
-                              enum enum_schema_table_state executed_place)
-{
-  JoinTable *tmp_join_tab= join->join_tab+join->tables;
-  Session *session= join->session;
-  LEX *lex= session->lex;
-  bool result= 0;
-
-  session->no_warnings_for_error= 1;
-  for (JoinTable *tab= join->join_tab; tab < tmp_join_tab; tab++)
-  {
-    if (!tab->table || !tab->table->pos_in_table_list)
-      break;
-
-    TableList *table_list= tab->table->pos_in_table_list;
-    if (table_list->schema_table)
-    {
-      bool is_subselect= (&lex->unit != lex->current_select->master_unit() &&
-                          lex->current_select->master_unit()->item);
-
-
-      /* skip I_S optimizations specific to get_all_tables */
-      if (session->lex->describe &&
-          (table_list->schema_table->isOptimizationPossible() != true))
-      {
-        continue;
-      }
-
-      /*
-        If schema table is already processed and
-        the statement is not a subselect then
-        we don't need to fill this table again.
-        If schema table is already processed and
-        schema_table_state != executed_place then
-        table is already processed and
-        we should skip second data processing.
-      */
-      if (table_list->schema_table_state &&
-          (!is_subselect || table_list->schema_table_state != executed_place))
-        continue;
-
-      /*
-        if table is used in a subselect and
-        table has been processed earlier with the same
-        'executed_place' value then we should refresh the table.
-      */
-      if (table_list->schema_table_state && is_subselect)
-      {
-        table_list->table->cursor->extra(HA_EXTRA_NO_CACHE);
-        table_list->table->cursor->extra(HA_EXTRA_RESET_STATE);
-        table_list->table->cursor->ha_delete_all_rows();
-        table_list->table->free_io_cache();
-        table_list->table->filesort_free_buffers(true);
-        table_list->table->null_row= 0;
-      }
-      else
-        table_list->table->cursor->stats.records= 0;
-
-      if (table_list->schema_table->fillTable(session, table_list))
-      {
-        result= 1;
-        join->error= 1;
-        tab->read_record.cursor= table_list->table->cursor;
-        table_list->schema_table_state= executed_place;
-        break;
-      }
-      tab->read_record.cursor= table_list->table->cursor;
-      table_list->schema_table_state= executed_place;
-    }
-  }
-  session->no_warnings_for_error= 0;
-  return(result);
-}

=== modified file 'drizzled/show.h'
--- drizzled/show.h	2009-11-19 03:54:45 +0000
+++ drizzled/show.h	2009-11-26 04:33:51 +0000
@@ -61,25 +61,23 @@
 } LOOKUP_FIELD_VALUES;
 
 bool calc_lookup_values_from_cond(Session *session, COND *cond, TableList *table,
-                                  LOOKUP_FIELD_VALUES *lookup_field_vals);
+                                  LOOKUP_FIELD_VALUES *lookup_field_vals,
+                                  drizzled::plugin::InfoSchemaTable *schema_table);
 bool get_lookup_field_values(Session *session, COND *cond, TableList *tables,
-                             LOOKUP_FIELD_VALUES *lookup_field_values);
+                             LOOKUP_FIELD_VALUES *lookup_field_values,
+                             drizzled::plugin::InfoSchemaTable *schema_table);
 int make_db_list(Session *session, std::vector<LEX_STRING*> &files,
                  LOOKUP_FIELD_VALUES *lookup_field_vals, bool *with_i_schema);
 SHOW_VAR *getFrontOfStatusVars();
 
 int store_create_info(TableList *table_list, String *packet, bool is_if_not_exists);
 
-bool schema_table_store_record(Session *session, Table *table);
-
 int get_quote_char_for_identifier();
 int wild_case_compare(const CHARSET_INFO * const cs, 
                       const char *str,const char *wildstr);
 
 bool make_schema_select(Session *session,  Select_Lex *sel,
                         const std::string& schema_table_name);
-bool mysql_schema_table(Session *session, LEX *lex, TableList *table_list);
-bool get_schema_tables_result(JOIN *join, enum enum_schema_table_state executed_place);
 
 bool mysqld_show_open_tables(Session *session,const char *wild);
 bool mysqld_show_logs(Session *session);

=== modified file 'drizzled/sql_base.cc'
--- drizzled/sql_base.cc	2009-11-26 03:12:02 +0000
+++ drizzled/sql_base.cc	2009-11-28 22:02:19 +0000
@@ -174,7 +174,13 @@
   true	Error 
 */
 
-bool list_open_tables(const char *db, const char *wild, bool(*func)(Table *table, open_table_list_st& open_list), Table *display)
+bool list_open_tables(const char *db, 
+                      const char *wild, 
+                      bool(*func)(Table *table, 
+                                  open_table_list_st& open_list,
+                                  plugin::InfoSchemaTable *schema_table), 
+                      Table *display,
+                      plugin::InfoSchemaTable *schema_table)
 {
   vector<open_table_list_st> open_list;
   vector<open_table_list_st>::iterator it;
@@ -225,7 +231,7 @@
 
   for (it= open_list.begin(); it < open_list.end(); it++)
   {
-    if (func(display, *it))
+    if (func(display, *it, schema_table))
       return true;
   }
 
@@ -2132,18 +2138,6 @@
     {
       continue;
     }
-    /*
-      If this TableList object is a placeholder for an information_schema
-      table, create a temporary table to represent the information_schema
-      table in the query. Do not fill it yet - will be filled during
-      execution.
-    */
-    if (tables->schema_table)
-    {
-      if (mysql_schema_table(this, lex, tables) == false)
-        continue;
-      return -1;
-    }
     (*counter)++;
 
     /*

=== modified file 'drizzled/sql_base.h'
--- drizzled/sql_base.h	2009-11-17 18:11:45 +0000
+++ drizzled/sql_base.h	2009-11-26 03:47:13 +0000
@@ -145,7 +145,13 @@
 
 bool fill_record(Session* session, List<Item> &fields, List<Item> &values, bool ignore_errors);
 bool fill_record(Session *session, Field **field, List<Item> &values, bool ignore_errors);
-bool list_open_tables(const char *db, const char *wild, bool(*func)(Table *table, open_table_list_st& open_list), Table *display);
+bool list_open_tables(const char *db, 
+                      const char *wild, 
+                      bool(*func)(Table *table, 
+                                  open_table_list_st& open_list,
+                                  drizzled::plugin::InfoSchemaTable *schema_table), 
+                      Table *display,
+                      drizzled::plugin::InfoSchemaTable *schema_table);
 
 inline TableList *find_table_in_global_list(TableList *table,
                                              const char *db_name,

=== modified file 'drizzled/sql_parse.cc'
--- drizzled/sql_parse.cc	2009-11-26 05:22:18 +0000
+++ drizzled/sql_parse.cc	2009-11-28 22:02:19 +0000
@@ -1001,8 +1001,6 @@
                ptr->table_name, INFORMATION_SCHEMA_NAME.c_str());
       return NULL;
     }
-    ptr->schema_table_name= ptr->table_name;
-    ptr->schema_table= schema_table;
   }
   ptr->select_lex=  lex->current_select;
   ptr->index_hints= index_hints_arg;

=== modified file 'drizzled/sql_select.cc'
--- drizzled/sql_select.cc	2009-11-16 17:06:48 +0000
+++ drizzled/sql_select.cc	2009-11-26 04:33:51 +0000
@@ -5293,11 +5293,6 @@
     }
   }
 
-  /* Fill schema tables with data before filesort if it's necessary */
-  if ((join->select_lex->options & OPTION_SCHEMA_TABLE) &&
-      get_schema_tables_result(join, PROCESSED_BY_CREATE_SORT_INDEX))
-    goto err;
-
   if (table->s->tmp_table)
     table->cursor->info(HA_STATUS_VARIABLE);	// Get record count
   table->sort.found_records=filesort(session, table,join->sortorder, length,
@@ -6660,7 +6655,6 @@
     {
       JoinTable *tab=join->join_tab+i;
       Table *table=tab->table;
-      TableList *table_list= tab->table->pos_in_table_list;
       char buff[512];
       char buff1[512], buff2[512], buff3[512];
       char keylen_str_buf[64];
@@ -6777,72 +6771,38 @@
       }
       else
       {
-        if (table_list->schema_table && 
-            table_list->schema_table->getRequestedObject() & OPTIMIZE_I_S_TABLE)
-        {
-          if (table_list->has_db_lookup_value)
-          {
-            int f_idx= table_list->schema_table->getFirstColumnIndex();
-            const string &tmp_buff= table_list->schema_table->getColumnName(f_idx);
-            tmp2.append(tmp_buff.c_str(), tmp_buff.length(), cs);
-          }
-          if (table_list->has_table_lookup_value)
-          {
-            if (table_list->has_db_lookup_value)
-              tmp2.append(',');
-            int f_idx= table_list->schema_table->getSecondColumnIndex();
-            const string &tmp_buff= table_list->schema_table->getColumnName(f_idx);
-            tmp2.append(tmp_buff.c_str(), tmp_buff.length(), cs);
-          }
-          if (tmp2.length())
-            item_list.push_back(new Item_string(tmp2.ptr(),tmp2.length(),cs));
-          else
-            item_list.push_back(item_null);
-        }
-        else
-          item_list.push_back(item_null);
+        item_list.push_back(item_null);
 	item_list.push_back(item_null);
 	item_list.push_back(item_null);
       }
 
       /* Add "rows" field to item_list. */
-      if (table_list->schema_table)
+      double examined_rows;
+      if (tab->select && tab->select->quick)
+        examined_rows= rows2double(tab->select->quick->records);
+      else if (tab->type == AM_NEXT || tab->type == AM_ALL)
+        examined_rows= rows2double(tab->limit ? tab->limit :
+            tab->table->cursor->records());
+      else
       {
-        /* in_rows */
-        if (join->session->lex->describe & DESCRIBE_EXTENDED)
-          item_list.push_back(item_null);
-        /* rows */
-        item_list.push_back(item_null);
+        optimizer::Position cur_pos= join->getPosFromOptimalPlan(i);
+        examined_rows= cur_pos.getFanout();
       }
-      else
+
+      item_list.push_back(new Item_int((int64_t) (uint64_t) examined_rows,
+            MY_INT64_NUM_DECIMAL_DIGITS));
+
+      /* Add "filtered" field to item_list. */
+      if (join->session->lex->describe & DESCRIBE_EXTENDED)
       {
-        double examined_rows;
-        if (tab->select && tab->select->quick)
-          examined_rows= rows2double(tab->select->quick->records);
-        else if (tab->type == AM_NEXT || tab->type == AM_ALL)
-          examined_rows= rows2double(tab->limit ? tab->limit :
-                                     tab->table->cursor->records());
-        else
+        float f= 0.0;
+        if (examined_rows)
         {
           optimizer::Position cur_pos= join->getPosFromOptimalPlan(i);
-          examined_rows= cur_pos.getFanout();
-        }
-
-        item_list.push_back(new Item_int((int64_t) (uint64_t) examined_rows,
-                                         MY_INT64_NUM_DECIMAL_DIGITS));
-
-        /* Add "filtered" field to item_list. */
-        if (join->session->lex->describe & DESCRIBE_EXTENDED)
-        {
-          float f= 0.0;
-          if (examined_rows)
-          {
-            optimizer::Position cur_pos= join->getPosFromOptimalPlan(i);
-            f= (float) (100.0 * cur_pos.getFanout() /
-                        examined_rows);
-          }
-          item_list.push_back(new Item_float(f, 2));
-        }
+          f= (float) (100.0 * cur_pos.getFanout() /
+              examined_rows);
+        }
+        item_list.push_back(new Item_float(f, 2));
       }
 
       /* Build "Extra" field and add it to item_list. */
@@ -6931,24 +6891,6 @@
         if (table->reginfo.not_exists_optimize)
           extra.append(STRING_WITH_LEN("; Not exists"));
 
-        if (table_list->schema_table &&
-            table_list->schema_table->getRequestedObject() & OPTIMIZE_I_S_TABLE)
-        {
-          if (!table_list->table_open_method)
-            extra.append(STRING_WITH_LEN("; Skip_open_table"));
-          else if (table_list->table_open_method == OPEN_FRM_ONLY)
-            extra.append(STRING_WITH_LEN("; Open_frm_only"));
-          else
-            extra.append(STRING_WITH_LEN("; Open_full_table"));
-          if (table_list->has_db_lookup_value &&
-              table_list->has_table_lookup_value)
-            extra.append(STRING_WITH_LEN("; Scanned 0 databases"));
-          else if (table_list->has_db_lookup_value ||
-                   table_list->has_table_lookup_value)
-            extra.append(STRING_WITH_LEN("; Scanned 1 database"));
-          else
-            extra.append(STRING_WITH_LEN("; Scanned all databases"));
-        }
         if (need_tmp_table)
         {
           need_tmp_table=0;

=== modified file 'drizzled/sql_table.cc'
--- drizzled/sql_table.cc	2009-11-26 05:22:18 +0000
+++ drizzled/sql_table.cc	2009-11-28 22:02:19 +0000
@@ -36,7 +36,8 @@
 #include <drizzled/plugin/client.h>
 #include <drizzled/table_identifier.h>
 
-#include "drizzled/statement/alter_table.h" /* for drizzled::create_like_schema_frm, which will die soon */
+#include "drizzled/statement/alter_table.h"
+#include "drizzled/plugin/info_schema_table.h"
 
 #include <algorithm>
 
@@ -2312,37 +2313,32 @@
   {
     int protoerr= EEXIST;
 
-    if (src_table->schema_table)
+    /*
+     * If an engine was not specified and we are reading from an I_S table, then we need to toss an
+     * error. This should go away soon.
+     * @todo make this go away!
+     */
+    if (! is_engine_set)
     {
-      /*
-        If engine was not specified and we are reading from the I_S, then we need to
-        toss an error. This should go away later on when we straighten out the
-        I_S engine.
-      */
-      if (! is_engine_set)
+      string tab_name(src_path);
+      string i_s_prefix("./information_schema/");
+      if (tab_name.compare(0, i_s_prefix.length(), i_s_prefix) == 0)
       {
         pthread_mutex_unlock(&LOCK_open);
-        my_error(ER_ILLEGAL_HA_CREATE_OPTION, MYF(0),
+        my_error(ER_ILLEGAL_HA_CREATE_OPTION,
+                 MYF(0),
                  "INFORMATION_ENGINE",
                  "TEMPORARY");
         goto err;
       }
+    }
 
-      if (create_like_schema_frm(session, src_table, &src_proto))
-      {
-        pthread_mutex_unlock(&LOCK_open);
-        goto err;
-      }
-    }
-    else
-    {
-      protoerr= plugin::StorageEngine::getTableDefinition(*session,
-                                                          src_path,
-                                                          db,
-                                                          table_name,
-                                                          false,
-                                                          &src_proto);
-    }
+    protoerr= plugin::StorageEngine::getTableDefinition(*session,
+                                                        src_path,
+                                                        db,
+                                                        table_name,
+                                                        false,
+                                                        &src_proto);
 
     message::Table new_proto(src_proto);
 

=== modified file 'drizzled/statement/alter_table.cc'
--- drizzled/statement/alter_table.cc	2009-11-29 19:01:41 +0000
+++ drizzled/statement/alter_table.cc	2009-11-30 18:45:46 +0000
@@ -28,6 +28,7 @@
 #include "drizzled/data_home.h"
 #include "drizzled/sql_table.h"
 #include "drizzled/table_proto.h"
+#include "drizzled/plugin/info_schema_table.h"
 
 using namespace std;
 
@@ -689,7 +690,12 @@
 
   new_name_buff[0]= '\0';
 
-  if (table_list && table_list->schema_table)
+  /**
+   * @todo this is a result of retaining the behavior that was here before. This should be removed
+   * and the correct error handling should be done in doDropTable for the I_S engine.
+   */
+  plugin::InfoSchemaTable *sch_table= plugin::InfoSchemaTable::getTable(table_list->table_name);
+  if (sch_table)
   {
     my_error(ER_DBACCESS_DENIED_ERROR, MYF(0), "", "", INFORMATION_SCHEMA_NAME.c_str());
     return true;
@@ -1430,61 +1436,6 @@
   return error;
 }
 
-/** @TODO This will soon die. */
-bool create_like_schema_frm(Session* session,
-                            TableList* schema_table,
-                            message::Table* table_proto)
-{
-  HA_CREATE_INFO local_create_info;
-  AlterInfo alter_info;
-  bool lex_identified_temp_table= (table_proto->type() == drizzled::message::Table::TEMPORARY);
-  uint32_t keys= schema_table->table->s->keys;
-  uint32_t db_options= 0;
-
-  memset(&local_create_info, 0, sizeof(local_create_info));
-  local_create_info.db_type= schema_table->table->s->db_type();
-  local_create_info.row_type= schema_table->table->s->row_type;
-  local_create_info.default_table_charset=default_charset_info;
-  alter_info.flags.set(ALTER_CHANGE_COLUMN);
-  alter_info.flags.set(ALTER_RECREATE);
-  schema_table->table->use_all_columns();
-  if (mysql_prepare_alter_table(session, schema_table->table,
-                                &local_create_info, table_proto, &alter_info))
-    return true;
-
-  /* I_S tables are created with MAX_ROWS for some efficiency drive.
-     When CREATE LIKE, we don't want to keep it coming across */
-  message::Table::TableOptions *table_options;
-  table_options= table_proto->mutable_options();
-  table_options->clear_max_rows();
-
-  if (mysql_prepare_create_table(session, &local_create_info, table_proto,
-                                 &alter_info,
-                                 lex_identified_temp_table, &db_options,
-                                 schema_table->table->cursor,
-                                 &schema_table->table->s->key_info, &keys, 0))
-    return true;
-
-  table_proto->set_name("system_stupid_i_s_fix_nonsense");
-
-  {
-    message::Table::StorageEngine *protoengine;
-    protoengine= table_proto->mutable_engine();
-
-    plugin::StorageEngine *engine= local_create_info.db_type;
-
-    protoengine->set_name(engine->getName());
-  }
-
-  if (fill_table_proto(table_proto, "system_stupid_i_s_fix_nonsense",
-                       alter_info.create_list, &local_create_info,
-                       keys, schema_table->table->s->key_info))
-    return true;
-
-  return false;
-}
-
-
 static Table *open_alter_table(Session *session, Table *table, char *db, char *table_name)
 {
   Table *new_table;

=== modified file 'drizzled/statement/alter_table.h'
--- drizzled/statement/alter_table.h	2009-11-19 20:11:37 +0000
+++ drizzled/statement/alter_table.h	2009-11-24 22:24:23 +0000
@@ -57,10 +57,6 @@
                  TableList *table_list,
                  AlterInfo *alter_info,
                  uint32_t order_num, order_st *order, bool ignore);
-/** @TODO This should die with I_S engine work from Padraig */
-bool create_like_schema_frm(Session* session,
-                            TableList* schema_table,
-                            message::Table* table_proto);
 
 } /* namespace drizzled */
 #endif /* DRIZZLED_STATEMENT_ALTER_TABLE_H */

=== modified file 'drizzled/statement/drop_table.cc'
--- drizzled/statement/drop_table.cc	2009-11-24 21:58:38 +0000
+++ drizzled/statement/drop_table.cc	2009-11-28 22:16:35 +0000
@@ -23,6 +23,7 @@
 #include <drizzled/session.h>
 #include <drizzled/lock.h>
 #include <drizzled/statement/drop_table.h>
+#include <drizzled/plugin/info_schema_table.h>
 
 namespace drizzled
 {
@@ -56,7 +57,16 @@
 {
   bool error, need_start_waiting= false;
 
-  if (tables && tables->schema_table)
+  /**
+   * @todo this is a result of retaining the behavior that was here before. This should be removed
+   * and the correct error handling should be done in doDropTable for the I_S engine. There is an
+   * issue here with dropping tables with the same name as an I_S table. How do we know if we are
+   * attemping to drop an I_S table or a regular table with the same name as an I_S table? For now,
+   * we simply check if the current database is information_schema
+   */
+  plugin::InfoSchemaTable *sch_table= plugin::InfoSchemaTable::getTable(tables->table_name);
+  if (sch_table &&
+      session->db.compare(INFORMATION_SCHEMA_NAME) == 0)
   {
     my_error(ER_DBACCESS_DENIED_ERROR, MYF(0), "", "", INFORMATION_SCHEMA_NAME.c_str());
     return true;

=== modified file 'drizzled/table.cc'
--- drizzled/table.cc	2009-11-29 19:01:41 +0000
+++ drizzled/table.cc	2009-11-30 18:45:46 +0000
@@ -2265,39 +2265,6 @@
 
 
 /**
-  Create field for information schema table.
-
-  @param session		Thread Cursor
-  @param table		Temporary table
-  @param item		Item to create a field for
-
-  @retval
-    0			on error
-  @retval
-    new_created field
-*/
-
-static Field *create_tmp_field_for_schema(Item *item, Table *table)
-{
-  if (item->field_type() == DRIZZLE_TYPE_VARCHAR)
-  {
-    Field *field;
-    if (item->max_length > MAX_FIELD_VARCHARLENGTH)
-      field= new Field_blob(item->max_length, item->maybe_null,
-                            item->name, item->collation.collation);
-    else
-      field= new Field_varstring(item->max_length, item->maybe_null,
-                                 item->name,
-                                 table->s, item->collation.collation);
-    if (field)
-      field->init(table);
-    return field;
-  }
-  return item->tmp_table_field_from_field_type(table, 0);
-}
-
-
-/**
   Create a temp table according to a field list.
 
   Given field pointers are changed to point at tmp_table for
@@ -2561,8 +2528,7 @@
 	We here distinguish between UNION and multi-table-updates by the fact
 	that in the later case group is set to the row pointer.
       */
-      Field *new_field= (param->schema_table) ?
-        create_tmp_field_for_schema(item, table) :
+      Field *new_field= 
         create_tmp_field(session, table, item, type, &copy_func,
                          tmp_from_field, &default_field[fieldnr],
                          group != 0,

=== modified file 'drizzled/table_list.cc'
--- drizzled/table_list.cc	2009-10-20 16:11:52 +0000
+++ drizzled/table_list.cc	2009-11-26 04:33:51 +0000
@@ -64,7 +64,7 @@
 
 bool TableList::placeholder()
 {
-  return derived || schema_table || (create && !table->getDBStat()) || !table;
+  return derived || (create && !table->getDBStat()) || !table;
 }
 
 /*
@@ -292,16 +292,8 @@
         str->append_identifier(db, db_length);
         str->append('.');
       }
-      if (schema_table)
-      {
-        str->append_identifier(schema_table_name, strlen(schema_table_name));
-        cmp_name= schema_table_name;
-      }
-      else
-      {
-        str->append_identifier(table_name, table_name_length);
-        cmp_name= table_name;
-      }
+      str->append_identifier(table_name, table_name_length);
+      cmp_name= table_name;
     }
     if (my_strcasecmp(table_alias_charset, cmp_name, alias))
     {

=== modified file 'drizzled/table_list.h'
--- drizzled/table_list.h	2009-10-20 16:11:52 +0000
+++ drizzled/table_list.h	2009-11-26 04:33:51 +0000
@@ -57,8 +57,6 @@
  *    (TableList::derived == NULL)
  *    - subquery - TableList::table is a temp table
  *    (TableList::derived != NULL)
- *    - information schema table
- *    (TableList::schema_table != NULL)
  *    
  *    @note
  *
@@ -86,7 +84,6 @@
     db(NULL),
     alias(NULL),
     table_name(NULL),
-    schema_table_name(NULL),
     option(NULL),
     on_expr(NULL),
     table(NULL),
@@ -106,9 +103,7 @@
     index_hints(NULL),
     derived_result(NULL),
     derived(NULL),
-    schema_table(NULL),
     schema_select_lex(NULL),
-    schema_table_param(NULL),
     select_lex(NULL),
     next_leaf(NULL),
     outer_join(0),
@@ -126,8 +121,7 @@
     is_alias(false),
     is_fqtn(false),
     has_db_lookup_value(false),
-    has_table_lookup_value(false),
-    table_open_method(0)
+    has_table_lookup_value(false)
   {}
 
   /**
@@ -144,7 +138,6 @@
   char *db;
   const char *alias;
   char *table_name;
-  char *schema_table_name;
   char *option; ///< Used by cache index
   Item *on_expr; ///< Used with outer join
   Table *table; ///< opened table
@@ -211,9 +204,7 @@
    */
   select_union *derived_result;
   Select_Lex_Unit *derived; ///< Select_Lex_Unit of derived table */
-  drizzled::plugin::InfoSchemaTable *schema_table; ///< Information_schema table
   Select_Lex *schema_select_lex;
-  Tmp_Table_Param *schema_table_param;
   /** link to select_lex where this table was used */
   Select_Lex *select_lex;
   /**
@@ -246,8 +237,6 @@
 
   bool has_db_lookup_value;
   bool has_table_lookup_value;
-  uint32_t table_open_method;
-  enum enum_schema_table_state schema_table_state;
 
   void set_underlying_merge();
   bool setup_underlying(Session *session);

=== modified file 'drizzled/table_proto_write.cc'
--- drizzled/table_proto_write.cc	2009-11-25 19:45:11 +0000
+++ drizzled/table_proto_write.cc	2009-11-28 22:02:19 +0000
@@ -536,8 +536,6 @@
     create_fields	Fields to create
     keys		number of keys to create
     key_info		Keys to create
-    file		Handler to use
-    is_like             is true for drizzled::create_like_schema_frm
 
   RETURN
     0  ok

=== modified file 'plugin/info_schema/character_set.cc'
--- plugin/info_schema/character_set.cc	2009-11-18 21:40:45 +0000
+++ plugin/info_schema/character_set.cc	2009-11-26 03:47:13 +0000
@@ -74,32 +74,28 @@
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Charset",
-                                            SKIP_OPEN_TABLE));
+                                            "Charset"));
 
   columns->push_back(new plugin::ColumnInfo("DEFAULT_COLLATE_NAME",
                                             64,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Default collation",
-                                            SKIP_OPEN_TABLE));
+                                            "Default collation"));
 
   columns->push_back(new plugin::ColumnInfo("DESCRIPTION",
                                             60,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Description",
-                                            SKIP_OPEN_TABLE));
+                                            "Description"));
 
   columns->push_back(new plugin::ColumnInfo("MAXLEN",
                                             3,
                                             DRIZZLE_TYPE_LONGLONG,
                                             0,
                                             0,
-                                            "Maxlen",
-                                            SKIP_OPEN_TABLE));
+                                            "Maxlen"));
 
   return columns;
 }
@@ -140,11 +136,12 @@
   delete columns;
 }
 
-int CharSetISMethods::fillTable(Session *session, TableList *tables)
+int CharSetISMethods::fillTable(Session *session, 
+                                Table *table,
+                                plugin::InfoSchemaTable *schema_table)
 {
   CHARSET_INFO **cs;
   const char *wild= session->lex->wild ? session->lex->wild->ptr() : NULL;
-  Table *table= tables->table;
   const CHARSET_INFO * const scs= system_charset_info;
 
   for (cs= all_charsets ; cs < all_charsets+255 ; cs++)
@@ -158,13 +155,16 @@
     {
       const char *comment;
       table->restoreRecordAsDefault();
+      table->setWriteSet(0);
+      table->setWriteSet(1);
+      table->setWriteSet(2);
+      table->setWriteSet(3);
       table->field[0]->store(tmp_cs->csname, strlen(tmp_cs->csname), scs);
       table->field[1]->store(tmp_cs->name, strlen(tmp_cs->name), scs);
       comment= tmp_cs->comment ? tmp_cs->comment : "";
       table->field[2]->store(comment, strlen(comment), scs);
       table->field[3]->store((int64_t) tmp_cs->mbmaxlen, true);
-      if (schema_table_store_record(session, table))
-        return 1;
+      schema_table->addRow(table->record[0], table->s->reclength);
     }
   }
   return 0;

=== modified file 'plugin/info_schema/character_set.h'
--- plugin/info_schema/character_set.h	2009-11-16 03:00:14 +0000
+++ plugin/info_schema/character_set.h	2009-11-26 03:47:13 +0000
@@ -34,7 +34,8 @@
 {
 public:
   virtual int fillTable(Session *session,
-                        TableList *tables);
+                        Table *table,
+                        drizzled::plugin::InfoSchemaTable *schema_table);
   virtual int oldFormat(Session *session,
                         drizzled::plugin::InfoSchemaTable *schema_table) const;
 };

=== modified file 'plugin/info_schema/collation.cc'
--- plugin/info_schema/collation.cc	2009-11-18 21:40:45 +0000
+++ plugin/info_schema/collation.cc	2009-11-26 03:47:13 +0000
@@ -74,56 +74,49 @@
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Collation",
-                                            SKIP_OPEN_TABLE));
+                                            "Collation"));
 
   columns->push_back(new plugin::ColumnInfo("CHARACTER_SET_NAME",
                                             64,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Default collation",
-                                            SKIP_OPEN_TABLE));
+                                            "Default collation"));
 
   columns->push_back(new plugin::ColumnInfo("DESCRIPTION",
                                             60,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Charset",
-                                            SKIP_OPEN_TABLE));
+                                            "Charset"));
 
   columns->push_back(new plugin::ColumnInfo("ID",
                                             MY_INT32_NUM_DECIMAL_DIGITS,
                                             DRIZZLE_TYPE_LONGLONG,
                                             0,
                                             0,
-                                            "Id",
-                                            SKIP_OPEN_TABLE));
+                                            "Id"));
 
   columns->push_back(new plugin::ColumnInfo("IS_DEFAULT",
                                             3,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Default",
-                                            SKIP_OPEN_TABLE));
+                                            "Default"));
 
   columns->push_back(new plugin::ColumnInfo("IS_COMPILED",
                                             3,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Compiled",
-                                            SKIP_OPEN_TABLE));
+                                            "Compiled"));
 
   columns->push_back(new plugin::ColumnInfo("SORTLEN",
                                             3,
                                             DRIZZLE_TYPE_LONGLONG,
                                             0,
                                             0,
-                                            "Sortlen",
-                                            SKIP_OPEN_TABLE));
+                                            "Sortlen"));
 
   return columns;
 }
@@ -164,11 +157,12 @@
   delete columns;
 }
 
-int CollationISMethods::fillTable(Session *session, TableList *tables)
+int CollationISMethods::fillTable(Session *session, 
+                                  Table *table,
+                                  plugin::InfoSchemaTable *schema_table)
 {
   CHARSET_INFO **cs;
   const char *wild= session->lex->wild ? session->lex->wild->ptr() : NULL;
-  Table *table= tables->table;
   const CHARSET_INFO * const scs= system_charset_info;
   for (cs= all_charsets ; cs < all_charsets+255 ; cs++ )
   {
@@ -189,6 +183,13 @@
       {
         const char *tmp_buff;
         table->restoreRecordAsDefault();
+        /* set the appropriate bits in the write bitset */
+        table->setWriteSet(0);
+        table->setWriteSet(1);
+        table->setWriteSet(2);
+        table->setWriteSet(3);
+        table->setWriteSet(4);
+        table->setWriteSet(5);
         table->field[0]->store(tmp_cl->name, strlen(tmp_cl->name), scs);
         table->field[1]->store(tmp_cl->csname , strlen(tmp_cl->csname), scs);
         table->field[2]->store((int64_t) tmp_cl->number, true);
@@ -197,8 +198,7 @@
         tmp_buff= (tmp_cl->state & MY_CS_COMPILED)? "Yes" : "";
         table->field[4]->store(tmp_buff, strlen(tmp_buff), scs);
         table->field[5]->store((int64_t) tmp_cl->strxfrm_multiply, true);
-        if (schema_table_store_record(session, table))
-          return 1;
+        schema_table->addRow(table->record[0], table->s->reclength);
       }
     }
   }

=== modified file 'plugin/info_schema/collation.h'
--- plugin/info_schema/collation.h	2009-11-16 03:25:39 +0000
+++ plugin/info_schema/collation.h	2009-11-26 03:47:13 +0000
@@ -33,7 +33,8 @@
 {
 public:
   virtual int fillTable(Session *session,
-                        TableList *tables);
+                        Table *table,
+                        drizzled::plugin::InfoSchemaTable *schema_table);
 };
 
 class CollationIS

=== modified file 'plugin/info_schema/collation_char_set.cc'
--- plugin/info_schema/collation_char_set.cc	2009-11-18 21:40:45 +0000
+++ plugin/info_schema/collation_char_set.cc	2009-11-26 03:47:13 +0000
@@ -74,16 +74,14 @@
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "",
-                                            SKIP_OPEN_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("CHARACTER_SET_NAME",
                                             64,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "",
-                                            SKIP_OPEN_TABLE));
+                                            ""));
 
   return columns;
 }
@@ -124,10 +122,11 @@
   delete columns;
 }
 
-int CollCharISMethods::fillTable(Session *session, TableList *tables)
+int CollCharISMethods::fillTable(Session *,  
+                                 Table *table,
+                                 plugin::InfoSchemaTable *schema_table)
 {
   CHARSET_INFO **cs;
-  Table *table= tables->table;
   const CHARSET_INFO * const scs= system_charset_info;
   for (cs= all_charsets ; cs < all_charsets+255 ; cs++ )
   {
@@ -143,10 +142,11 @@
           ! my_charset_same(tmp_cs,tmp_cl))
         continue;
       table->restoreRecordAsDefault();
+      table->setWriteSet(0);
+      table->setWriteSet(1);
       table->field[0]->store(tmp_cl->name, strlen(tmp_cl->name), scs);
       table->field[1]->store(tmp_cl->csname , strlen(tmp_cl->csname), scs);
-      if (schema_table_store_record(session, table))
-        return 1;
+      schema_table->addRow(table->record[0], table->s->reclength);
     }
   }
   return 0;

=== modified file 'plugin/info_schema/collation_char_set.h'
--- plugin/info_schema/collation_char_set.h	2009-11-16 03:47:07 +0000
+++ plugin/info_schema/collation_char_set.h	2009-11-26 03:47:13 +0000
@@ -33,7 +33,8 @@
 {
 public:
   virtual int fillTable(Session *session,
-                        TableList *tables);
+                        Table *table,
+                        drizzled::plugin::InfoSchemaTable *schema_table);
 };
 
 class CollationCharSetIS

=== modified file 'plugin/info_schema/columns.cc'
--- plugin/info_schema/columns.cc	2009-11-18 21:40:45 +0000
+++ plugin/info_schema/columns.cc	2009-11-29 05:53:07 +0000
@@ -74,168 +74,147 @@
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             1,
-                                            "",
-                                            OPEN_FRM_ONLY));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("TABLE_SCHEMA",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "",
-                                            OPEN_FRM_ONLY));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("TABLE_NAME",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "",
-                                            OPEN_FRM_ONLY));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("COLUMN_NAME",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Field",
-                                            OPEN_FRM_ONLY));
+                                            "Field"));
 
   columns->push_back(new plugin::ColumnInfo("ORDINAL_POSITION",
                                             MY_INT64_NUM_DECIMAL_DIGITS,
                                             DRIZZLE_TYPE_LONGLONG,
                                             0,
                                             MY_I_S_UNSIGNED,
-                                            "",
-                                            OPEN_FRM_ONLY));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("COLUMN_DEFAULT",
-                                            MAX_FIELD_VARCHARLENGTH,
+                                            64,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             1,
-                                            "Default",
-                                            OPEN_FRM_ONLY));
+                                            "Default"));
 
   columns->push_back(new plugin::ColumnInfo("IS_NULLABLE",
                                             3,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Null",
-                                            OPEN_FRM_ONLY));
+                                            "Null"));
 
   columns->push_back(new plugin::ColumnInfo("DATA_TYPE",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "",
-                                            OPEN_FRM_ONLY));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("CHARACTER_MAXIMUM_LENGTH",
                                            MY_INT64_NUM_DECIMAL_DIGITS,
                                            DRIZZLE_TYPE_LONGLONG,
                                            0,
                                            (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED),
-                                           "",
-                                           OPEN_FRM_ONLY));
+                                           ""));
 
   columns->push_back(new plugin::ColumnInfo("CHARACTER_OCTET_LENGTH",
                                             MY_INT64_NUM_DECIMAL_DIGITS,
                                             DRIZZLE_TYPE_LONGLONG,
                                             0,
                                             (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED),
-                                            "",
-                                            OPEN_FRM_ONLY));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("NUMERIC_PRECISION",
                                             MY_INT64_NUM_DECIMAL_DIGITS,
                                             DRIZZLE_TYPE_LONGLONG,
                                             0,
                                             (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED),
-                                            "",
-                                            OPEN_FRM_ONLY));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("NUMERIC_SCALE",
                                             MY_INT64_NUM_DECIMAL_DIGITS,
                                             DRIZZLE_TYPE_LONGLONG,
                                             0,
                                             (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED),
-                                            "",
-                                            OPEN_FRM_ONLY));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("CHARACTER_SET_NAME",
                                             64,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             1,
-                                            "",
-                                            OPEN_FRM_ONLY));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("COLLATION_NAME",
                                             64,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             1,
-                                            "Collation",
-                                            OPEN_FRM_ONLY));
+                                            "Collation"));
 
   columns->push_back(new plugin::ColumnInfo("COLUMN_TYPE",
-                                            65535,
+                                            64,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Type",
-                                            OPEN_FRM_ONLY));
+                                            "Type"));
 
   columns->push_back(new plugin::ColumnInfo("COLUMN_KEY",
                                             3,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Key",
-                                            OPEN_FRM_ONLY));
+                                            "Key"));
 
   columns->push_back(new plugin::ColumnInfo("EXTRA",
                                             27,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Extra",
-                                            OPEN_FRM_ONLY));
+                                            "Extra"));
 
   columns->push_back(new plugin::ColumnInfo("PRIVILEGES",
                                             80,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Privileges",
-                                            OPEN_FRM_ONLY));
+                                            "Privileges"));
 
   columns->push_back(new plugin::ColumnInfo("COLUMN_COMMENT",
                                             COLUMN_COMMENT_MAXLEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Comment",
-                                            OPEN_FRM_ONLY));
+                                            "Comment"));
 
   columns->push_back(new plugin::ColumnInfo("STORAGE",
                                             8,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Storage",
-                                            OPEN_FRM_ONLY));
+                                            "Storage"));
 
   columns->push_back(new plugin::ColumnInfo("FORMAT",
                                             8,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Format",
-                                            OPEN_FRM_ONLY));
+                                            "Format"));
   return columns;
 }
 

=== modified file 'plugin/info_schema/helper_methods.cc'
--- plugin/info_schema/helper_methods.cc	2009-11-18 21:40:45 +0000
+++ plugin/info_schema/helper_methods.cc	2009-11-26 03:47:13 +0000
@@ -36,6 +36,7 @@
 #include <string>
 
 using namespace std;
+using namespace drizzled;
 
 static inline void make_upper(char *buf)
 {
@@ -49,7 +50,8 @@
                        enum enum_var_type value_type,
                        struct system_status_var *status_var,
                        const char *prefix, Table *table,
-                       bool ucase_names)
+                       bool ucase_names,
+                       plugin::InfoSchemaTable *schema_table)
 {
   MY_ALIGNED_BYTE_ARRAY(buff_data, SHOW_VAR_FUNC_BUFF_SIZE, int64_t);
   char * const buff= (char *) &buff_data;
@@ -84,7 +86,7 @@
     if (show_type == SHOW_ARRAY)
     {
       show_status_array(session, wild, (SHOW_VAR *) var->value, value_type,
-                        status_var, name_buffer, table, ucase_names);
+                        status_var, name_buffer, table, ucase_names, schema_table);
     }
     else
     {
@@ -187,6 +189,9 @@
           break;
         }
         table->restoreRecordAsDefault();
+        table->setWriteSet(0);
+        table->setWriteSet(1);
+        table->setWriteSet(2);
         table->field[0]->store(name_buffer, strlen(name_buffer),
                                system_charset_info);
         table->field[1]->store(pos, (uint32_t) (end - pos), system_charset_info);
@@ -194,8 +199,7 @@
 
         pthread_mutex_unlock(&LOCK_global_system_variables);
 
-        if (schema_table_store_record(session, table))
-          return true;
+        schema_table->addRow(table->record[0], table->s->reclength);
       }
     }
   }
@@ -203,7 +207,6 @@
   return false;
 }
 
-
 void store_key_column_usage(Table *table, 
                             LEX_STRING *db_name,
                             LEX_STRING *table_name, 
@@ -214,6 +217,13 @@
                             int64_t idx)
 {
   const CHARSET_INFO * const cs= system_charset_info;
+  /* set the appropriate bits in the write bitset */
+  table->setWriteSet(1);
+  table->setWriteSet(2);
+  table->setWriteSet(4);
+  table->setWriteSet(5);
+  table->setWriteSet(6);
+  table->setWriteSet(7);
   table->field[1]->store(db_name->str, db_name->length, cs);
   table->field[2]->store(key_name, key_len, cs);
   table->field[4]->store(db_name->str, db_name->length, cs);

=== modified file 'plugin/info_schema/helper_methods.h'
--- plugin/info_schema/helper_methods.h	2009-11-18 21:40:45 +0000
+++ plugin/info_schema/helper_methods.h	2009-11-26 03:47:13 +0000
@@ -29,7 +29,8 @@
                        enum enum_var_type value_type,
                        struct system_status_var *status_var,
                        const char *prefix, Table *table,
-                       bool ucase_names);
+                       bool ucase_names,
+                       drizzled::plugin::InfoSchemaTable *schema_table);
 
 void store_key_column_usage(Table *table, 
                             LEX_STRING *db_name,

=== modified file 'plugin/info_schema/key_column_usage.cc'
--- plugin/info_schema/key_column_usage.cc	2009-11-18 21:40:45 +0000
+++ plugin/info_schema/key_column_usage.cc	2009-11-26 04:33:51 +0000
@@ -71,96 +71,84 @@
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             1,
-                                            "",
-                                            OPEN_FULL_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("CONSTRAINT_SCHEMA",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "",
-                                            OPEN_FULL_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("CONSTRAINT_NAME",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "",
-                                            OPEN_FULL_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("TABLE_CATALOG",
                                             FN_REFLEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             1,
-                                            "",
-                                            OPEN_FULL_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("TABLE_SCHEMA",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "",
-                                            OPEN_FULL_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("TABLE_NAME",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "",
-                                            OPEN_FULL_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("COLUMN_NAME",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "",
-                                            OPEN_FULL_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("ORDINAL_POSITION",
                                             10,
                                             DRIZZLE_TYPE_LONGLONG,
                                             0,
                                             0,
-                                            "",
-                                            OPEN_FULL_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("POSITION_IN_UNIQUE_CONSTRAINT",
                                             10,
                                             DRIZZLE_TYPE_LONGLONG,
                                             0,
                                             1,
-                                            "",
-                                            OPEN_FULL_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("REFERENCED_TABLE_SCHEMA",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             1,
-                                            "",
-                                            OPEN_FULL_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("REFERENCED_TABLE_NAME",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             1,
-                                            "",
-                                            OPEN_FULL_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("REFERENCED_COLUMN_NAME",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             1,
-                                            "",
-                                            OPEN_FULL_TABLE));
+                                            ""));
 
   return columns;
 }
@@ -202,11 +190,12 @@
   delete columns;
 }
 
-int KeyColUsageISMethods::processTable(Session *session,
+int KeyColUsageISMethods::processTable(plugin::InfoSchemaTable *store_table,
+                                       Session *session,
                                        TableList *tables,
                                        Table *table, bool res,
                                        LEX_STRING *db_name,
-                                       LEX_STRING *table_name) const
+                                       LEX_STRING *table_name)
 {
   if (res)
   {
@@ -245,10 +234,8 @@
                                  key_part->field->field_name,
                                  strlen(key_part->field->field_name),
                                  (int64_t) f_idx);
-          if (schema_table_store_record(session, table))
-          {
-            return (1);
-          }
+          store_table->addRow(table->record[0],
+                                       table->s->reclength);
         }
       }
     }
@@ -273,6 +260,10 @@
                                f_key_info->forein_id->length,
                                f_info->str, f_info->length,
                                (int64_t) f_idx);
+        table->setWriteSet(8);
+        table->setWriteSet(9);
+        table->setWriteSet(10);
+        table->setWriteSet(11);
         table->field[8]->store((int64_t) f_idx, true);
         table->field[8]->set_notnull();
         table->field[9]->store(f_key_info->referenced_db->str,
@@ -286,10 +277,7 @@
         table->field[11]->store(r_info->str, r_info->length,
                                 system_charset_info);
         table->field[11]->set_notnull();
-        if (schema_table_store_record(session, table))
-        {
-          return (1);
-        }
+        store_table->addRow(table->record[0], table->s->reclength);
       }
     }
   }

=== modified file 'plugin/info_schema/key_column_usage.h'
--- plugin/info_schema/key_column_usage.h	2009-11-16 18:35:38 +0000
+++ plugin/info_schema/key_column_usage.h	2009-11-24 22:20:36 +0000
@@ -32,9 +32,10 @@
 class KeyColUsageISMethods : public drizzled::plugin::InfoSchemaMethods
 {
 public:
-  virtual int processTable(Session *session, TableList *tables,
+  virtual int processTable(drizzled::plugin::InfoSchemaTable *store_table,
+                           Session *session, TableList *tables,
                            Table *table, bool res, LEX_STRING *db_name,
-                           LEX_STRING *table_name) const;
+                           LEX_STRING *table_name);
 };
 
 class KeyColumnUsageIS

=== modified file 'plugin/info_schema/modules.cc'
--- plugin/info_schema/modules.cc	2009-11-18 21:40:45 +0000
+++ plugin/info_schema/modules.cc	2009-11-26 03:47:13 +0000
@@ -71,56 +71,49 @@
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Name",
-                                            SKIP_OPEN_TABLE));
+                                            "Name"));
 
   columns->push_back(new plugin::ColumnInfo("MODULE_VERSION",
                                             20,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "",
-                                            SKIP_OPEN_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("MODULE_AUTHOR",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             1,
-                                            "",
-                                            SKIP_OPEN_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("IS_BUILTIN",
                                             3,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "",
-                                            SKIP_OPEN_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("MODULE_LIBRARY",
                                             65535,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             1,
-                                            "",
-                                            SKIP_OPEN_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("MODULE_DESCRIPTION",
                                             65535,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             1,
-                                            "",
-                                            SKIP_OPEN_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("MODULE_LICENSE",
                                             80,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             1,
-                                            "License",
-                                            SKIP_OPEN_TABLE));
+                                            "License"));
   return columns;
 }
 
@@ -164,9 +157,10 @@
 {
   Session *session;
   Table *table;
+  plugin::InfoSchemaTable *schema_table;
 public:
-  ShowModules(Session *session_arg, Table *table_arg)
-    : session(session_arg), table(table_arg) {}
+  ShowModules(Session *session_arg, Table *table_arg, plugin::InfoSchemaTable *sch_tab_arg)
+    : session(session_arg), table(table_arg), schema_table(sch_tab_arg) {}
 
   result_type operator() (argument_type module)
   {
@@ -174,6 +168,13 @@
     const CHARSET_INFO * const cs= system_charset_info;
 
     table->restoreRecordAsDefault();
+    table->setWriteSet(0);
+    table->setWriteSet(1);
+    table->setWriteSet(2);
+    table->setWriteSet(3);
+    table->setWriteSet(4);
+    table->setWriteSet(5);
+    table->setWriteSet(6);
 
     table->field[0]->store(module->getName().c_str(),
                            module->getName().size(), cs);
@@ -239,18 +240,19 @@
     }
     table->field[6]->set_notnull();
 
-    return schema_table_store_record(session, table);
+    schema_table->addRow(table->record[0], table->s->reclength);
+    return false;
   }
 };
 
-int ModulesISMethods::fillTable(Session *session, TableList *tables)
+int ModulesISMethods::fillTable(Session *session, 
+                                Table *table,
+                                plugin::InfoSchemaTable *schema_table)
 {
-  Table *table= tables->table;
-
   drizzled::plugin::Registry &registry= drizzled::plugin::Registry::singleton();
   vector<drizzled::plugin::Module *> modules= registry.getList(true);
   vector<drizzled::plugin::Module *>::iterator iter=
-    find_if(modules.begin(), modules.end(), ShowModules(session, table));
+    find_if(modules.begin(), modules.end(), ShowModules(session, table, schema_table));
   if (iter != modules.end())
   {
     return 1;

=== modified file 'plugin/info_schema/modules.h'
--- plugin/info_schema/modules.h	2009-11-17 04:45:13 +0000
+++ plugin/info_schema/modules.h	2009-11-26 03:47:13 +0000
@@ -33,7 +33,8 @@
 {
 public:
   virtual int fillTable(Session *session,
-                        TableList *tables);
+                        Table *table,
+                        drizzled::plugin::InfoSchemaTable *schema_table);
 };
 
 class ModulesIS

=== modified file 'plugin/info_schema/open_tables.cc'
--- plugin/info_schema/open_tables.cc	2009-11-18 21:40:45 +0000
+++ plugin/info_schema/open_tables.cc	2009-11-26 03:47:13 +0000
@@ -71,32 +71,28 @@
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Database",
-                                            SKIP_OPEN_TABLE));
+                                            "Database"));
 
   columns->push_back(new plugin::ColumnInfo("Table",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Table",
-                                            SKIP_OPEN_TABLE));
+                                            "Table"));
 
   columns->push_back(new plugin::ColumnInfo("In_use",
                                             1,
                                             DRIZZLE_TYPE_LONGLONG,
                                             0,
                                             0,
-                                            "In_use",
-                                            SKIP_OPEN_TABLE));
+                                            "In_use"));
 
   columns->push_back(new plugin::ColumnInfo("Name_locked",
                                             4,
                                             DRIZZLE_TYPE_LONGLONG,
                                             0,
                                             0,
-                                            "Name_locked",
-                                            SKIP_OPEN_TABLE));
+                                            "Name_locked"));
 
   return columns;
 }
@@ -137,25 +133,34 @@
   delete columns;
 }
 
-inline bool open_list_store(Table *table, open_table_list_st& open_list);
-inline bool open_list_store(Table *table, open_table_list_st& open_list)
+inline bool open_list_store(Table *table, 
+                            open_table_list_st& open_list,
+                            plugin::InfoSchemaTable *schema_table);
+inline bool open_list_store(Table *table, 
+                            open_table_list_st& open_list,
+                            plugin::InfoSchemaTable *schema_table)
 {
   table->restoreRecordAsDefault();
+  table->setWriteSet(0);
+  table->setWriteSet(1);
+  table->setWriteSet(2);
+  table->setWriteSet(3);
   table->field[0]->store(open_list.db.c_str(), open_list.db.length(), system_charset_info);
   table->field[1]->store(open_list.table.c_str(), open_list.table.length(), system_charset_info);
   table->field[2]->store((int64_t) open_list.in_use, true);
   table->field[3]->store((int64_t) open_list.locked, true);
-  if (schema_table_store_record(table->in_use, table))
-    return true;
+  schema_table->addRow(table->record[0], table->s->reclength);
 
   return false;
 }
 
-int OpenTablesISMethods::fillTable(Session *session, TableList *tables)
+int OpenTablesISMethods::fillTable(Session *session, 
+                                   Table *table,
+                                   plugin::InfoSchemaTable *schema_table)
 {
   const char *wild= session->lex->wild ? session->lex->wild->ptr() : NULL;
 
-  if ((list_open_tables(session->lex->select_lex.db, wild, open_list_store, tables->table) == true) && session->is_fatal_error)
+  if ((list_open_tables(session->lex->select_lex.db, wild, open_list_store, table, schema_table) == true) && session->is_fatal_error)
     return 1;
 
   return 0;

=== modified file 'plugin/info_schema/open_tables.h'
--- plugin/info_schema/open_tables.h	2009-11-17 05:51:20 +0000
+++ plugin/info_schema/open_tables.h	2009-11-26 03:47:13 +0000
@@ -33,7 +33,8 @@
 {
 public:
   virtual int fillTable(Session *session,
-                        TableList *tables);
+                        Table *table,
+                        drizzled::plugin::InfoSchemaTable *schema_table);
 };
 
 class OpenTablesIS

=== modified file 'plugin/info_schema/plugins.cc'
--- plugin/info_schema/plugins.cc	2009-11-18 21:40:45 +0000
+++ plugin/info_schema/plugins.cc	2009-11-26 03:47:13 +0000
@@ -71,32 +71,28 @@
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Name",
-                                            SKIP_OPEN_TABLE));
+                                            "Name"));
 
   columns->push_back(new plugin::ColumnInfo("PLUGIN_TYPE",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "",
-                                            SKIP_OPEN_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("IS_ACTIVE",
                                             3,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "",
-                                            SKIP_OPEN_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("MODULE_NAME",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Name",
-                                            SKIP_OPEN_TABLE));
+                                            "Name"));
   return columns;
 }
 
@@ -141,9 +137,10 @@
 {
   Session *session;
   Table *table;
+  plugin::InfoSchemaTable *schema_table;
 public:
-  ShowPlugins(Session *session_arg, Table *table_arg)
-    : session(session_arg), table(table_arg) {}
+  ShowPlugins(Session *session_arg, Table *table_arg, plugin::InfoSchemaTable *sch_tab_arg)
+    : session(session_arg), table(table_arg), schema_table(sch_tab_arg) {}
 
   result_type operator() (argument_type plugin)
   {
@@ -151,6 +148,14 @@
 
     table->restoreRecordAsDefault();
 
+    /* mark fields that will be written to in the write bitset */
+    table->setWriteSet(0);
+    table->setWriteSet(1);
+    table->setWriteSet(2);
+    table->setWriteSet(3);
+    table->setWriteSet(4);
+    table->setWriteSet(5);
+
     table->field[0]->store(plugin.first.c_str(),
                            plugin.first.size(), cs);
 
@@ -169,22 +174,23 @@
     table->field[3]->store(plugin.second->getModuleName().c_str(),
                            plugin.second->getModuleName().size(), cs);
 
-    return schema_table_store_record(session, table);
+    schema_table->addRow(table->record[0], table->s->reclength);
+    return false;
   }
 };
 
-int PluginsISMethods::fillTable(Session *session, TableList *tables)
+int PluginsISMethods::fillTable(Session *session, 
+                                Table *table,
+                                plugin::InfoSchemaTable *schema_table)
 {
-  Table *table= tables->table;
-
   drizzled::plugin::Registry &registry= drizzled::plugin::Registry::singleton();
   const map<string, const drizzled::plugin::Plugin *> &plugin_map=
     registry.getPluginsMap();
   map<string, const drizzled::plugin::Plugin *>::const_iterator iter=
-    find_if(plugin_map.begin(), plugin_map.end(), ShowPlugins(session, table));
+    find_if(plugin_map.begin(), plugin_map.end(), ShowPlugins(session, table, schema_table));
   if (iter != plugin_map.end())
   {
     return 1;
   }
-  return (0);
+  return 0;
 }

=== modified file 'plugin/info_schema/plugins.h'
--- plugin/info_schema/plugins.h	2009-11-17 05:28:24 +0000
+++ plugin/info_schema/plugins.h	2009-11-26 03:47:13 +0000
@@ -33,7 +33,8 @@
 {
 public:
   virtual int fillTable(Session *session,
-                        TableList *tables);
+                        Table *table,
+                        drizzled::plugin::InfoSchemaTable *schema_table);
 };
 
 class PluginsIS

=== modified file 'plugin/info_schema/processlist.cc'
--- plugin/info_schema/processlist.cc	2009-11-18 21:40:45 +0000
+++ plugin/info_schema/processlist.cc	2009-11-26 03:47:13 +0000
@@ -77,64 +77,56 @@
                                             DRIZZLE_TYPE_LONGLONG,
                                             0,
                                             0,
-                                            "Id",
-                                            SKIP_OPEN_TABLE));
+                                            "Id"));
 
   columns->push_back(new plugin::ColumnInfo("USER",
                                             16,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "User",
-                                            SKIP_OPEN_TABLE));
+                                            "User"));
 
   columns->push_back(new plugin::ColumnInfo("HOST",
                                             LIST_PROCESS_HOST_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Host",
-                                            SKIP_OPEN_TABLE));
+                                            "Host"));
 
   columns->push_back(new plugin::ColumnInfo("DB",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             1,
-                                            "Db",
-                                            SKIP_OPEN_TABLE));
+                                            "Db"));
 
   columns->push_back(new plugin::ColumnInfo("COMMAND",
                                             16,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Command",
-                                            SKIP_OPEN_TABLE));
+                                            "Command"));
 
   columns->push_back(new plugin::ColumnInfo("TIME",
                                             7,
                                             DRIZZLE_TYPE_LONGLONG,
                                             0,
                                             0,
-                                            "Time",
-                                            SKIP_OPEN_TABLE));
+                                            "Time"));
 
   columns->push_back(new plugin::ColumnInfo("STATE",
                                             64,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             1,
-                                            "State",
-                                            SKIP_OPEN_TABLE));
+                                            "State"));
 
   columns->push_back(new plugin::ColumnInfo("INFO",
-                                            PROCESS_LIST_INFO_WIDTH,
+                                            16383,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             1,
-                                            "Info",
-                                            SKIP_OPEN_TABLE));
+                                            "Info"));
 
   return columns;
 }
@@ -175,9 +167,10 @@
   delete columns;
 }
 
-int ProcessListISMethods::fillTable(Session* session, TableList* tables)
+int ProcessListISMethods::fillTable(Session* session, 
+                                    Table *table,
+                                    plugin::InfoSchemaTable *schema_table)
 {
-  Table *table= tables->table;
   const CHARSET_INFO * const cs= system_charset_info;
   time_t now= time(NULL);
   size_t length;
@@ -202,6 +195,14 @@
         continue;
 
       table->restoreRecordAsDefault();
+      table->setWriteSet(0);
+      table->setWriteSet(1);
+      table->setWriteSet(2);
+      table->setWriteSet(3);
+      table->setWriteSet(4);
+      table->setWriteSet(5);
+      table->setWriteSet(6);
+      table->setWriteSet(7);
       /* ID */
       table->field[0]->store((int64_t) tmp->thread_id, true);
       /* USER */
@@ -254,11 +255,7 @@
         table->field[7]->set_notnull();
       }
 
-      if (schema_table_store_record(session, table))
-      {
-        pthread_mutex_unlock(&LOCK_thread_count);
-        return(1);
-      }
+      schema_table->addRow(table->record[0], table->s->reclength);
     }
   }
 

=== modified file 'plugin/info_schema/processlist.h'
--- plugin/info_schema/processlist.h	2009-11-17 17:54:59 +0000
+++ plugin/info_schema/processlist.h	2009-11-26 03:47:13 +0000
@@ -33,7 +33,8 @@
 {
 public:
   virtual int fillTable(Session *session,
-                        TableList *tables);
+                        Table *table,
+                        drizzled::plugin::InfoSchemaTable *schema_table);
 };
 
 class ProcessListIS

=== modified file 'plugin/info_schema/referential_constraints.cc'
--- plugin/info_schema/referential_constraints.cc	2009-11-18 21:40:45 +0000
+++ plugin/info_schema/referential_constraints.cc	2009-11-26 04:33:51 +0000
@@ -71,88 +71,77 @@
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             1,
-                                            "",
-                                            OPEN_FULL_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("CONSTRAINT_SCHEMA",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "",
-                                            OPEN_FULL_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("CONSTRAINT_NAME",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "",
-                                            OPEN_FULL_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("UNIQUE_CONSTRAINT_CATALOG",
                                             FN_REFLEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             1,
-                                            "",
-                                            OPEN_FULL_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("UNIQUE_CONSTRAINT_SCHEMA",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "",
-                                            OPEN_FULL_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("UNIQUE_CONSTRAINT_NAME",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             MY_I_S_MAYBE_NULL,
-                                            "",
-                                            OPEN_FULL_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("MATCH_OPTION",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "",
-                                            OPEN_FULL_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("UPDATE_RULE",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "",
-                                            OPEN_FULL_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("DELETE_RULE",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "",
-                                            OPEN_FULL_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("TABLE_NAME",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "",
-                                            OPEN_FULL_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("REFERENCED_TABLE_NAME",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "",
-                                            OPEN_FULL_TABLE));
+                                            ""));
 
   return columns;
 }
@@ -195,13 +184,13 @@
 }
 
 int
-RefConstraintsISMethods::processTable(Session *session, 
+RefConstraintsISMethods::processTable(plugin::InfoSchemaTable *store_table,
+                                      Session *session, 
                                       TableList *tables,
                                       Table *table, 
                                       bool res,
                                       LEX_STRING *db_name, 
                                       LEX_STRING *table_name)
-  const
 {
   const CHARSET_INFO * const cs= system_charset_info;
 
@@ -231,6 +220,15 @@
     while ((f_key_info= it++))
     {
       table->restoreRecordAsDefault();
+      table->setWriteSet(1);
+      table->setWriteSet(2);
+      table->setWriteSet(4);
+      table->setWriteSet(5);
+      table->setWriteSet(6);
+      table->setWriteSet(7);
+      table->setWriteSet(8);
+      table->setWriteSet(9);
+      table->setWriteSet(10);
       table->field[1]->store(db_name->str, db_name->length, cs);
       table->field[9]->store(table_name->str, table_name->length, cs);
       table->field[2]->store(f_key_info->forein_id->str,
@@ -254,10 +252,7 @@
                              f_key_info->update_method->length, cs);
       table->field[8]->store(f_key_info->delete_method->str,
                              f_key_info->delete_method->length, cs);
-      if (schema_table_store_record(session, table))
-      {
-        return 1;
-      }
+      store_table->addRow(table->record[0], table->s->reclength);
     }
   }
   return 0;

=== modified file 'plugin/info_schema/referential_constraints.h'
--- plugin/info_schema/referential_constraints.h	2009-11-17 18:13:13 +0000
+++ plugin/info_schema/referential_constraints.h	2009-11-24 22:20:36 +0000
@@ -45,9 +45,10 @@
    *
    * @return 0 on success; 1 on failure
    */
-  virtual int processTable(Session *session, TableList *tables,
+  virtual int processTable(drizzled::plugin::InfoSchemaTable *store_table,
+                           Session *session, TableList *tables,
                            Table *table, bool res, LEX_STRING *db_name,
-                           LEX_STRING *table_name) const;
+                           LEX_STRING *table_name);
 };
 
 class ReferentialConstraintsIS

=== modified file 'plugin/info_schema/schemata.cc'
--- plugin/info_schema/schemata.cc	2009-11-18 21:40:45 +0000
+++ plugin/info_schema/schemata.cc	2009-11-26 04:33:51 +0000
@@ -72,40 +72,35 @@
                                             DRIZZLE_TYPE_VARCHAR,
                                             0, 
                                             1, 
-                                            "", 
-                                            SKIP_OPEN_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("SCHEMA_NAME",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0, 
                                             0, 
-                                            "Database", 
-                                            SKIP_OPEN_TABLE));
+                                            "Database"));
 
   columns->push_back(new plugin::ColumnInfo("DEFAULT_CHARACTER_SET_NAME",
                                             64, 
                                             DRIZZLE_TYPE_VARCHAR, 
                                             0, 
                                             0, 
-                                            "",
-                                            SKIP_OPEN_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("DEFAULT_COLLATION_NAME",
                                             64, 
                                             DRIZZLE_TYPE_VARCHAR, 
                                             0, 
                                             0, 
-                                            "",
-                                            SKIP_OPEN_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("SQL_PATH",
                                             FN_REFLEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0, 
                                             1, 
-                                            "", 
-                                            SKIP_OPEN_TABLE));
+                                            ""));
 
   return columns;
 }
@@ -146,19 +141,26 @@
   delete columns;
 }
 
-static bool store_schema_schemata(Session* session, 
+static bool store_schema_schemata(Session *, 
                                   Table *table, 
                                   LEX_STRING *db_name,
-                                  const CHARSET_INFO * const cs)
+                                  const CHARSET_INFO * const cs,
+                                  plugin::InfoSchemaTable *schema_table)
 {
   table->restoreRecordAsDefault();
+  table->setWriteSet(1);
+  table->setWriteSet(2);
+  table->setWriteSet(3);
   table->field[1]->store(db_name->str, db_name->length, system_charset_info);
   table->field[2]->store(cs->csname, strlen(cs->csname), system_charset_info);
   table->field[3]->store(cs->name, strlen(cs->name), system_charset_info);
-  return schema_table_store_record(session, table);
+  schema_table->addRow(table->record[0], table->s->reclength);
+  return false;
 }
 
-int SchemataISMethods::fillTable(Session *session, TableList *tables)
+int SchemataISMethods::fillTable(Session *session, 
+                                 Table *table,
+                                 plugin::InfoSchemaTable *schema_table)
 {
   /*
     TODO: fill_schema_shemata() is called when new client is connected.
@@ -168,11 +170,14 @@
   LOOKUP_FIELD_VALUES lookup_field_vals;
   vector<LEX_STRING*> db_names;
   bool with_i_schema;
-  Table *table= tables->table;
   /* the WHERE condition */
   COND *cond= table->reginfo.join_tab->select_cond;
 
-  if (get_lookup_field_values(session, cond, tables, &lookup_field_vals))
+  if (get_lookup_field_values(session, 
+                              cond, 
+                              table->pos_in_table_list, 
+                              &lookup_field_vals,
+                              schema_table))
   {
     return 0;
   }
@@ -217,7 +222,7 @@
   {
     if (with_i_schema)       // information schema name is always first in list
     {
-      if (store_schema_schemata(session, table, *db_name, system_charset_info))
+      if (store_schema_schemata(session, table, *db_name, system_charset_info, schema_table))
       {
         return 1;
       }
@@ -227,7 +232,7 @@
     {
       const CHARSET_INFO *cs= get_default_db_collation((*db_name)->str);
 
-      if (store_schema_schemata(session, table, *db_name, cs))
+      if (store_schema_schemata(session, table, *db_name, cs, schema_table))
       {
         return 1;
       }

=== modified file 'plugin/info_schema/schemata.h'
--- plugin/info_schema/schemata.h	2009-11-17 18:35:55 +0000
+++ plugin/info_schema/schemata.h	2009-11-26 03:47:13 +0000
@@ -33,7 +33,8 @@
 {
 public:
   virtual int fillTable(Session *session,
-                        TableList *tables);
+                        Table *table,
+                        drizzled::plugin::InfoSchemaTable *schema_table);
   virtual int oldFormat(Session *session,
                         drizzled::plugin::InfoSchemaTable *schema_table) const;
 };

=== modified file 'plugin/info_schema/statistics.cc'
--- plugin/info_schema/statistics.cc	2009-11-18 21:40:45 +0000
+++ plugin/info_schema/statistics.cc	2009-11-25 16:55:42 +0000
@@ -72,128 +72,112 @@
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             1,
-                                            "",
-                                            OPEN_FRM_ONLY));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("TABLE_SCHEMA",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "",
-                                            OPEN_FRM_ONLY));
+                                            ""));
   
   columns->push_back(new plugin::ColumnInfo("TABLE_NAME",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Table",
-                                            OPEN_FRM_ONLY));
+                                            "Table"));
 
   columns->push_back(new plugin::ColumnInfo("NON_UNIQUE",
                                             1,
                                             DRIZZLE_TYPE_LONGLONG,
                                             0,
                                             0,
-                                            "Non_unique",
-                                            OPEN_FRM_ONLY));
+                                            "Non_unique"));
 
   columns->push_back(new plugin::ColumnInfo("INDEX_SCHEMA",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "",
-                                            OPEN_FRM_ONLY));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("INDEX_NAME",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Key_name",
-                                            OPEN_FRM_ONLY));
+                                            "Key_name"));
 
   columns->push_back(new plugin::ColumnInfo("SEQ_IN_INDEX",
                                             2,
                                             DRIZZLE_TYPE_LONGLONG,
                                             0,
                                             0,
-                                            "Seq_in_index",
-                                            OPEN_FRM_ONLY));
+                                            "Seq_in_index"));
 
   columns->push_back(new plugin::ColumnInfo("COLUMN_NAME",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Column_name",
-                                            OPEN_FRM_ONLY));
+                                            "Column_name"));
 
   columns->push_back(new plugin::ColumnInfo("COLLATION",
                                             1,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             1,
-                                            "Collation",
-                                            OPEN_FRM_ONLY));
+                                            "Collation"));
 
   columns->push_back(new plugin::ColumnInfo("CARDINALITY",
                                             MY_INT64_NUM_DECIMAL_DIGITS,
                                             DRIZZLE_TYPE_LONGLONG,
                                             0,
                                             1,
-                                            "Cardinality",
-                                            OPEN_FULL_TABLE));
+                                            "Cardinality"));
 
   columns->push_back(new plugin::ColumnInfo("SUB_PART",
                                             3,
                                             DRIZZLE_TYPE_LONGLONG,
                                             0,
                                             1,
-                                            "Sub_part",
-                                            OPEN_FRM_ONLY));
+                                            "Sub_part"));
 
   columns->push_back(new plugin::ColumnInfo("PACKED",
                                             10,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             1,
-                                            "Packed",
-                                            OPEN_FRM_ONLY));
+                                            "Packed"));
 
   columns->push_back(new plugin::ColumnInfo("NULLABLE",
                                             3,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Null",
-                                            OPEN_FRM_ONLY));
+                                            "Null"));
 
   columns->push_back(new plugin::ColumnInfo("INDEX_TYPE",
                                             16,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Index_type",
-                                            OPEN_FULL_TABLE));
+                                            "Index_type"));
 
   columns->push_back(new plugin::ColumnInfo("COMMENT",
                                             16,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             1,
-                                            "Comment",
-                                            OPEN_FRM_ONLY));
+                                            "Comment"));
 
   columns->push_back(new plugin::ColumnInfo("INDEX_COMMENT",
                                             INDEX_COMMENT_MAXLEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Index_Comment",
-                                            OPEN_FRM_ONLY));
+                                            "Index_Comment"));
 
   return columns;
 }
@@ -235,12 +219,13 @@
   delete columns;
 }
 
-int StatsISMethods::processTable(Session *session, 
+int StatsISMethods::processTable(plugin::InfoSchemaTable *store_table,
+                                 Session *session, 
                                  TableList *tables,
                                  Table *table, 
                                  bool res,
                                  LEX_STRING *db_name,
-                                 LEX_STRING *table_name) const
+                                 LEX_STRING *table_name)
 {
   const CHARSET_INFO * const cs= system_charset_info;
   if (res)
@@ -280,6 +265,19 @@
       for (uint32_t j= 0; j < key_info->key_parts; j++, key_part++)
       {
         table->restoreRecordAsDefault();
+        table->setWriteSet(1);
+        table->setWriteSet(2);
+        table->setWriteSet(3);
+        table->setWriteSet(4);
+        table->setWriteSet(5);
+        table->setWriteSet(6);
+        table->setWriteSet(8);
+        table->setWriteSet(9);
+        table->setWriteSet(10);
+        table->setWriteSet(12);
+        table->setWriteSet(13);
+        table->setWriteSet(14);
+        table->setWriteSet(15);
         table->field[1]->store(db_name->str, db_name->length, cs);
         table->field[2]->store(table_name->str, table_name->length, cs);
         table->field[3]->store((int64_t) ((key_info->flags &
@@ -337,10 +335,7 @@
           table->field[15]->store(key_info->comment.str,
                                   key_info->comment.length, cs);
         }
-        if (schema_table_store_record(session, table))
-        {
-          return 1;
-        }
+        store_table->addRow(table->record[0], table->s->reclength);
       }
     }
   }

=== modified file 'plugin/info_schema/statistics.h'
--- plugin/info_schema/statistics.h	2009-11-18 04:33:30 +0000
+++ plugin/info_schema/statistics.h	2009-11-24 22:20:36 +0000
@@ -32,9 +32,10 @@
 class StatsISMethods : public drizzled::plugin::InfoSchemaMethods
 {
 public:
-  virtual int processTable(Session *session, TableList *tables,
+  virtual int processTable(drizzled::plugin::InfoSchemaTable *store_table,
+                           Session *session, TableList *tables,
                            Table *table, bool res, LEX_STRING *db_name,
-                           LEX_STRING *table_name) const;
+                           LEX_STRING *table_name);
 };
 
 class StatisticsIS

=== modified file 'plugin/info_schema/status.cc'
--- plugin/info_schema/status.cc	2009-11-18 21:40:45 +0000
+++ plugin/info_schema/status.cc	2009-11-26 03:47:13 +0000
@@ -74,16 +74,14 @@
                                                    DRIZZLE_TYPE_VARCHAR,
                                                    0,
                                                    0,
-                                                   "Variable_name",
-                                                   SKIP_OPEN_TABLE));
+                                                   "Variable_name"));
 
   status_columns->push_back(new plugin::ColumnInfo("VARIABLE_VALUE",
                                                    16300,
                                                    DRIZZLE_TYPE_VARCHAR,
                                                    0,
                                                    1,
-                                                   "Value",
-                                                   SKIP_OPEN_TABLE));
+                                                   "Value"));
 
   return status_columns;
 }
@@ -178,13 +176,15 @@
   delete status_table;
 }
 
-int StatusISMethods::fillTable(Session *session, TableList *tables)
+int StatusISMethods::fillTable(Session *session, 
+                               Table *table,
+                               plugin::InfoSchemaTable *schema_table)
 {
   LEX *lex= session->lex;
   const char *wild= lex->wild ? lex->wild->ptr() : NULL;
   int res= 0;
   STATUS_VAR *tmp1, tmp;
-  const string schema_table_name= tables->schema_table->getTableName();
+  const string schema_table_name= schema_table->getTableName();
   enum enum_var_type option_type;
   bool upper_case_names= (schema_table_name.compare("STATUS") != 0);
 
@@ -218,8 +218,9 @@
   }
   res= show_status_array(session, wild,
                          getFrontOfStatusVars(),
-                         option_type, tmp1, "", tables->table,
-                         upper_case_names);
+                         option_type, tmp1, "", table,
+                         upper_case_names,
+                         schema_table);
   pthread_mutex_unlock(&LOCK_status);
   return res;
 }

=== modified file 'plugin/info_schema/status.h'
--- plugin/info_schema/status.h	2009-11-18 05:15:57 +0000
+++ plugin/info_schema/status.h	2009-11-26 03:47:13 +0000
@@ -33,7 +33,8 @@
 {
 public:
   virtual int fillTable(Session *session, 
-                        TableList *tables);
+                        Table *table,
+                        drizzled::plugin::InfoSchemaTable *schema_table);
 };
 
 class GlobalStatusIS

=== modified file 'plugin/info_schema/table_constraints.cc'
--- plugin/info_schema/table_constraints.cc	2009-11-18 21:40:45 +0000
+++ plugin/info_schema/table_constraints.cc	2009-11-26 04:33:51 +0000
@@ -71,48 +71,42 @@
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             1,
-                                            "",
-                                            OPEN_FULL_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("CONSTRAINT_SCHEMA",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "",
-                                            OPEN_FULL_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("CONSTRAINT_NAME",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "",
-                                            OPEN_FULL_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("TABLE_SCHEMA",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "",
-                                            OPEN_FULL_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("TABLE_NAME",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "",
-                                            OPEN_FULL_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("CONSTRAINT_TYPE",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "",
-                                            OPEN_FULL_TABLE));
+                                            ""));
   return columns;
 }
 
@@ -153,31 +147,38 @@
   delete columns;
 }
 
-static bool store_constraints(Session *session, 
-                              Table *table, 
+static bool store_constraints(Table *table, 
                               LEX_STRING *db_name,
                               LEX_STRING *table_name, 
                               const char *key_name,
                               uint32_t key_len, 
                               const char *con_type, 
-                              uint32_t con_len)
+                              uint32_t con_len,
+                              plugin::InfoSchemaTable *schema_table)
 {
   const CHARSET_INFO * const cs= system_charset_info;
   table->restoreRecordAsDefault();
+  table->setWriteSet(1);
+  table->setWriteSet(2);
+  table->setWriteSet(3);
+  table->setWriteSet(4);
+  table->setWriteSet(5);
   table->field[1]->store(db_name->str, db_name->length, cs);
   table->field[2]->store(key_name, key_len, cs);
   table->field[3]->store(db_name->str, db_name->length, cs);
   table->field[4]->store(table_name->str, table_name->length, cs);
   table->field[5]->store(con_type, con_len, cs);
-  return schema_table_store_record(session, table);
+  schema_table->addRow(table->record[0], table->s->reclength);
+  return false;
 }
 
-int TabConstraintsISMethods::processTable(Session *session, 
+int TabConstraintsISMethods::processTable(plugin::InfoSchemaTable *store_table,
+                                          Session *session, 
                                           TableList *tables,
                                           Table *table, 
                                           bool res,
                                           LEX_STRING *db_name,
-                                          LEX_STRING *table_name) const
+                                          LEX_STRING *table_name)
 {
   if (res)
   {
@@ -209,26 +210,26 @@
 
       if (i == primary_key && is_primary_key(key_info))
       {
-        if (store_constraints(session, 
-                              table, 
+        if (store_constraints(table, 
                               db_name, 
                               table_name, 
                               key_info->name,
                               strlen(key_info->name),
-                              STRING_WITH_LEN("PRIMARY KEY")))
+                              STRING_WITH_LEN("PRIMARY KEY"),
+                              store_table))
         {
           return 1;
         }
       }
       else if (key_info->flags & HA_NOSAME)
       {
-        if (store_constraints(session, 
-                              table, 
+        if (store_constraints(table, 
                               db_name, 
                               table_name, 
                               key_info->name,
                               strlen(key_info->name),
-                              STRING_WITH_LEN("UNIQUE")))
+                              STRING_WITH_LEN("UNIQUE"),
+                              store_table))
         {
           return 1;
         }
@@ -240,13 +241,13 @@
     List_iterator_fast<FOREIGN_KEY_INFO> it(f_key_list);
     while ((f_key_info= it++))
     {
-      if (store_constraints(session, 
-                            table, 
+      if (store_constraints(table, 
                             db_name, 
                             table_name,
                             f_key_info->forein_id->str,
                             strlen(f_key_info->forein_id->str),
-                            "FOREIGN KEY", 11))
+                            "FOREIGN KEY", 11,
+                            store_table))
       {
         return 1;
       }

=== modified file 'plugin/info_schema/table_constraints.h'
--- plugin/info_schema/table_constraints.h	2009-11-18 02:35:54 +0000
+++ plugin/info_schema/table_constraints.h	2009-11-24 22:20:36 +0000
@@ -32,9 +32,10 @@
 class TabConstraintsISMethods : public drizzled::plugin::InfoSchemaMethods
 {
 public:
-  virtual int processTable(Session *session, TableList *tables,
+  virtual int processTable(drizzled::plugin::InfoSchemaTable *store_table,
+                           Session *session, TableList *tables,
                            Table *table, bool res, LEX_STRING *db_name,
-                           LEX_STRING *table_name) const;
+                           LEX_STRING *table_name);
 };
 
 class TableConstraintsIS

=== modified file 'plugin/info_schema/table_names.cc'
--- plugin/info_schema/table_names.cc	2009-11-18 21:40:45 +0000
+++ plugin/info_schema/table_names.cc	2009-11-25 16:55:42 +0000
@@ -72,32 +72,28 @@
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             1,
-                                            "",
-                                            SKIP_OPEN_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("TABLE_SCHEMA",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "",
-                                            SKIP_OPEN_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("TABLE_NAME",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Tables_in_",
-                                            SKIP_OPEN_TABLE));
+                                            "Tables_in_"));
 
   columns->push_back(new plugin::ColumnInfo("TABLE_TYPE",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Table_type",
-                                            OPEN_FRM_ONLY));
+                                            "Table_type"));
   return columns;
 }
 

=== modified file 'plugin/info_schema/tables.cc'
--- plugin/info_schema/tables.cc	2009-11-18 21:40:45 +0000
+++ plugin/info_schema/tables.cc	2009-11-26 04:33:51 +0000
@@ -72,168 +72,147 @@
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             1,
-                                            "",
-                                            SKIP_OPEN_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("TABLE_SCHEMA",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "",
-                                            SKIP_OPEN_TABLE));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("TABLE_NAME",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Name",
-                                            SKIP_OPEN_TABLE));
+                                            "Name"));
 
   columns->push_back(new plugin::ColumnInfo("TABLE_TYPE",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "",
-                                            OPEN_FRM_ONLY));
+                                            ""));
 
   columns->push_back(new plugin::ColumnInfo("ENGINE",
                                             NAME_CHAR_LEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             1,
-                                            "Engine",
-                                            OPEN_FRM_ONLY));
+                                            "Engine"));
 
   columns->push_back(new plugin::ColumnInfo("VERSION",
                                             MY_INT64_NUM_DECIMAL_DIGITS,
                                             DRIZZLE_TYPE_LONGLONG,
                                             0,
                                             (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED),
-                                            "Version",
-                                            OPEN_FRM_ONLY));
+                                            "Version"));
 
   columns->push_back(new plugin::ColumnInfo("ROW_FORMAT",
                                             10,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             1,
-                                            "Row_format",
-                                            OPEN_FULL_TABLE));
+                                            "Row_format"));
 
   columns->push_back(new plugin::ColumnInfo("TABLE_ROWS",
                                             MY_INT64_NUM_DECIMAL_DIGITS,
                                             DRIZZLE_TYPE_LONGLONG,
                                             0,
                                             (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED),
-                                            "Rows",
-                                            OPEN_FULL_TABLE));
+                                            "Rows"));
 
   columns->push_back(new plugin::ColumnInfo("AVG_ROW_LENGTH",
                                             MY_INT64_NUM_DECIMAL_DIGITS,
                                             DRIZZLE_TYPE_LONGLONG,
                                             0,
                                             (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED),
-                                            "Avg_row_length",
-                                            OPEN_FULL_TABLE));
+                                            "Avg_row_length"));
 
   columns->push_back(new plugin::ColumnInfo("DATA_LENGTH",
                                             MY_INT64_NUM_DECIMAL_DIGITS,
                                             DRIZZLE_TYPE_LONGLONG,
                                             0,
                                             (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED),
-                                            "Data_length",
-                                            OPEN_FULL_TABLE));
+                                            "Data_length"));
 
   columns->push_back(new plugin::ColumnInfo("MAX_DATA_LENGTH",
                                             MY_INT64_NUM_DECIMAL_DIGITS,
                                             DRIZZLE_TYPE_LONGLONG,
                                             0,
                                             (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED),
-                                            "Max_data_length",
-                                            OPEN_FULL_TABLE));
+                                            "Max_data_length"));
 
   columns->push_back(new plugin::ColumnInfo("INDEX_LENGTH",
                                             MY_INT64_NUM_DECIMAL_DIGITS,
                                             DRIZZLE_TYPE_LONGLONG,
                                             0,
                                             (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED),
-                                            "Index_length",
-                                            OPEN_FULL_TABLE));
+                                            "Index_length"));
 
   columns->push_back(new plugin::ColumnInfo("DATA_FREE",
                                             MY_INT64_NUM_DECIMAL_DIGITS,
                                             DRIZZLE_TYPE_LONGLONG,
                                             0,
                                             (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED),
-                                            "Data_free",
-                                            OPEN_FULL_TABLE));
+                                            "Data_free"));
 
   columns->push_back(new plugin::ColumnInfo("AUTO_INCREMENT",
                                             MY_INT64_NUM_DECIMAL_DIGITS,
                                             DRIZZLE_TYPE_LONGLONG,
                                             0,
                                             (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED),
-                                            "Auto_increment",
-                                            OPEN_FULL_TABLE));
+                                            "Auto_increment"));
 
   columns->push_back(new plugin::ColumnInfo("CREATE_TIME",
                                             0,
                                             DRIZZLE_TYPE_DATETIME,
                                             0,
                                             1,
-                                            "Create_time",
-                                            OPEN_FULL_TABLE));
+                                            "Create_time"));
 
   columns->push_back(new plugin::ColumnInfo("UPDATE_TIME",
                                             0,
                                             DRIZZLE_TYPE_DATETIME,
                                             0,
                                             1,
-                                            "Update_time",
-                                            OPEN_FULL_TABLE));
+                                            "Update_time"));
 
   columns->push_back(new plugin::ColumnInfo("CHECK_TIME",
                                             0,
                                             DRIZZLE_TYPE_DATETIME,
                                             0,
                                             1,
-                                            "Check_time",
-                                            OPEN_FULL_TABLE));
+                                            "Check_time"));
 
   columns->push_back(new plugin::ColumnInfo("TABLE_COLLATION",
                                             64,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             1,
-                                            "Collation",
-                                            OPEN_FRM_ONLY));
+                                            "Collation"));
 
   columns->push_back(new plugin::ColumnInfo("CHECKSUM",
                                             MY_INT64_NUM_DECIMAL_DIGITS,
                                             DRIZZLE_TYPE_LONGLONG,
                                             0,
                                             (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED),
-                                            "Checksum",
-                                            OPEN_FULL_TABLE));
+                                            "Checksum"));
 
   columns->push_back(new plugin::ColumnInfo("CREATE_OPTIONS",
                                             255,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             1,
-                                            "Create_options",
-                                            OPEN_FRM_ONLY));
+                                            "Create_options"));
 
   columns->push_back(new plugin::ColumnInfo("TABLE_COMMENT",
                                             TABLE_COMMENT_MAXLEN,
                                             DRIZZLE_TYPE_VARCHAR,
                                             0,
                                             0,
-                                            "Comment",
-                                            OPEN_FRM_ONLY));
+                                            "Comment"));
 
   return columns;
 }
@@ -275,18 +254,38 @@
   delete columns;
 }
 
-int TablesISMethods::processTable(Session *session, 
+int TablesISMethods::processTable(plugin::InfoSchemaTable *store_table,
+                                  Session *session, 
                                   TableList *tables,
                                   Table *table, 
                                   bool res,
                                   LEX_STRING *db_name,
-                                  LEX_STRING *table_name) const
+                                  LEX_STRING *table_name)
 {
   const char *tmp_buff= NULL;
   DRIZZLE_TIME time;
   const CHARSET_INFO * const cs= system_charset_info;
 
   table->restoreRecordAsDefault();
+  table->setWriteSet(1);
+  table->setWriteSet(2);
+  table->setWriteSet(3);
+  table->setWriteSet(4);
+  table->setWriteSet(5);
+  table->setWriteSet(6);
+  table->setWriteSet(7);
+  table->setWriteSet(8);
+  table->setWriteSet(9);
+  table->setWriteSet(11);
+  table->setWriteSet(12);
+  table->setWriteSet(13);
+  table->setWriteSet(14);
+  table->setWriteSet(15);
+  table->setWriteSet(16);
+  table->setWriteSet(17);
+  table->setWriteSet(18);
+  table->setWriteSet(19);
+  table->setWriteSet(20);
   table->field[1]->store(db_name->str, db_name->length, cs);
   table->field[2]->store(table_name->str, table_name->length, cs);
   if (res)
@@ -295,14 +294,7 @@
       there was errors during opening tables
     */
     const char *error= session->is_error() ? session->main_da.message() : "";
-    if (tables->schema_table)
-    {
-      table->field[3]->store(STRING_WITH_LEN("SYSTEM VIEW"), cs);
-    }
-    else
-    {
-      table->field[3]->store(STRING_WITH_LEN("BASE Table"), cs);
-    }
+    table->field[3]->store(STRING_WITH_LEN("BASE Table"), cs);
     table->field[20]->store(error, strlen(error), cs);
     session->clear_error();
   }
@@ -408,11 +400,8 @@
         break;
       }
       table->field[6]->store(tmp_buff, strlen(tmp_buff), cs);
-      if (! tables->schema_table)
-      {
-        table->field[7]->store((int64_t) cursor->stats.records, true);
-        table->field[7]->set_notnull();
-      }
+      table->field[7]->store((int64_t) cursor->stats.records, true);
+      table->field[7]->set_notnull();
       table->field[8]->store((int64_t) cursor->stats.mean_rec_length, true);
       table->field[9]->store((int64_t) cursor->stats.data_file_length, true);
       if (cursor->stats.max_data_file_length)
@@ -455,6 +444,7 @@
       }
     }
   }
-  return (schema_table_store_record(session, table));
+  store_table->addRow(table->record[0], table->s->reclength);
+  return false;
 }
 

=== modified file 'plugin/info_schema/tables.h'
--- plugin/info_schema/tables.h	2009-11-18 02:55:28 +0000
+++ plugin/info_schema/tables.h	2009-11-24 22:20:36 +0000
@@ -32,9 +32,10 @@
 class TablesISMethods : public drizzled::plugin::InfoSchemaMethods
 {
 public:
-  virtual int processTable(Session *session, TableList *tables,
+  virtual int processTable(drizzled::plugin::InfoSchemaTable *store_table,
+                           Session *session, TableList *tables,
                            Table *table, bool res, LEX_STRING *db_name,
-                           LEX_STRING *table_name) const;
+                           LEX_STRING *table_name);
 };
 
 class TablesIS

=== modified file 'plugin/info_schema/variables.cc'
--- plugin/info_schema/variables.cc	2009-11-18 05:30:00 +0000
+++ plugin/info_schema/variables.cc	2009-11-26 03:47:13 +0000
@@ -137,12 +137,14 @@
   delete var_table;
 }
 
-int VariablesISMethods::fillTable(Session *session, TableList *tables)
+int VariablesISMethods::fillTable(Session *session, 
+                                  Table *table,
+                                  plugin::InfoSchemaTable *schema_table)
 {
   int res= 0;
   LEX *lex= session->lex;
   const char *wild= lex->wild ? lex->wild->ptr() : NULL;
-  const string schema_table_name= tables->schema_table->getTableName();
+  const string schema_table_name= schema_table->getTableName();
   enum enum_var_type option_type= OPT_SESSION;
   bool upper_case_names= (schema_table_name.compare("VARIABLES") != 0);
   bool sorted_vars= (schema_table_name.compare("VARIABLES") == 0);
@@ -155,7 +157,7 @@
 
   pthread_rwlock_rdlock(&LOCK_system_variables_hash);
   res= show_status_array(session, wild, enumerate_sys_vars(session, sorted_vars),
-                         option_type, NULL, "", tables->table, upper_case_names);
+                         option_type, NULL, "", table, upper_case_names, schema_table);
   pthread_rwlock_unlock(&LOCK_system_variables_hash);
   return res;
 }

=== modified file 'plugin/info_schema/variables.h'
--- plugin/info_schema/variables.h	2009-11-18 05:15:57 +0000
+++ plugin/info_schema/variables.h	2009-11-26 03:47:13 +0000
@@ -33,7 +33,8 @@
 {
 public:
   virtual int fillTable(Session *session, 
-                        TableList *tables);
+                        Table *table,
+                        drizzled::plugin::InfoSchemaTable *schema_table);
 };
 
 

=== modified file 'plugin/information_engine/information_cursor.cc'
--- plugin/information_engine/information_cursor.cc	2009-11-17 04:16:37 +0000
+++ plugin/information_engine/information_cursor.cc	2009-11-29 05:53:07 +0000
@@ -1,17 +1,22 @@
-/* Copyright (C) 2005 MySQL AB
-
-  This program is free software; you can redistribute it and/or modify
-  it under the terms of the GNU General Public License as published by
-  the Free Software Foundation; version 2 of the License.
-
-  This program is distributed in the hope that it will be useful,
-  but WITHOUT ANY WARRANTY; without even the implied warranty of
-  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-  GNU General Public License for more details.
-
-  You should have received a copy of the GNU General Public License
-  along with this program; if not, write to the Free Software
-  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2009 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
 
 #include <plugin/information_engine/information_cursor.h>
 #include <drizzled/session.h>
@@ -38,7 +43,10 @@
 
 int InformationCursor::open(const char *name, int, uint32_t)
 {
-  share= ((InformationEngine *)engine)->getShare(name);
+  string tab_name(name);
+  string i_s_prefix("./information_schema/");
+  tab_name.erase(0, i_s_prefix.length());
+  share= ((InformationEngine *)engine)->getShare(tab_name);
 
   assert(share);
   thr_lock_data_init(&share->lock, &lock, NULL);
@@ -55,12 +63,15 @@
 
 int InformationCursor::rnd_init(bool)
 {
-  TableList *tmp= table->pos_in_table_list;
   plugin::InfoSchemaTable *sch_table= share->getInfoSchemaTable();
   if (sch_table)
   {
+    if (! sch_table->getRows().empty())
+    {
+      sch_table->clearRows();
+    }
     sch_table->fillTable(ha_session(),
-                         tmp);
+                         table);
     iter= sch_table->getRows().begin();
   }
   return 0;
@@ -80,32 +91,59 @@
     return 0;
   }
 
-  sch_table->clearRows();
-
   return HA_ERR_END_OF_FILE;
 }
 
-
-int InformationCursor::rnd_pos(unsigned char *, unsigned char *)
-{
-  assert(1);
+class FindRowByChecksum
+{
+  uint32_t checksum;
+public:
+  FindRowByChecksum(uint32_t in_crc)
+    :
+      checksum(in_crc)
+  {}
+
+  inline bool operator()(const plugin::InfoSchemaRecord *rec) const
+  {
+    return rec->checksumMatches(checksum);
+  }
+};
+
+void InformationCursor::position(const unsigned char *record)
+{
+  /* compute a hash of the row */
+  uint32_t cs= drizzled::hash::crc32((const char *) record, table->s->reclength);
+  /* copy the hash into ref */
+  memcpy(ref, &cs, sizeof(uint32_t));
+}
+
+int InformationCursor::rnd_pos(unsigned char *buf, unsigned char *pos)
+{
+  ha_statistic_increment(&SSV::ha_read_rnd_count);
+  /* get the checksum */
+  uint32_t cs;
+  memcpy(&cs, pos, sizeof(uint32_t));
+
+  /* search for that data */
+  plugin::InfoSchemaTable *sch_table= share->getInfoSchemaTable();
+  plugin::InfoSchemaTable::Rows::iterator it= find_if(sch_table->getRows().begin(),
+                                                      sch_table->getRows().end(),
+                                                      FindRowByChecksum(cs));
+  if (it != sch_table->getRows().end())
+  {
+    (*it)->copyRecordInto(buf);
+  }
 
   return 0;
 }
 
 
-void InformationCursor::position(const unsigned char *)
-{
-  assert(1);
-}
-
-
 int InformationCursor::info(uint32_t flag)
 {
   memset(&stats, 0, sizeof(stats));
   if (flag & HA_STATUS_AUTO)
     stats.auto_increment_value= 1;
-  return(0);
+  return 0;
 }
 
 

=== modified file 'plugin/information_engine/information_cursor.h'
--- plugin/information_engine/information_cursor.h	2009-11-16 20:30:19 +0000
+++ plugin/information_engine/information_cursor.h	2009-11-29 05:53:07 +0000
@@ -1,18 +1,22 @@
-/* Copyright (C) 2005 MySQL AB
-
-  This program is free software; you can redistribute it and/or modify
-  it under the terms of the GNU General Public License as published by
-  the Free Software Foundation; version 2 of the License.
-
-  This program is distributed in the hope that it will be useful,
-  but WITHOUT ANY WARRANTY; without even the implied warranty of
-  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-  GNU General Public License for more details.
-
-  You should have received a copy of the GNU General Public License
-  along with this program; if not, write to the Free Software
-  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
-
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2009 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
 
 #ifndef PLUGIN_INFORMATION_ENGINE_INFORMATION_CURSOR_H
 #define PLUGIN_INFORMATION_ENGINE_INFORMATION_CURSOR_H
@@ -36,14 +40,44 @@
   ~InformationCursor() {}
 
   uint32_t index_flags(uint32_t inx, uint32_t part, bool all_parts) const;
-  /* The following defines can be increased if necessary */
+
   int open(const char *name, int mode, uint32_t test_if_locked);
+
   int close(void);
+
   int rnd_init(bool scan);
+
+  /* get the next row and copy it into buf */
   int rnd_next(unsigned char *buf);
-  int rnd_pos(unsigned char * buf, unsigned char *pos);
+
+  /* locate row pointed to by pos, copy it into buf */
+  int rnd_pos(unsigned char *buf, unsigned char *pos);
+
+  /* record position of a record for reordering */
   void position(const unsigned char *record);
+
   int info(uint32_t flag);
+
+  /**
+   * @return an upper bound estimate for the number of rows in the table
+   */
+  ha_rows estimate_rows_upper_bound()
+  {
+    if (share)
+    {
+      drizzled::plugin::InfoSchemaTable *sch_table= share->getInfoSchemaTable();
+      if (sch_table)
+      {
+        if (! sch_table->getRows().empty())
+        {
+          /* we multiply by 3 here to ensure enough memory is allocated for sort buffers */
+          return (3 * sch_table->getRows().size());
+        }
+      }
+    }
+    return HA_POS_ERROR;
+  }
+
   THR_LOCK_DATA **store_lock(Session *session,
                              THR_LOCK_DATA **to,
                              enum thr_lock_type lock_type);

=== modified file 'plugin/information_engine/information_engine.cc'
--- plugin/information_engine/information_engine.cc	2009-11-17 07:21:27 +0000
+++ plugin/information_engine/information_engine.cc	2009-11-30 17:52:54 +0000
@@ -1,17 +1,22 @@
-/* Copyright (C) 2005 MySQL AB
-
-  This program is free software; you can redistribute it and/or modify
-  it under the terms of the GNU General Public License as published by
-  the Free Software Foundation; version 2 of the License.
-
-  This program is distributed in the hope that it will be useful,
-  but WITHOUT ANY WARRANTY; without even the implied warranty of
-  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-  GNU General Public License for more details.
-
-  You should have received a copy of the GNU General Public License
-  along with this program; if not, write to the Free Software
-  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2009 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
 
 #include <plugin/information_engine/information_engine.h>
 #include <drizzled/session.h>
@@ -33,13 +38,15 @@
 
 
 int InformationEngine::doGetTableDefinition(Session &,
-                                            const char *,
-                                            const char *,
-                                            const char *table_name,
+                                            const char *path,
+                                            const char *,
+                                            const char *,
                                             const bool,
                                             message::Table *table_proto)
 {
-  if (! table_name)
+  string tab_name(path);
+  string i_s_prefix("./information_schema/");
+  if (tab_name.compare(0, i_s_prefix.length(), i_s_prefix) != 0)
   {
     return ENOENT;
   }
@@ -49,14 +56,15 @@
     return EEXIST;
   }
 
-  plugin::InfoSchemaTable *schema_table= plugin::InfoSchemaTable::getTable(table_name);
+  tab_name.erase(0, i_s_prefix.length());
+  plugin::InfoSchemaTable *schema_table= plugin::InfoSchemaTable::getTable(tab_name.c_str());
 
   if (! schema_table)
   {
     return ENOENT;
   }
 
-  table_proto->set_name(table_name);
+  table_proto->set_name(tab_name);
   table_proto->set_type(message::Table::STANDARD);
 
   message::Table::StorageEngine *protoengine= table_proto->mutable_engine();
@@ -87,6 +95,11 @@
       field_options->set_default_null(true);
       field_constraints->set_is_nullable(true);
     }
+    else
+    {
+      field_options->set_default_null(false);
+      field_constraints->set_is_nullable(false);
+    }
 
     if (column->getFlags() & MY_I_S_UNSIGNED)
     {
@@ -163,7 +176,7 @@
 
 InformationEngine::Share *InformationEngine::getShare(const string &name_arg)
 {
-  InformationEngine::Share *share;
+  InformationEngine::Share *share= NULL;
   pthread_mutex_lock(&mutex);
 
   OpenTables::iterator it= open_tables.find(name_arg);
@@ -187,8 +200,9 @@
     }
 
     Record &value= *(returned.first);
-
     share= &(value.second);
+    share->setInfoSchemaTable(name_arg);
+    share->initThreadLock();
   }
 
 
@@ -207,6 +221,7 @@
   if (share->getUseCount() == 0)
   {
     open_tables.erase(share->getName());
+    share->deinitThreadLock();
   }
 
   pthread_mutex_unlock(&mutex);

=== modified file 'plugin/information_engine/information_engine.h'
--- plugin/information_engine/information_engine.h	2009-11-19 19:08:33 +0000
+++ plugin/information_engine/information_engine.h	2009-11-30 17:52:54 +0000
@@ -1,18 +1,22 @@
-/* Copyright (C) 2005 MySQL AB
-
-  This program is free software; you can redistribute it and/or modify
-  it under the terms of the GNU General Public License as published by
-  the Free Software Foundation; version 2 of the License.
-
-  This program is distributed in the hope that it will be useful,
-  but WITHOUT ANY WARRANTY; without even the implied warranty of
-  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-  GNU General Public License for more details.
-
-  You should have received a copy of the GNU General Public License
-  along with this program; if not, write to the Free Software
-  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
-
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2009 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
 
 #ifndef PLUGIN_INFORMATION_ENGINE_INFORMATION_ENGINE_H
 #define PLUGIN_INFORMATION_ENGINE_INFORMATION_ENGINE_H
@@ -33,7 +37,6 @@
     : drizzled::plugin::StorageEngine(name_arg,
                                       HTON_ALTER_NOT_SUPPORTED |
                                       HTON_HIDDEN |
-                                      HTON_NOT_USER_SELECTABLE |
                                       HTON_TEMPORARY_NOT_SUPPORTED)
   {
     pthread_mutex_init(&mutex, NULL);
@@ -61,11 +64,17 @@
     Share(const std::string &in_name) :
       count(1)
     {
+      table= drizzled::plugin::InfoSchemaTable::getTable(in_name.c_str());
+    }
+
+    ~Share()  {}
+
+    void initThreadLock()
+    {
       thr_lock_init(&lock);
-      table= drizzled::plugin::InfoSchemaTable::getTable(in_name.c_str());
     }
 
-    ~Share() 
+    void deinitThreadLock()
     {
       thr_lock_delete(&lock);
     }
@@ -107,8 +116,17 @@
     }
 
     /**
+     * Set the I_S table associated with this share.
+     * @param[in] name the name of the I_S table
+     */
+    void setInfoSchemaTable(const std::string &name)
+    {
+      table= drizzled::plugin::InfoSchemaTable::getTable(name.c_str());
+    }
+
+    /**
      * @return the I_S table associated with this share.
-   */
+     */
     drizzled::plugin::InfoSchemaTable *getInfoSchemaTable()
     {
       return table;

=== modified file 'plugin/innobase/handler/i_s.cc'
--- plugin/innobase/handler/i_s.cc	2009-10-31 00:17:15 +0000
+++ plugin/innobase/handler/i_s.cc	2009-11-26 04:33:51 +0000
@@ -112,7 +112,6 @@
 */
 
 /* XXX these are defined in mysql_priv.h inside #ifdef DRIZZLE_SERVER */
-bool schema_table_store_record(Session *session, Table *table);
 void localtime_to_TIME(DRIZZLE_TIME *to, struct tm *from);
 
 /*******************************************************************//**
@@ -205,8 +204,7 @@
                   DRIZZLE_TYPE_VARCHAR,
                   0,
                   0,
-                  "",
-                  SKIP_OPEN_TABLE),
+                  ""),
 
 #define IDX_TRX_STATE		1
         drizzled::plugin::ColumnInfo("trx_state",
@@ -214,8 +212,7 @@
                   DRIZZLE_TYPE_VARCHAR,
                   0,
                   0,
-                  "",
-                  SKIP_OPEN_TABLE),
+                  ""),
 
 #define IDX_TRX_STARTED		2
         drizzled::plugin::ColumnInfo("trx_started",
@@ -223,8 +220,7 @@
                   DRIZZLE_TYPE_DATETIME,
                   0,
                   0,
-                  "",
-                  SKIP_OPEN_TABLE),
+                  ""),
 
 #define IDX_TRX_REQUESTED_LOCK_ID	3
         drizzled::plugin::ColumnInfo("trx_requested_lock_id",
@@ -232,8 +228,7 @@
                   DRIZZLE_TYPE_VARCHAR,
                   0,
                   MY_I_S_MAYBE_NULL,
-                  "",
-                  SKIP_OPEN_TABLE),
+                  ""),
 
 #define IDX_TRX_WAIT_STARTED	4
         drizzled::plugin::ColumnInfo("trx_wait_started",
@@ -241,8 +236,7 @@
                   DRIZZLE_TYPE_DATETIME,
                   0,
                   MY_I_S_MAYBE_NULL,
-                  "",
-                  SKIP_OPEN_TABLE),
+                  ""),
 
 #define IDX_TRX_WEIGHT		5
         drizzled::plugin::ColumnInfo("trx_weight",
@@ -250,8 +244,7 @@
                   DRIZZLE_TYPE_LONGLONG,
                   0,
                   MY_I_S_UNSIGNED,
-                  "",
-                  SKIP_OPEN_TABLE),
+                  ""),
 
 #define IDX_TRX_DRIZZLE_THREAD_ID	6
         drizzled::plugin::ColumnInfo("trx_mysql_thread_id",
@@ -259,8 +252,7 @@
                   DRIZZLE_TYPE_LONGLONG,
                   0,
                   MY_I_S_UNSIGNED,
-                  "",
-                  SKIP_OPEN_TABLE),
+                  ""),
 
 #define IDX_TRX_QUERY		7
         drizzled::plugin::ColumnInfo("trx_query",
@@ -268,8 +260,7 @@
                   DRIZZLE_TYPE_VARCHAR,
                   0,
                   MY_I_S_MAYBE_NULL,
-                  "",
-                  SKIP_OPEN_TABLE),
+                  ""),
 
         drizzled::plugin::ColumnInfo()
 };
@@ -283,9 +274,8 @@
 fill_innodb_trx_from_cache(
 /*=======================*/
 	trx_i_s_cache_t*	cache,	/*!< in: cache to read from */
-	Session*		session,/*!< in: used to call
-					schema_table_store_record() */
-	Table*			table)	/*!< in/out: fill this table */
+	Table*			table,	/*!< in/out: fill this table */
+        drizzled::plugin::InfoSchemaTable *schema_table)
 {
 	Field**	fields;
 	ulint	rows_num;
@@ -351,7 +341,8 @@
 		OK(field_store_string(fields[IDX_TRX_QUERY],
 				      row->trx_query));
 
-		OK(schema_table_store_record(session, table));
+                schema_table->addRow(table->record[0],
+                                     table->s->reclength);
 	}
 
 	return(0);
@@ -383,8 +374,7 @@
                   DRIZZLE_TYPE_VARCHAR,
                   0,
                   0,
-                  "",
-                  SKIP_OPEN_TABLE),
+                  ""),
 
 #define IDX_LOCK_TRX_ID		1
         drizzled::plugin::ColumnInfo("lock_trx_id",
@@ -392,8 +382,7 @@
                   DRIZZLE_TYPE_VARCHAR,
                   0,
                   0,
-                  "",
-                  SKIP_OPEN_TABLE),
+                  ""),
 
 #define IDX_LOCK_MODE		2
         drizzled::plugin::ColumnInfo("lock_mode",
@@ -402,8 +391,7 @@
                   DRIZZLE_TYPE_VARCHAR,
                   0,
                   0,
-                  "",
-                  SKIP_OPEN_TABLE),
+                  ""),
 
 #define IDX_LOCK_TYPE		3
         drizzled::plugin::ColumnInfo("lock_type",
@@ -411,8 +399,7 @@
                   DRIZZLE_TYPE_VARCHAR,
                   0,
                   0,
-                  "",
-                  SKIP_OPEN_TABLE),
+                  ""),
 
 #define IDX_LOCK_TABLE		4
         drizzled::plugin::ColumnInfo("lock_table",
@@ -420,8 +407,7 @@
                   DRIZZLE_TYPE_VARCHAR,
                   0,
                   0,
-                  "",
-                  SKIP_OPEN_TABLE),
+                  ""),
 
 #define IDX_LOCK_INDEX		5
         drizzled::plugin::ColumnInfo("lock_index",
@@ -429,8 +415,7 @@
                   DRIZZLE_TYPE_VARCHAR,
                   0,
                   MY_I_S_MAYBE_NULL,
-                  "",
-                  SKIP_OPEN_TABLE),
+                  ""),
 
 #define IDX_LOCK_SPACE		6
         drizzled::plugin::ColumnInfo("lock_space",
@@ -438,8 +423,7 @@
                   DRIZZLE_TYPE_LONGLONG,
                   0,
                   MY_I_S_UNSIGNED | MY_I_S_MAYBE_NULL,
-                  "",
-                  SKIP_OPEN_TABLE),
+                  ""),
 
 #define IDX_LOCK_PAGE		7
         drizzled::plugin::ColumnInfo("lock_page",
@@ -447,8 +431,7 @@
                   DRIZZLE_TYPE_LONGLONG,
                   0,
                   MY_I_S_UNSIGNED | MY_I_S_MAYBE_NULL,
-                  "",
-                  SKIP_OPEN_TABLE),
+                  ""),
 
 #define IDX_LOCK_REC		8
         drizzled::plugin::ColumnInfo("lock_rec",
@@ -456,8 +439,7 @@
                   DRIZZLE_TYPE_LONGLONG,
                   0,
                   MY_I_S_UNSIGNED | MY_I_S_MAYBE_NULL,
-                  "",
-                  SKIP_OPEN_TABLE),
+                  ""),
 
 #define IDX_LOCK_DATA		9
         drizzled::plugin::ColumnInfo("lock_data",
@@ -465,8 +447,7 @@
                   DRIZZLE_TYPE_VARCHAR,
                   0,
                   MY_I_S_MAYBE_NULL,
-                  "",
-                  SKIP_OPEN_TABLE),
+                  ""),
 
         drizzled::plugin::ColumnInfo()
 };
@@ -481,7 +462,8 @@
 /*=========================*/
 	trx_i_s_cache_t*	cache,	/*!< in: cache to read from */
 	Session*		session,/*!< in: MySQL client connection */
-	Table*			table)	/*!< in/out: fill this table */
+	Table*			table,	/*!< in/out: fill this table */
+        drizzled::plugin::InfoSchemaTable *schema_table)
 {
 	Field**	fields;
 	ulint	rows_num;
@@ -571,7 +553,8 @@
 		OK(field_store_string(fields[IDX_LOCK_DATA],
 				      row->lock_data));
 
-		OK(schema_table_store_record(session, table));
+                schema_table->addRow(table->record[0],
+                                     table->s->reclength);
 	}
 
 	return(0);
@@ -603,8 +586,7 @@
                   DRIZZLE_TYPE_VARCHAR,
                   0,
                   0,
-                  "",
-                  SKIP_OPEN_TABLE),
+                  ""),
 
 #define IDX_REQUESTED_LOCK_ID	1
         drizzled::plugin::ColumnInfo("requested_lock_id",
@@ -612,8 +594,7 @@
                   DRIZZLE_TYPE_VARCHAR,
                   0,
                   0,
-                  "",
-                  SKIP_OPEN_TABLE),
+                  ""),
 
 #define IDX_BLOCKING_TRX_ID	2
         drizzled::plugin::ColumnInfo("blocking_trx_id",
@@ -621,8 +602,7 @@
                   DRIZZLE_TYPE_VARCHAR,
                   0,
                   0,
-                  "",
-                  SKIP_OPEN_TABLE),
+                  ""),
 
 #define IDX_BLOCKING_LOCK_ID	3
         drizzled::plugin::ColumnInfo("blocking_lock_id",
@@ -630,8 +610,7 @@
                   DRIZZLE_TYPE_VARCHAR,
                   0,
                   0,
-                  "",
-                  SKIP_OPEN_TABLE),
+                  ""),
 
         drizzled::plugin::ColumnInfo()
 };
@@ -645,9 +624,8 @@
 fill_innodb_lock_waits_from_cache(
 /*==============================*/
 	trx_i_s_cache_t*	cache,	/*!< in: cache to read from */
-	Session*		session,/*!< in: used to call
-					schema_table_store_record() */
-	Table*			table)	/*!< in/out: fill this table */
+	Table*			table,	/*!< in/out: fill this table */
+        drizzled::plugin::InfoSchemaTable *schema_table)
 {
 	Field**	fields;
 	ulint	rows_num;
@@ -699,7 +677,8 @@
 				   blocking_lock_id,
 				   sizeof(blocking_lock_id))));
 
-		OK(schema_table_store_record(session, table));
+                schema_table->addRow(table->record[0],
+                                     table->s->reclength);
 	}
 
 	return(0);
@@ -734,7 +713,8 @@
 TrxISMethods::fillTable(
 /*======================*/
 	Session*	session,/*!< in: thread */
-	TableList*	tables)	/*!< in/out: tables to fill */
+	Table*	table,	/*!< in/out: tables to fill */
+        drizzled::plugin::InfoSchemaTable *schema_table)
 {
 	const char*		table_name;
 	int			ret;
@@ -745,7 +725,7 @@
 	cache = trx_i_s_cache;
 
 	/* which table we have to fill? */
-	table_name = tables->schema_table_name;
+	table_name = schema_table->getName().c_str();
 	/* or table_name = tables->schema_table->table_name; */
 
 	RETURN_IF_INNODB_NOT_STARTED(table_name);
@@ -770,7 +750,7 @@
 	if (innobase_strcasecmp(table_name, "innodb_trx") == 0) {
 
 		if (fill_innodb_trx_from_cache(
-			cache, session, tables->table) != 0) {
+			cache, table, schema_table) != 0) {
 
 			ret = 1;
 		}
@@ -778,7 +758,7 @@
 	} else if (innobase_strcasecmp(table_name, "innodb_locks") == 0) {
 
 		if (fill_innodb_locks_from_cache(
-			cache, session, tables->table) != 0) {
+			cache, session, table, schema_table) != 0) {
 
 			ret = 1;
 		}
@@ -786,7 +766,7 @@
 	} else if (innobase_strcasecmp(table_name, "innodb_lock_waits") == 0) {
 
 		if (fill_innodb_lock_waits_from_cache(
-			cache, session, tables->table) != 0) {
+			cache, table, schema_table) != 0) {
 
 			ret = 1;
 		}
@@ -825,48 +805,42 @@
                   DRIZZLE_TYPE_LONG,
                   0,
                   0,
-                  "Compressed Page Size",
-                  SKIP_OPEN_TABLE),
+                  "Compressed Page Size"),
 
         drizzled::plugin::ColumnInfo("compress_ops",
                   MY_INT32_NUM_DECIMAL_DIGITS,
                   DRIZZLE_TYPE_LONG,
                   0,
                   0,
-                  "Total Number of Compressions",
-                  SKIP_OPEN_TABLE),
+                  "Total Number of Compressions"),
 
         drizzled::plugin::ColumnInfo("compress_ops_ok",
                   MY_INT32_NUM_DECIMAL_DIGITS,
                   DRIZZLE_TYPE_LONG,
                   0,
                   0,
-                  "Total Number of Successful Compressions",
-                  SKIP_OPEN_TABLE),
+                  "Total Number of Successful Compressions"),
 
         drizzled::plugin::ColumnInfo("compress_time",
                   MY_INT32_NUM_DECIMAL_DIGITS,
                   DRIZZLE_TYPE_LONG,
                   0,
                   0,
-                  "Total Duration of Compressions in Seconds",
-                  SKIP_OPEN_TABLE),
+                  "Total Duration of Compressions in Seconds"),
 
         drizzled::plugin::ColumnInfo("uncompress_ops",
                   MY_INT32_NUM_DECIMAL_DIGITS,
                   DRIZZLE_TYPE_LONG,
                   0,
                   0,
-                  "Total Number of Decompressions",
-                  SKIP_OPEN_TABLE),
+                  "Total Number of Decompressions"),
 
         drizzled::plugin::ColumnInfo("uncompress_time",
                   MY_INT32_NUM_DECIMAL_DIGITS,
                   DRIZZLE_TYPE_LONG,
                   0,
                   0,
-                  "Total Duration of Decompressions in Seconds",
-                  SKIP_OPEN_TABLE),
+                  "Total Duration of Decompressions in Seconds"),
 
         drizzled::plugin::ColumnInfo()
 };
@@ -881,14 +855,14 @@
 i_s_cmp_fill_low(
 /*=============*/
 	Session*	session,/*!< in: thread */
-	TableList*	tables,	/*!< in/out: tables to fill */
+	Table*	table,	/*!< in/out: tables to fill */
+        drizzled::plugin::InfoSchemaTable *schema_table,
 	ibool		reset)	/*!< in: TRUE=reset cumulated counts */
 {
-	Table*	table	= (Table *) tables->table;
 	int	status	= 0;
 
 
-	RETURN_IF_INNODB_NOT_STARTED(tables->schema_table_name);
+	RETURN_IF_INNODB_NOT_STARTED(schema_table->getName().c_str());
 
 	for (uint i = 0; i < PAGE_ZIP_NUM_SSIZE - 1; i++) {
 		page_zip_stat_t*	zip_stat = &page_zip_stat[i];
@@ -913,10 +887,8 @@
 			memset(zip_stat, 0, sizeof *zip_stat);
 		}
 
-		if (schema_table_store_record(session, table)) {
-			status = 1;
-			break;
-		}
+                schema_table->addRow(table->record[0],
+                                     table->s->reclength);
 	}
 
 	return(status);
@@ -929,9 +901,10 @@
 CmpISMethods::fillTable(
 /*=========*/
 	Session*	session,/*!< in: thread */
-	TableList*	tables)	/*!< in/out: tables to fill */
+	Table*	table,	/*!< in/out: tables to fill */
+        drizzled::plugin::InfoSchemaTable *schema_table)
 {
-	return(i_s_cmp_fill_low(session, tables, FALSE));
+	return(i_s_cmp_fill_low(session, table, schema_table, FALSE));
 }
 
 /*******************************************************************//**
@@ -941,9 +914,10 @@
 CmpResetISMethods::fillTable(
 /*===============*/
 	Session*	session,/*!< in: thread */
-	TableList*	tables)	/*!< in/out: tables to fill */
+	Table*	table,	/*!< in/out: tables to fill */
+        drizzled::plugin::InfoSchemaTable *schema_table)
 {
-	return(i_s_cmp_fill_low(session, tables, TRUE));
+	return(i_s_cmp_fill_low(session, table, schema_table, TRUE));
 }
 
 /*******************************************************************//**
@@ -990,40 +964,35 @@
                   DRIZZLE_TYPE_LONG,
                   0,
                   0,
-                  "Buddy Block Size",
-                  SKIP_OPEN_TABLE),
+                  "Buddy Block Size"),
 
         drizzled::plugin::ColumnInfo("pages_used",
                   MY_INT32_NUM_DECIMAL_DIGITS,
                   DRIZZLE_TYPE_LONG,
                   0,
                   0,
-                  "Currently in Use",
-                  SKIP_OPEN_TABLE),
+                  "Currently in Use"),
 
         drizzled::plugin::ColumnInfo("pages_free",
                   MY_INT32_NUM_DECIMAL_DIGITS,
                   DRIZZLE_TYPE_LONG,
                   0,
                   0,
-                  "Currently Available",
-                  SKIP_OPEN_TABLE),
+                  "Currently Available"),
 
         drizzled::plugin::ColumnInfo("relocation_ops",
                   MY_INT64_NUM_DECIMAL_DIGITS,
                   DRIZZLE_TYPE_LONGLONG,
                   0,
                   0,
-                  "Total Number of Relocations",
-                  SKIP_OPEN_TABLE),
+                  "Total Number of Relocations"),
 
         drizzled::plugin::ColumnInfo("relocation_time",
                   MY_INT32_NUM_DECIMAL_DIGITS,
                   DRIZZLE_TYPE_LONG,
                   0,
                   0,
-                  "Total Duration of Relocations, in Seconds",
-                  SKIP_OPEN_TABLE),
+                  "Total Duration of Relocations, in Seconds"),
 
         drizzled::plugin::ColumnInfo()
 };
@@ -1037,13 +1006,13 @@
 i_s_cmpmem_fill_low(
 /*================*/
 	Session*	session,/*!< in: thread */
-	TableList*	tables,	/*!< in/out: tables to fill */
+	Table*	table,	/*!< in/out: tables to fill */
+        drizzled::plugin::InfoSchemaTable *schema_table,
 	ibool		reset)	/*!< in: TRUE=reset cumulated counts */
 {
-	Table*	table	= (Table *) tables->table;
 	int	status	= 0;
 
-	RETURN_IF_INNODB_NOT_STARTED(tables->schema_table_name);
+	RETURN_IF_INNODB_NOT_STARTED(schema_table->getName().c_str());
 
 	buf_pool_mutex_enter();
 
@@ -1065,10 +1034,8 @@
 			buddy_stat->relocated_usec = 0;
 		}
 
-		if (schema_table_store_record(session, table)) {
-			status = 1;
-			break;
-		}
+                schema_table->addRow(table->record[0],
+                                     table->s->reclength);
 	}
 
 	buf_pool_mutex_exit();
@@ -1082,9 +1049,10 @@
 CmpmemISMethods::fillTable(
 /*============*/
 	Session*	session,/*!< in: thread */
-	TableList*	tables)	/*!< in/out: tables to fill */
+	Table*	table, /*!< in/out: tables to fill */
+        drizzled::plugin::InfoSchemaTable *schema_table)	
 {
-	return(i_s_cmpmem_fill_low(session, tables, FALSE));
+	return(i_s_cmpmem_fill_low(session, table, schema_table, FALSE));
 }
 
 /*******************************************************************//**
@@ -1094,9 +1062,10 @@
 CmpmemResetISMethods::fillTable(
 /*==================*/
 	Session*	session,/*!< in: thread */
-	TableList*	tables)	/*!< in/out: tables to fill */
+	Table*	table,	/*!< in/out: tables to fill */
+        drizzled::plugin::InfoSchemaTable *schema_table)
 {
-	return(i_s_cmpmem_fill_low(session, tables, TRUE));
+	return(i_s_cmpmem_fill_low(session, table, schema_table, TRUE));
 }
 
 /*******************************************************************//**

=== modified file 'plugin/innobase/handler/i_s.h'
--- plugin/innobase/handler/i_s.h	2009-10-31 00:17:15 +0000
+++ plugin/innobase/handler/i_s.h	2009-11-26 03:47:13 +0000
@@ -30,42 +30,48 @@
 {
 public:
   virtual int fillTable(Session *session,
-                        TableList *tables);
+                        Table *table,
+                        drizzled::plugin::InfoSchemaTable *schema_table);
 };
 
 class LocksISMethods : public drizzled::plugin::InfoSchemaMethods
 {
 public:
   virtual int fillTable(Session *session,
-                        TableList *tables);
+                        Table *table,
+                        drizzled::plugin::InfoSchemaTable *schema_table);
 };
 
 class CmpISMethods : public drizzled::plugin::InfoSchemaMethods
 {
 public:
   virtual int fillTable(Session *session,
-                        TableList *tables);
+                        Table *table,
+                        drizzled::plugin::InfoSchemaTable *schema_table);
 };
 
 class CmpResetISMethods : public drizzled::plugin::InfoSchemaMethods
 {
 public:
   virtual int fillTable(Session *session,
-                        TableList *tables);
+                        Table *table,
+                        drizzled::plugin::InfoSchemaTable *schema_table);
 };
 
 class CmpmemISMethods : public drizzled::plugin::InfoSchemaMethods
 {
 public:
   virtual int fillTable(Session *session,
-                        TableList *tables);
+                        Table *table,
+                        drizzled::plugin::InfoSchemaTable *schema_table);
 };
 
 class CmpmemResetISMethods : public drizzled::plugin::InfoSchemaMethods
 {
 public:
   virtual int fillTable(Session *session,
-                        TableList *tables);
+                        Table *table,
+                        drizzled::plugin::InfoSchemaTable *schema_table);
 };
 
 int i_s_common_deinit(drizzled::plugin::Registry &registry);

=== modified file 'plugin/memcached_stats/analysis_table.cc'
--- plugin/memcached_stats/analysis_table.cc	2009-10-31 00:17:15 +0000
+++ plugin/memcached_stats/analysis_table.cc	2009-11-26 03:47:13 +0000
@@ -42,11 +42,11 @@
 using namespace std;
 using namespace drizzled;
 
-int MemcachedAnalysisISMethods::fillTable(Session *session,
-                                          TableList *tables)
+int MemcachedAnalysisISMethods::fillTable(Session *,
+                                          Table *table,
+                                          plugin::InfoSchemaTable *schema_table)
 {
   const CHARSET_INFO * const scs= system_charset_info;
-  Table *table= tables->table;
   SysvarHolder &sysvar_holder= SysvarHolder::singleton();
   const string servers_string= sysvar_holder.getServersString();
 
@@ -87,10 +87,7 @@
     table->field[8]->store(report->pool_hit_ratio);
 
     /* store the actual record now */
-    if (schema_table_store_record(session, table))
-    {
-      return 1;
-    }
+    schema_table->addRow(table->record[0], table->s->reclength);
     free(report);
   }
 
@@ -109,8 +106,7 @@
                                                                DRIZZLE_TYPE_LONGLONG,
                                                                0,
                                                                0, 
-                                                               "Num of Servers Analyzed",
-                                                               SKIP_OPEN_TABLE);
+                                                               "Num of Servers Analyzed");
   if (! num_analyzed)
   {
     return true;
@@ -121,8 +117,7 @@
                                                            DRIZZLE_TYPE_LONGLONG,
                                                            0,
                                                            0, 
-                                                           "Average Item Size",
-                                                           SKIP_OPEN_TABLE);
+                                                           "Average Item Size");
   if (! avg_size)
   {
     return true;
@@ -133,8 +128,7 @@
                                                            DRIZZLE_TYPE_VARCHAR,
                                                            0,
                                                            0,
-                                                           "Node with Most Memory Consumption",
-                                                           SKIP_OPEN_TABLE);
+                                                           "Node with Most Memory Consumption");
   if (! mem_node)
   {
     return true;
@@ -145,8 +139,7 @@
                                                              DRIZZLE_TYPE_LONGLONG,
                                                              0,
                                                              0,
-                                                             "Used Bytes",
-                                                             SKIP_OPEN_TABLE);
+                                                             "Used Bytes");
   if (! used_bytes)
   {
     return true;
@@ -157,8 +150,7 @@
                                                             DRIZZLE_TYPE_VARCHAR,
                                                             0,
                                                             0,
-                                                            "Node with Least Free Space",
-                                                            SKIP_OPEN_TABLE);
+                                                            "Node with Least Free Space");
   if (! free_node)
   {
     return true;
@@ -169,8 +161,7 @@
                                                              DRIZZLE_TYPE_LONGLONG,
                                                              0,
                                                              0,
-                                                             "Free Bytes",
-                                                             SKIP_OPEN_TABLE);
+                                                             "Free Bytes");
   if (! free_bytes)
   {
     return true;
@@ -181,8 +172,7 @@
                                                           DRIZZLE_TYPE_VARCHAR,
                                                           0,
                                                           0,
-                                                          "Node with Longest Uptime",
-                                                          SKIP_OPEN_TABLE);
+                                                          "Node with Longest Uptime");
   if (! up_node)
   {
     return true;
@@ -193,8 +183,7 @@
                                                          DRIZZLE_TYPE_LONGLONG,
                                                          0,
                                                          0,
-                                                         "Longest Uptime",
-                                                         SKIP_OPEN_TABLE);
+                                                         "Longest Uptime");
   if (! uptime)
   {
     return true;
@@ -205,8 +194,7 @@
                                                             DRIZZLE_TYPE_LONGLONG,
                                                             0,
                                                             0,
-                                                            "Pool-wide Hit Ratio",
-                                                            SKIP_OPEN_TABLE);
+                                                            "Pool-wide Hit Ratio");
   if (! hit_ratio)
   {
     return true;

=== modified file 'plugin/memcached_stats/analysis_table.h'
--- plugin/memcached_stats/analysis_table.h	2009-10-31 00:17:15 +0000
+++ plugin/memcached_stats/analysis_table.h	2009-11-26 03:47:13 +0000
@@ -38,7 +38,8 @@
 {
 public:
   virtual int fillTable(Session *session,
-                        TableList *tables);
+                        Table *table,
+                        drizzled::plugin::InfoSchemaTable *schema_table);
 };
 
 bool createMemcachedAnalysisColumns(std::vector<const drizzled::plugin::ColumnInfo *> &cols);

=== modified file 'plugin/memcached_stats/stats_table.cc'
--- plugin/memcached_stats/stats_table.cc	2009-10-31 00:17:15 +0000
+++ plugin/memcached_stats/stats_table.cc	2009-11-26 03:47:13 +0000
@@ -42,11 +42,11 @@
 using namespace std;
 using namespace drizzled;
 
-int MemcachedStatsISMethods::fillTable(Session *session,
-                                       TableList *tables)
+int MemcachedStatsISMethods::fillTable(Session *,
+                                       Table *table,
+                                       plugin::InfoSchemaTable *schema_table)
 {
   const CHARSET_INFO * const scs= system_charset_info;
-  Table *table= tables->table;
   SysvarHolder &sysvar_holder= SysvarHolder::singleton();
   const string servers_string= sysvar_holder.getServersString();
 
@@ -82,10 +82,7 @@
     }
     free(list);
     /* store the actual record now */
-    if (schema_table_store_record(session, table))
-    {
-      return 1;
-    }
+    schema_table->addRow(table->record[0], table->s->reclength);
   }
 
   memcached_stat_free(serv, stats);
@@ -104,8 +101,7 @@
                                                            DRIZZLE_TYPE_VARCHAR,
                                                            0,
                                                            0,
-                                                           "Name",
-                                                           SKIP_OPEN_TABLE);
+                                                           "Name");
   if (! name_col)
   {
     return true;
@@ -116,8 +112,7 @@
                                                        DRIZZLE_TYPE_LONGLONG,
                                                        0,
                                                        0, 
-                                                       "Port Number",
-                                                       SKIP_OPEN_TABLE);
+                                                       "Port Number");
   if (! port)
   {
     return true;
@@ -128,8 +123,7 @@
                                                       DRIZZLE_TYPE_LONGLONG,
                                                       0,
                                                       0, 
-                                                      "Process ID",
-                                                      SKIP_OPEN_TABLE);
+                                                      "Process ID");
   if (! pid)
   {
     return true;
@@ -140,8 +134,7 @@
                                                          DRIZZLE_TYPE_LONGLONG,
                                                          0,
                                                          0, 
-                                                         "Uptime",
-                                                         SKIP_OPEN_TABLE);
+                                                         "Uptime");
   if (! uptime)
   {
     return true;
@@ -152,8 +145,7 @@
                                                        DRIZZLE_TYPE_LONGLONG,
                                                        0,
                                                        0, 
-                                                       "Time",
-                                                       SKIP_OPEN_TABLE);
+                                                       "Time");
   if (! time)
   {
     return true;
@@ -164,8 +156,7 @@
                                                           DRIZZLE_TYPE_VARCHAR,
                                                           0,
                                                           0,
-                                                          "Version",
-                                                          SKIP_OPEN_TABLE);
+                                                          "Version");
   if (! version)
   {
     return true;
@@ -176,8 +167,7 @@
                                                            DRIZZLE_TYPE_LONGLONG,
                                                            0,
                                                            0, 
-                                                           "Pointer Size",
-                                                           SKIP_OPEN_TABLE);
+                                                           "Pointer Size");
   if (! ptr_size)
   {
     return true;
@@ -188,8 +178,7 @@
                                                          DRIZZLE_TYPE_LONGLONG,
                                                          0,
                                                          0, 
-                                                         "rusage user",
-                                                         SKIP_OPEN_TABLE);
+                                                         "rusage user");
   if (! r_user)
   {
     return true;
@@ -200,8 +189,7 @@
                                                         DRIZZLE_TYPE_LONGLONG,
                                                         0,
                                                         0, 
-                                                        "rusage system",
-                                                        SKIP_OPEN_TABLE);
+                                                        "rusage system");
   if (! r_sys)
   {
     return true;
@@ -211,8 +199,7 @@
                                                              DRIZZLE_TYPE_LONGLONG,
                                                              0,
                                                              0, 
-                                                             "Current Items",
-                                                             SKIP_OPEN_TABLE);
+                                                             "Current Items");
   if (! curr_items)
   {
     return true;
@@ -223,8 +210,7 @@
                                                               DRIZZLE_TYPE_LONGLONG,
                                                               0,
                                                               0,
-                                                              "Total Items",
-                                                              SKIP_OPEN_TABLE);
+                                                              "Total Items");
   if (! total_items)
   {
     return true;
@@ -235,8 +221,7 @@
                                                         DRIZZLE_TYPE_LONGLONG,
                                                         0,
                                                         0,
-                                                        "Bytes",
-                                                        SKIP_OPEN_TABLE);
+                                                        "Bytes");
   if (! bytes)
   {
     return true;
@@ -247,8 +232,7 @@
                                                             DRIZZLE_TYPE_LONGLONG,
                                                             0,
                                                             0,
-                                                            "Current Connections",
-                                                            SKIP_OPEN_TABLE);
+                                                            "Current Connections");
   if (! curr_cons)
   {
     return true;
@@ -259,8 +243,7 @@
                                                              DRIZZLE_TYPE_LONGLONG,
                                                              0,
                                                              0,
-                                                             "Total Connections",
-                                                             SKIP_OPEN_TABLE);
+                                                             "Total Connections");
   if (! total_cons)
   {
     return true;
@@ -271,8 +254,7 @@
                                                               DRIZZLE_TYPE_LONGLONG,
                                                               0,
                                                               0,
-                                                              "Connection Structures",
-                                                              SKIP_OPEN_TABLE);
+                                                              "Connection Structures");
   if (! con_structs)
   {
     return true;
@@ -283,8 +265,7 @@
                                                            DRIZZLE_TYPE_LONGLONG,
                                                            0,
                                                            0,
-                                                           "Gets",
-                                                           SKIP_OPEN_TABLE);
+                                                           "Gets");
   if (! cmd_gets)
   {
     return true;
@@ -295,8 +276,7 @@
                                                            DRIZZLE_TYPE_LONGLONG,
                                                            0,
                                                            0,
-                                                           "Sets",
-                                                           SKIP_OPEN_TABLE);
+                                                           "Sets");
   if (! cmd_sets)
   {
     return true;
@@ -307,8 +287,7 @@
                                                        DRIZZLE_TYPE_LONGLONG,
                                                        0,
                                                        0,
-                                                       "Hits",
-                                                       SKIP_OPEN_TABLE);
+                                                       "Hits");
   if (! hits)
   {
     return true;
@@ -319,8 +298,7 @@
                                                          DRIZZLE_TYPE_LONGLONG,
                                                          0,
                                                          0,
-                                                         "Misses",
-                                                         SKIP_OPEN_TABLE);
+                                                         "Misses");
   if (! misses)
   {
     return true;
@@ -331,8 +309,7 @@
                                                          DRIZZLE_TYPE_LONGLONG,
                                                          0,
                                                          0,
-                                                         "Evictions",
-                                                         SKIP_OPEN_TABLE);
+                                                         "Evictions");
   if (! evicts)
   {
     return true;
@@ -343,8 +320,7 @@
                                                              DRIZZLE_TYPE_LONGLONG,
                                                              0,
                                                              0,
-                                                             "bytes read",
-                                                             SKIP_OPEN_TABLE);
+                                                             "bytes read");
   if (! bytes_read)
   {
     return true;
@@ -355,8 +331,7 @@
                                                                 DRIZZLE_TYPE_LONGLONG,
                                                                 0,
                                                                 0,
-                                                                "bytes written",
-                                                                SKIP_OPEN_TABLE);
+                                                                "bytes written");
   if (! bytes_written)
   {
     return true;
@@ -367,8 +342,7 @@
                                                                 DRIZZLE_TYPE_LONGLONG,
                                                                 0,
                                                                 0,
-                                                                "limit maxbytes",
-                                                                SKIP_OPEN_TABLE);
+                                                                "limit maxbytes");
   if (! lim_max_bytes)
   {
     return true;
@@ -379,8 +353,7 @@
                                                           DRIZZLE_TYPE_LONGLONG,
                                                           0,
                                                           0,
-                                                          "Threads",
-                                                          SKIP_OPEN_TABLE);
+                                                          "Threads");
   if (! threads)
   {
     return true;

=== modified file 'plugin/memcached_stats/stats_table.h'
--- plugin/memcached_stats/stats_table.h	2009-10-31 00:17:15 +0000
+++ plugin/memcached_stats/stats_table.h	2009-11-26 03:47:13 +0000
@@ -38,7 +38,8 @@
 {
 public:
   virtual int fillTable(Session *session,
-                        TableList *tables);
+                        Table *table,
+                        drizzled::plugin::InfoSchemaTable *schema_table);
 };
 
 bool createMemcachedStatsColumns(std::vector<const drizzled::plugin::ColumnInfo *> &cols);

=== modified file 'plugin/transaction_log/info_schema.cc'
--- plugin/transaction_log/info_schema.cc	2009-11-26 02:50:58 +0000
+++ plugin/transaction_log/info_schema.cc	2009-11-30 19:02:55 +0000
@@ -112,15 +112,23 @@
 static bool createTransactionLogEntriesViewColumns(vector<const drizzled::plugin::ColumnInfo *> &cols);
 static bool createTransactionLogTransactionsViewColumns(vector<const drizzled::plugin::ColumnInfo *> &cols);
 
-int TransactionLogViewISMethods::fillTable(Session *session,
-                                           TableList *tables)
+int TransactionLogViewISMethods::fillTable(Session *,
+                                           Table *table,
+                                           plugin::InfoSchemaTable *schema_table)
 {
-  Table *table= tables->table;
-
   if (transaction_log != NULL)
   {
     table->restoreRecordAsDefault();
 
+    table->setWriteSet(0);
+    table->setWriteSet(1);
+    table->setWriteSet(2);
+    table->setWriteSet(3);
+    table->setWriteSet(4);
+    table->setWriteSet(5);
+    table->setWriteSet(6);
+    table->setWriteSet(7);
+
     const string &filename= transaction_log->getLogFilename();
     table->field[0]->store(filename.c_str(), filename.length(), system_charset_info);
 
@@ -138,19 +146,15 @@
     table->field[7]->store(static_cast<int64_t>(transaction_log_index->getMaxEndTimestamp()));
 
     /* store the actual record now */
-    if (schema_table_store_record(session, table))
-    {
-      return 1;
-    }
+    schema_table->addRow(table->record[0], table->s->reclength);
   }
   return 0;
 }
 
-int TransactionLogEntriesViewISMethods::fillTable(Session *session,
-                                                  TableList *tables)
+int TransactionLogEntriesViewISMethods::fillTable(Session *,
+                                                  Table *table,
+                                                  plugin::InfoSchemaTable *schema_table)
 {
-  Table *table= tables->table;
-
   if (transaction_log != NULL)
   {
     /** @todo trigger indexing update here. */
@@ -162,26 +166,26 @@
 
       table->restoreRecordAsDefault();
 
+      table->setWriteSet(0);
+      table->setWriteSet(1);
+      table->setWriteSet(2);
+
       table->field[0]->store(static_cast<int64_t>(entry.getOffset()));
       const char *type_string= entry.getTypeAsString();
       table->field[1]->store(type_string, strlen(type_string), system_charset_info);
       table->field[2]->store(static_cast<int64_t>(entry.getLengthInBytes()));
 
       /* store the actual record now */
-      if (schema_table_store_record(session, table))
-      {
-        return 1;
-      }
+      schema_table->addRow(table->record[0], table->s->reclength);
     }
   }
   return 0;
 }
 
-int TransactionLogTransactionsViewISMethods::fillTable(Session *session,
-                                                  TableList *tables)
+int TransactionLogTransactionsViewISMethods::fillTable(Session *,
+                                                       Table *table,
+                                                       plugin::InfoSchemaTable *schema_table)
 {
-  Table *table= tables->table;
-
   if (transaction_log != NULL)
   {
     /** @todo trigger indexing update here. */
@@ -193,6 +197,14 @@
 
       table->restoreRecordAsDefault();
 
+      table->setWriteSet(0);
+      table->setWriteSet(1);
+      table->setWriteSet(2);
+      table->setWriteSet(3);
+      table->setWriteSet(4);
+      table->setWriteSet(5);
+      table->setWriteSet(6);
+
       table->field[0]->store(static_cast<int64_t>(entry.getOffset()));
       table->field[1]->store(static_cast<int64_t>(entry.getTransactionId()));
       table->field[2]->store(static_cast<int64_t>(entry.getServerId()));
@@ -202,10 +214,7 @@
       table->field[6]->store(static_cast<int64_t>(entry.getChecksum()));
 
       /* store the actual record now */
-      if (schema_table_store_record(session, table))
-      {
-        return 1;
-      }
+      schema_table->addRow(table->record[0], table->s->reclength);
     }
   }
   return 0;
@@ -222,8 +231,7 @@
                                       DRIZZLE_TYPE_VARCHAR,
                                       0,
                                       0, 
-                                      "Filename of the transaction log",
-                                      SKIP_OPEN_TABLE);
+                                      "Filename of the transaction log");
   if (file_name_col == NULL)
   {
     errmsg_printf(ERRMSG_LVL_ERROR, _("Failed to allocate ColumnInfo %s.  Got error: %s\n"), 
@@ -238,8 +246,7 @@
                                       DRIZZLE_TYPE_LONGLONG,
                                       0,
                                       0, 
-                                      "Length in bytes of the transaction log",
-                                      SKIP_OPEN_TABLE);
+                                      "Length in bytes of the transaction log");
   if (file_length_col == NULL)
   {
     errmsg_printf(ERRMSG_LVL_ERROR, _("Failed to allocate ColumnInfo %s.  Got error: %s\n"), 
@@ -254,8 +261,7 @@
                                       DRIZZLE_TYPE_LONGLONG,
                                       0,
                                       0, 
-                                      "Total number of entries in the transaction log",
-                                      SKIP_OPEN_TABLE);
+                                      "Total number of entries in the transaction log");
   if (num_log_entries_col == NULL)
   {
     errmsg_printf(ERRMSG_LVL_ERROR, _("Failed to allocate ColumnInfo %s.  Got error: %s\n"), 
@@ -270,8 +276,7 @@
                                       DRIZZLE_TYPE_LONGLONG,
                                       0,
                                       0, 
-                                      "Total number of transaction message entries in the transaction log",
-                                      SKIP_OPEN_TABLE);
+                                      "Total number of transaction message entries in the transaction log");
   if (num_transactions_col == NULL)
   {
     errmsg_printf(ERRMSG_LVL_ERROR, _("Failed to allocate ColumnInfo %s.  Got error: %s\n"), 
@@ -286,8 +291,7 @@
                                       DRIZZLE_TYPE_LONGLONG,
                                       0,
                                       0, 
-                                      "Minimum transaction ID in the transaction log",
-                                      SKIP_OPEN_TABLE);
+                                      "Minimum transaction ID in the transaction log");
   if (min_transaction_id_col == NULL)
   {
     errmsg_printf(ERRMSG_LVL_ERROR, _("Failed to allocate ColumnInfo %s.  Got error: %s\n"), 
@@ -302,8 +306,7 @@
                                       DRIZZLE_TYPE_LONGLONG,
                                       0,
                                       0, 
-                                      "Maximum transaction ID in the transaction log",
-                                      SKIP_OPEN_TABLE);
+                                      "Maximum transaction ID in the transaction log");
   if (max_transaction_id_col == NULL)
   {
     errmsg_printf(ERRMSG_LVL_ERROR, _("Failed to allocate ColumnInfo %s.  Got error: %s\n"), 
@@ -318,8 +321,7 @@
                                       DRIZZLE_TYPE_LONGLONG,
                                       0,
                                       0, 
-                                      "Minimum end timestamp for a transaction in the transaction log",
-                                      SKIP_OPEN_TABLE);
+                                      "Minimum end timestamp for a transaction in the transaction log");
   if (min_timestamp_col == NULL)
   {
     errmsg_printf(ERRMSG_LVL_ERROR, _("Failed to allocate ColumnInfo %s.  Got error: %s\n"), 
@@ -334,8 +336,7 @@
                                       DRIZZLE_TYPE_LONGLONG,
                                       0,
                                       0, 
-                                      "Maximum end timestamp for a transaction in the transaction log",
-                                      SKIP_OPEN_TABLE);
+                                      "Maximum end timestamp for a transaction in the transaction log");
   if (max_timestamp_col == NULL)
   {
     errmsg_printf(ERRMSG_LVL_ERROR, _("Failed to allocate ColumnInfo %s.  Got error: %s\n"), 
@@ -367,8 +368,7 @@
                                       DRIZZLE_TYPE_LONGLONG,
                                       0,
                                       0, 
-                                      "Offset of this entry into the transaction log",
-                                      SKIP_OPEN_TABLE);
+                                      "Offset of this entry into the transaction log");
   if (entry_offset_col == NULL)
   {
     errmsg_printf(ERRMSG_LVL_ERROR, _("Failed to allocate ColumnInfo %s.  Got error: %s\n"), 
@@ -383,8 +383,7 @@
                                       DRIZZLE_TYPE_VARCHAR,
                                       0,
                                       0, 
-                                      "Type of this entry",
-                                      SKIP_OPEN_TABLE);
+                                      "Type of this entry");
   if (entry_type_col == NULL)
   {
     errmsg_printf(ERRMSG_LVL_ERROR, _("Failed to allocate ColumnInfo %s.  Got error: %s\n"), 
@@ -399,8 +398,7 @@
                                       DRIZZLE_TYPE_LONGLONG,
                                       0,
                                       0, 
-                                      "Length in bytes of this entry",
-                                      SKIP_OPEN_TABLE);
+                                      "Length in bytes of this entry");
   if (entry_length_col == NULL)
   {
     errmsg_printf(ERRMSG_LVL_ERROR, _("Failed to allocate ColumnInfo %s.  Got error: %s\n"), 
@@ -427,8 +425,7 @@
                                       DRIZZLE_TYPE_LONGLONG,
                                       0,
                                       0, 
-                                      "Offset of this entry into the transaction log",
-                                      SKIP_OPEN_TABLE);
+                                      "Offset of this entry into the transaction log");
   if (entry_offset_col == NULL)
   {
     errmsg_printf(ERRMSG_LVL_ERROR, _("Failed to allocate ColumnInfo %s.  Got error: %s\n"), 
@@ -443,8 +440,7 @@
                                       DRIZZLE_TYPE_LONGLONG,
                                       0,
                                       0, 
-                                      "Transaction ID for this entry",
-                                      SKIP_OPEN_TABLE);
+                                      "Transaction ID for this entry");
   if (transaction_id_col == NULL)
   {
     errmsg_printf(ERRMSG_LVL_ERROR, _("Failed to allocate ColumnInfo %s.  Got error: %s\n"), 
@@ -459,8 +455,7 @@
                                       DRIZZLE_TYPE_LONGLONG,
                                       0,
                                       0, 
-                                      "Server ID for this entry",
-                                      SKIP_OPEN_TABLE);
+                                      "Server ID for this entry");
   if (server_id_col == NULL)
   {
     errmsg_printf(ERRMSG_LVL_ERROR, _("Failed to allocate ColumnInfo %s.  Got error: %s\n"), 
@@ -475,8 +470,7 @@
                                       DRIZZLE_TYPE_LONGLONG,
                                       0,
                                       0, 
-                                      "Start timestamp for this transaction",
-                                      SKIP_OPEN_TABLE);
+                                      "Start timestamp for this transaction");
   if (start_timestamp_col == NULL)
   {
     errmsg_printf(ERRMSG_LVL_ERROR, _("Failed to allocate ColumnInfo %s.  Got error: %s\n"), 
@@ -491,8 +485,7 @@
                                       DRIZZLE_TYPE_LONGLONG,
                                       0,
                                       0, 
-                                      "End timestamp for this transaction",
-                                      SKIP_OPEN_TABLE);
+                                      "End timestamp for this transaction");
   if (end_timestamp_col == NULL)
   {
     errmsg_printf(ERRMSG_LVL_ERROR, _("Failed to allocate ColumnInfo %s.  Got error: %s\n"), 
@@ -507,8 +500,7 @@
                                       DRIZZLE_TYPE_LONGLONG,
                                       0,
                                       0, 
-                                      "Number of statements in this transaction",
-                                      SKIP_OPEN_TABLE);
+                                      "Number of statements in this transaction");
   if (num_statements_col == NULL)
   {
     errmsg_printf(ERRMSG_LVL_ERROR, _("Failed to allocate ColumnInfo %s.  Got error: %s\n"), 
@@ -523,8 +515,7 @@
                                       DRIZZLE_TYPE_LONGLONG,
                                       0,
                                       0, 
-                                      "Checksum of this transaction",
-                                      SKIP_OPEN_TABLE);
+                                      "Checksum of this transaction");
   if (checksum_col == NULL)
   {
     errmsg_printf(ERRMSG_LVL_ERROR, _("Failed to allocate ColumnInfo %s.  Got error: %s\n"), 

=== modified file 'plugin/transaction_log/info_schema.h'
--- plugin/transaction_log/info_schema.h	2009-11-09 15:29:23 +0000
+++ plugin/transaction_log/info_schema.h	2009-11-30 19:02:55 +0000
@@ -40,21 +40,24 @@
 {
 public:
   virtual int fillTable(Session *session,
-                        TableList *tables);
+                        Table *table,
+                        drizzled::plugin::InfoSchemaTable *schema_table);
 };
 
 class TransactionLogEntriesViewISMethods : public drizzled::plugin::InfoSchemaMethods
 {
 public:
   virtual int fillTable(Session *session,
-                        TableList *tables);
+                        Table *table,
+                        drizzled::plugin::InfoSchemaTable *schema_table);
 };
 
 class TransactionLogTransactionsViewISMethods : public drizzled::plugin::InfoSchemaMethods
 {
 public:
   virtual int fillTable(Session *session,
-                        TableList *tables);
+                        Table *table,
+                        drizzled::plugin::InfoSchemaTable *schema_table);
 };
 
 /**

=== modified file 'tests/r/create.result'
--- tests/r/create.result	2009-11-18 03:04:25 +0000
+++ tests/r/create.result	2009-11-25 04:11:37 +0000
@@ -1453,7 +1453,7 @@
   `COMMAND` varchar(16) NOT NULL DEFAULT '',
   `TIME` bigint NOT NULL DEFAULT '0',
   `STATE` varchar(64) DEFAULT NULL,
-  `INFO` text
+  `INFO` varchar(16383) DEFAULT NULL
 ) ENGINE=InnoDB
 drop table t1;
 create temporary table t1 like information_schema.processlist;
@@ -1469,7 +1469,7 @@
   `COMMAND` varchar(16) NOT NULL DEFAULT '',
   `TIME` bigint NOT NULL DEFAULT '0',
   `STATE` varchar(64) DEFAULT NULL,
-  `INFO` text
+  `INFO` varchar(16383) DEFAULT NULL
 ) ENGINE=MyISAM
 drop table t1;
 

=== modified file 'tests/r/information_schema.result'
--- tests/r/information_schema.result	2009-11-26 02:37:40 +0000
+++ tests/r/information_schema.result	2009-11-29 06:12:52 +0000
@@ -74,7 +74,7 @@
 select TABLE_ROWS from information_schema.tables where 
 table_schema="information_schema" and table_name="COLUMNS";
 TABLE_ROWS
-NULL
+0
 select table_type from information_schema.tables
 where table_schema="mysql" and table_name="user";
 table_type
@@ -169,9 +169,10 @@
 ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your Drizzle server version for the right syntax to use near '' at line 1
 drop database information_schema;
 ERROR 42000: Access denied for user ''@'' to database 'information_schema'
-drop table information_schema.tables;
+use information_schema;
+drop table tables;
 ERROR 42000: Access denied for user ''@'' to database 'information_schema'
-alter table information_schema.tables;
+alter table tables;
 ERROR 42000: Access denied for user ''@'' to database 'information_schema'
 use information_schema;
 create temporary table schemata(f1 char(10));
@@ -211,7 +212,7 @@
 table_schema='information_schema' and
 (column_type = 'varchar(7)' or column_type = 'varchar(20)'
  or column_type = 'varchar(27)')
-group by column_type order by num;
+group by column_type order by column_type, num;
 column_type	group_concat(table_schema, '.', table_name)	num
 varchar(20)	information_schema.MODULES	1
 varchar(27)	information_schema.COLUMNS	1

=== modified file 'tests/r/show_check.result'
--- tests/r/show_check.result	2009-11-26 02:37:40 +0000
+++ tests/r/show_check.result	2009-11-28 22:02:19 +0000
@@ -26,19 +26,19 @@
 test.t1	check	status	OK
 show index from t1;
 Catalog	Database	Table	Table_alias	Column	Column_alias	Type	Length	Max length	Is_null	Flags	Decimals	Charsetnr
-def			STATISTICS	TABLE_NAME	Table	8	256	2	N	1	0	45
-def			STATISTICS	NON_UNIQUE	Non_unique	5	1	1	N	32769	0	63
-def			STATISTICS	INDEX_NAME	Key_name	8	256	7	N	1	0	45
-def			STATISTICS	SEQ_IN_INDEX	Seq_in_index	5	2	1	N	32769	0	63
-def			STATISTICS	COLUMN_NAME	Column_name	8	256	1	N	1	0	45
-def			STATISTICS	COLLATION	Collation	8	4	1	Y	0	0	45
-def			STATISTICS	CARDINALITY	Cardinality	5	21	1	Y	32768	0	63
-def			STATISTICS	SUB_PART	Sub_part	5	3	0	Y	32768	0	63
-def			STATISTICS	PACKED	Packed	8	40	0	Y	0	0	45
-def			STATISTICS	NULLABLE	Null	8	12	0	N	1	0	45
-def			STATISTICS	INDEX_TYPE	Index_type	8	64	5	N	1	0	45
-def			STATISTICS	COMMENT	Comment	8	64	0	Y	0	0	45
-def			STATISTICS	INDEX_COMMENT	Index_Comment	8	4096	0	N	1	0	45
+def	information_schema	statistics	STATISTICS	TABLE_NAME	Table	8	256	2	N	1	0	45
+def	information_schema	statistics	STATISTICS	NON_UNIQUE	Non_unique	5	20	1	N	32769	0	63
+def	information_schema	statistics	STATISTICS	INDEX_NAME	Key_name	8	256	7	N	1	0	45
+def	information_schema	statistics	STATISTICS	SEQ_IN_INDEX	Seq_in_index	5	20	1	N	32769	0	63
+def	information_schema	statistics	STATISTICS	COLUMN_NAME	Column_name	8	256	1	N	1	0	45
+def	information_schema	statistics	STATISTICS	COLLATION	Collation	8	4	1	Y	0	0	45
+def	information_schema	statistics	STATISTICS	CARDINALITY	Cardinality	5	20	1	Y	32768	0	63
+def	information_schema	statistics	STATISTICS	SUB_PART	Sub_part	5	20	0	Y	32768	0	63
+def	information_schema	statistics	STATISTICS	PACKED	Packed	8	40	0	Y	0	0	45
+def	information_schema	statistics	STATISTICS	NULLABLE	Null	8	12	0	N	1	0	45
+def	information_schema	statistics	STATISTICS	INDEX_TYPE	Index_type	8	64	5	N	1	0	45
+def	information_schema	statistics	STATISTICS	COMMENT	Comment	8	64	0	Y	0	0	45
+def	information_schema	statistics	STATISTICS	INDEX_COMMENT	Index_Comment	8	4096	0	N	1	0	45
 Table	Non_unique	Key_name	Seq_in_index	Column_name	Collation	Cardinality	Sub_part	Packed	Null	Index_type	Comment	Index_Comment
 t1	0	PRIMARY	1	a	A	5	NULL	NULL		BTREE		
 t1	1	b	1	b	A	5	NULL	NULL		BTREE		
@@ -56,52 +56,52 @@
 -- after Bug#29394 is implemented.
 show variables like "server_id%";
 Catalog	Database	Table	Table_alias	Column	Column_alias	Type	Length	Max length	Is_null	Flags	Decimals	Charsetnr
-def			VARIABLES	VARIABLE_NAME	Variable_name	8	256	9	N	1	0	45
-def			VARIABLES	VARIABLE_VALUE	Value	8	65200	1	Y	0	0	45
+def	information_schema	variables	VARIABLES	VARIABLE_NAME	Variable_name	8	256	9	N	1	0	45
+def	information_schema	variables	VARIABLES	VARIABLE_VALUE	Value	8	65200	1	Y	0	0	45
 Variable_name	Value
 server_id	1
 show variables like "SERVER_id%";
 Catalog	Database	Table	Table_alias	Column	Column_alias	Type	Length	Max length	Is_null	Flags	Decimals	Charsetnr
-def			VARIABLES	VARIABLE_NAME	Variable_name	8	256	9	N	1	0	45
-def			VARIABLES	VARIABLE_VALUE	Value	8	65200	1	Y	0	0	45
+def	information_schema	variables	VARIABLES	VARIABLE_NAME	Variable_name	8	256	9	N	1	0	45
+def	information_schema	variables	VARIABLES	VARIABLE_VALUE	Value	8	65200	1	Y	0	0	45
 Variable_name	Value
 server_id	1
 show variables like "this_doesn't_exists%";
 Catalog	Database	Table	Table_alias	Column	Column_alias	Type	Length	Max length	Is_null	Flags	Decimals	Charsetnr
-def			VARIABLES	VARIABLE_NAME	Variable_name	8	256	0	N	1	0	45
-def			VARIABLES	VARIABLE_VALUE	Value	8	65200	0	Y	0	0	45
+def	information_schema	variables	VARIABLES	VARIABLE_NAME	Variable_name	8	256	0	N	1	0	45
+def	information_schema	variables	VARIABLES	VARIABLE_VALUE	Value	8	65200	0	Y	0	0	45
 Variable_name	Value
 show table status from test like "this_doesn't_exists%";
 Catalog	Database	Table	Table_alias	Column	Column_alias	Type	Length	Max length	Is_null	Flags	Decimals	Charsetnr
-def			TABLES	TABLE_NAME	Name	8	256	0	N	1	0	45
-def			TABLES	ENGINE	Engine	8	256	0	Y	0	0	45
-def			TABLES	VERSION	Version	5	21	0	Y	32768	0	63
-def			TABLES	ROW_FORMAT	Row_format	8	40	0	Y	0	0	45
-def			TABLES	TABLE_ROWS	Rows	5	21	0	Y	32768	0	63
-def			TABLES	AVG_ROW_LENGTH	Avg_row_length	5	21	0	Y	32768	0	63
-def			TABLES	DATA_LENGTH	Data_length	5	21	0	Y	32768	0	63
-def			TABLES	MAX_DATA_LENGTH	Max_data_length	5	21	0	Y	32768	0	63
-def			TABLES	INDEX_LENGTH	Index_length	5	21	0	Y	32768	0	63
-def			TABLES	DATA_FREE	Data_free	5	21	0	Y	32768	0	63
-def			TABLES	AUTO_INCREMENT	Auto_increment	5	21	0	Y	32768	0	63
-def			TABLES	CREATE_TIME	Create_time	6	19	0	Y	128	0	63
-def			TABLES	UPDATE_TIME	Update_time	6	19	0	Y	128	0	63
-def			TABLES	CHECK_TIME	Check_time	6	19	0	Y	128	0	63
-def			TABLES	TABLE_COLLATION	Collation	8	256	0	Y	0	0	45
-def			TABLES	CHECKSUM	Checksum	5	21	0	Y	32768	0	63
-def			TABLES	CREATE_OPTIONS	Create_options	8	1020	0	Y	0	0	45
-def			TABLES	TABLE_COMMENT	Comment	8	8192	0	N	1	0	45
+def	information_schema	tables	TABLES	TABLE_NAME	Name	8	256	0	N	1	0	45
+def	information_schema	tables	TABLES	ENGINE	Engine	8	256	0	Y	0	0	45
+def	information_schema	tables	TABLES	VERSION	Version	5	20	0	Y	32768	0	63
+def	information_schema	tables	TABLES	ROW_FORMAT	Row_format	8	40	0	Y	0	0	45
+def	information_schema	tables	TABLES	TABLE_ROWS	Rows	5	20	0	Y	32768	0	63
+def	information_schema	tables	TABLES	AVG_ROW_LENGTH	Avg_row_length	5	20	0	Y	32768	0	63
+def	information_schema	tables	TABLES	DATA_LENGTH	Data_length	5	20	0	Y	32768	0	63
+def	information_schema	tables	TABLES	MAX_DATA_LENGTH	Max_data_length	5	20	0	Y	32768	0	63
+def	information_schema	tables	TABLES	INDEX_LENGTH	Index_length	5	20	0	Y	32768	0	63
+def	information_schema	tables	TABLES	DATA_FREE	Data_free	5	20	0	Y	32768	0	63
+def	information_schema	tables	TABLES	AUTO_INCREMENT	Auto_increment	5	20	0	Y	32768	0	63
+def	information_schema	tables	TABLES	CREATE_TIME	Create_time	6	19	0	Y	128	0	63
+def	information_schema	tables	TABLES	UPDATE_TIME	Update_time	6	19	0	Y	128	0	63
+def	information_schema	tables	TABLES	CHECK_TIME	Check_time	6	19	0	Y	128	0	63
+def	information_schema	tables	TABLES	TABLE_COLLATION	Collation	8	256	0	Y	0	0	45
+def	information_schema	tables	TABLES	CHECKSUM	Checksum	5	20	0	Y	32768	0	63
+def	information_schema	tables	TABLES	CREATE_OPTIONS	Create_options	8	1020	0	Y	0	0	45
+def	information_schema	tables	TABLES	TABLE_COMMENT	Comment	8	8192	0	N	1	0	45
 Name	Engine	Version	Row_format	Rows	Avg_row_length	Data_length	Max_data_length	Index_length	Data_free	Auto_increment	Create_time	Update_time	Check_time	Collation	Checksum	Create_options	Comment
 show databases;
 Catalog	Database	Table	Table_alias	Column	Column_alias	Type	Length	Max length	Is_null	Flags	Decimals	Charsetnr
-def			SCHEMATA	SCHEMA_NAME	Database	8	256	18	N	1	0	45
+def	information_schema	schemata	SCHEMATA	SCHEMA_NAME	Database	8	256	18	N	1	0	45
 Database
 information_schema
 mysql
 test
 show databases like "test%";
 Catalog	Database	Table	Table_alias	Column	Column_alias	Type	Length	Max length	Is_null	Flags	Decimals	Charsetnr
-def			SCHEMATA	SCHEMA_NAME	Database (test%)	8	256	4	N	1	0	45
+def	information_schema	schemata	SCHEMATA	SCHEMA_NAME	Database (test%)	8	256	4	N	1	0	45
 Database (test%)
 test
 create table t1 (f1 int not null, f2 int not null, f3 int not null, f4 int not null, primary key(f1,f2,f3,f4));
@@ -183,11 +183,13 @@
 flush tables;
 show open tables;
 Database	Table	In_use	Name_locked
+information_schema	open_tables	0	0
 create table t1(n int);
 insert into t1 values (1);
 show open tables;
 Database	Table	In_use	Name_locked
 test	t1	0	0
+information_schema	open_tables	0	0
 drop table t1;
 create temporary table t1 (a int not null, b VARCHAR(10), INDEX (b) ) COMMENT="test" ENGINE=MYISAM ROW_FORMAT=fixed;
 show create table t1;
@@ -449,19 +451,19 @@
 );
 show index from t1;
 Catalog	Database	Table	Table_alias	Column	Column_alias	Type	Length	Max length	Is_null	Flags	Decimals	Charsetnr
-def			STATISTICS	TABLE_NAME	Table	8	256	2	N	1	0	45
-def			STATISTICS	NON_UNIQUE	Non_unique	5	1	1	N	32769	0	63
-def			STATISTICS	INDEX_NAME	Key_name	8	256	7	N	1	0	45
-def			STATISTICS	SEQ_IN_INDEX	Seq_in_index	5	2	1	N	32769	0	63
-def			STATISTICS	COLUMN_NAME	Column_name	8	256	6	N	1	0	45
-def			STATISTICS	COLLATION	Collation	8	4	1	Y	0	0	45
-def			STATISTICS	CARDINALITY	Cardinality	5	21	1	Y	32768	0	63
-def			STATISTICS	SUB_PART	Sub_part	5	3	3	Y	32768	0	63
-def			STATISTICS	PACKED	Packed	8	40	0	Y	0	0	45
-def			STATISTICS	NULLABLE	Null	8	12	0	N	1	0	45
-def			STATISTICS	INDEX_TYPE	Index_type	8	64	5	N	1	0	45
-def			STATISTICS	COMMENT	Comment	8	64	0	Y	0	0	45
-def			STATISTICS	INDEX_COMMENT	Index_Comment	8	4096	0	N	1	0	45
+def	information_schema	statistics	STATISTICS	TABLE_NAME	Table	8	256	2	N	1	0	45
+def	information_schema	statistics	STATISTICS	NON_UNIQUE	Non_unique	5	20	1	N	32769	0	63
+def	information_schema	statistics	STATISTICS	INDEX_NAME	Key_name	8	256	7	N	1	0	45
+def	information_schema	statistics	STATISTICS	SEQ_IN_INDEX	Seq_in_index	5	20	1	N	32769	0	63
+def	information_schema	statistics	STATISTICS	COLUMN_NAME	Column_name	8	256	6	N	1	0	45
+def	information_schema	statistics	STATISTICS	COLLATION	Collation	8	4	1	Y	0	0	45
+def	information_schema	statistics	STATISTICS	CARDINALITY	Cardinality	5	20	1	Y	32768	0	63
+def	information_schema	statistics	STATISTICS	SUB_PART	Sub_part	5	20	3	Y	32768	0	63
+def	information_schema	statistics	STATISTICS	PACKED	Packed	8	40	0	Y	0	0	45
+def	information_schema	statistics	STATISTICS	NULLABLE	Null	8	12	0	N	1	0	45
+def	information_schema	statistics	STATISTICS	INDEX_TYPE	Index_type	8	64	5	N	1	0	45
+def	information_schema	statistics	STATISTICS	COMMENT	Comment	8	64	0	Y	0	0	45
+def	information_schema	statistics	STATISTICS	INDEX_COMMENT	Index_Comment	8	4096	0	N	1	0	45
 Table	Non_unique	Key_name	Seq_in_index	Column_name	Collation	Cardinality	Sub_part	Packed	Null	Index_type	Comment	Index_Comment
 t1	0	PRIMARY	1	field1	A	0	180	NULL		BTREE		
 drop table t1;

=== modified file 'tests/r/variables.result'
--- tests/r/variables.result	2009-11-10 22:59:28 +0000
+++ tests/r/variables.result	2009-11-26 05:42:49 +0000
@@ -185,13 +185,13 @@
 show global variables like 'drizzle_protocol_buffer_%';
 Variable_name	Value
 drizzle_protocol_buffer_length	1024
-select * from information_schema.global_variables where variable_name like 'drizzle_protocol_buffer_%' order by 1;
+select * from information_schema.global_variables where variable_name like 'drizzle_protocol_buffer_%';
 VARIABLE_NAME	VARIABLE_VALUE
 DRIZZLE_PROTOCOL_BUFFER_LENGTH	1024
 show global variables like 'drizzle_protocol_buffer_%';
 Variable_name	Value
 drizzle_protocol_buffer_length	1024
-select * from information_schema.global_variables where variable_name like 'drizzle_protocol_buffer_%' order by 1;
+select * from information_schema.global_variables where variable_name like 'drizzle_protocol_buffer_%';
 VARIABLE_NAME	VARIABLE_VALUE
 DRIZZLE_PROTOCOL_BUFFER_LENGTH	1024
 set global drizzle_protocol_buffer_length=1;
@@ -214,7 +214,7 @@
 range_alloc_block_size	
 transaction_alloc_block_size	8192
 transaction_prealloc_size	4096
-select * from information_schema.session_variables where variable_name like '%alloc%' order by 1;
+select * from information_schema.session_variables where variable_name like '%alloc%';
 VARIABLE_NAME	VARIABLE_VALUE
 INNODB_USE_SYS_MALLOC	ON
 QUERY_ALLOC_BLOCK_SIZE	8192
@@ -238,7 +238,7 @@
 range_alloc_block_size	
 transaction_alloc_block_size	19456
 transaction_prealloc_size	20480
-select * from information_schema.session_variables where variable_name like '%alloc%' order by 1;
+select * from information_schema.session_variables where variable_name like '%alloc%';
 VARIABLE_NAME	VARIABLE_VALUE
 INNODB_USE_SYS_MALLOC	ON
 QUERY_ALLOC_BLOCK_SIZE	17408
@@ -257,7 +257,7 @@
 range_alloc_block_size	
 transaction_alloc_block_size	8192
 transaction_prealloc_size	4096
-select * from information_schema.session_variables where variable_name like '%alloc%' order by 1;
+select * from information_schema.session_variables where variable_name like '%alloc%';
 VARIABLE_NAME	VARIABLE_VALUE
 INNODB_USE_SYS_MALLOC	ON
 QUERY_ALLOC_BLOCK_SIZE	8192

=== modified file 'tests/t/information_schema.test'
--- tests/t/information_schema.test	2009-11-12 00:06:13 +0000
+++ tests/t/information_schema.test	2009-11-29 06:12:52 +0000
@@ -170,10 +170,11 @@
 alter database information_schema;
 --error ER_DBACCESS_DENIED_ERROR
 drop database information_schema;
---error 1044
-drop table information_schema.tables;
---error 1044
-alter table information_schema.tables;
+use information_schema;
+--error 1044
+drop table tables;
+--error 1044
+alter table tables;
 #
 # Bug #9683 INFORMATION_SCH: Creation of temporary table allowed in Information_schema DB
 #
@@ -219,7 +220,7 @@
 table_schema='information_schema' and
 (column_type = 'varchar(7)' or column_type = 'varchar(20)'
  or column_type = 'varchar(27)')
-group by column_type order by num;
+group by column_type order by column_type, num;
 
 #
 # Bug#19236 bad COLUMNS.CHARACTER_MAXIMUM_LENGHT and CHARACTER_OCTET_LENGTH

=== modified file 'tests/t/variables.test'
--- tests/t/variables.test	2009-11-10 22:59:28 +0000
+++ tests/t/variables.test	2009-11-26 05:42:49 +0000
@@ -115,9 +115,9 @@
 
 set global drizzle_protocol_buffer_length=1024;
 show global variables like 'drizzle_protocol_buffer_%';
-select * from information_schema.global_variables where variable_name like 'drizzle_protocol_buffer_%' order by 1;
+select * from information_schema.global_variables where variable_name like 'drizzle_protocol_buffer_%';
 show global variables like 'drizzle_protocol_buffer_%';
-select * from information_schema.global_variables where variable_name like 'drizzle_protocol_buffer_%' order by 1;
+select * from information_schema.global_variables where variable_name like 'drizzle_protocol_buffer_%';
 set global drizzle_protocol_buffer_length=1;
 show variables like 'drizzle_protocol_buffer_length';
 #warning 1292
@@ -125,7 +125,7 @@
 show variables like 'drizzle_protocol_buffer_length';
 
 show variables like '%alloc%';
-select * from information_schema.session_variables where variable_name like '%alloc%' order by 1;
+select * from information_schema.session_variables where variable_name like '%alloc%';
 set @@range_alloc_block_size=1024*16;
 set @@query_alloc_block_size=1024*17+2;
 set @@query_prealloc_size=1024*18;
@@ -133,12 +133,12 @@
 set @@transaction_prealloc_size=1024*21-1;
 select @@query_alloc_block_size;
 show variables like '%alloc%';
-select * from information_schema.session_variables where variable_name like '%alloc%' order by 1;
+select * from information_schema.session_variables where variable_name like '%alloc%';
 set @@range_alloc_block_size=default;
 set @@query_alloc_block_size=default, @@query_prealloc_size=default;
 set transaction_alloc_block_size=default, @@transaction_prealloc_size=default;
 show variables like '%alloc%';
-select * from information_schema.session_variables where variable_name like '%alloc%' order by 1;
+select * from information_schema.session_variables where variable_name like '%alloc%';
 
 #
 # Bug #10904 Illegal mix of collations between

